<?php
/**
 * Compare images of taxa
 *
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-02-24 21:24:33
 * @license Noncommercial-Share Alike 3.0 Unported
 * @todo minor issue: document further detailed
 * @category determination key
 * @package chirokey_adults
 * @subpackage key
 */
/**
 * Extract current server path relatively
 *
 *
 * {1} means one level up as it replaces
 * any string exept '/' multiple times ('+') ended by '/'. In regular expression
 * language:
 * <code>([^/]+/)</code>
 * The (..) can be used to refere the found string by \\1, \\2 and so on.
 * @global string $currentServerPath
 */
 $currentServerPath = preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);
header('content-type: text/html; charset=utf-8');
include($currentServerPath.'structure/functions.php');
include($currentServerPath.'structure/classes/sql.php');//first get classes
include($currentServerPath.'structure/config.php');/* login */
include($currentServerPath.'structure/classes/tools.php');
/* title definitions */
  $title      = 'compare specimen';
  $link       = '../structure/css/basic.css';
  $javascript = 'src="../structure/js/functions.js"';
  include($currentServerPath.'structure/pages.php');
  $content    = $page['head'];/* head of page */
// print_r($_GET);

$objMysql = new db_mysql;//class db_mysql
  // $objMysql->showsql=TRUE;
$objHtml = new html;//class html


// echo "<pre>";
//  print_r($_GET);
// echo "</pre>";
if($_GET['show']=='species'){
  /* @annotation: highlight references */
  // $content.= "<pre>".print_r($MysqlSelect['ReferencesReplace'],true)."</pre>";
  if($referenceList=$objMysql->queryObjectArray($MysqlSelect['ReferencesReplace'])){
    foreach($referenceList as $ref){
      $replacetext[$ref->id]=htmlentities($ref->authors_short,ENT_NOQUOTES,'UTF-8');
      //$replacetext[$ref->id]="refid".$ref->id;
    }
  }
  #if(
  $result=$objMysql->queryObjectArray($MysqlSelect['SpeciesToCompare']);#){
   if(!empty($_GET['similar_id'])){
      $similar=split(" ",$_GET['similar_id']);
      foreach($similar as $_GET['valid_id']){
        include($currentServerPath.'structure/config.php');/* login */
        if($resultsimilar=$objMysql->queryObjectArray($MysqlSelect['SpeciesToCompareOthers'])){
          if(isset($resultsimilar_last) && is_array($resultsimilar_last)){
            $resultsimilar=array_merge($resultsimilar_last, $resultsimilar);
            #print_r("else - nein, ");
            $resultsimilar_last=$resultsimilar;
          }
          else{
            $resultsimilar_last=$resultsimilar;
            #print_r(isset($resultsimilar_last));
            #print_r("else - ja, ");
          }
        }

      }// end foreach similar
    }
  #}
     $resultsimilar=$resultsimilar_last;
//      print_pre($resultsimilar);
      if(
        #isset($resultsimilar) &&
        #isset($result) &&
        is_array($resultsimilar) &&
        is_array($result)
      ){
        $result = array_merge($result, $resultsimilar);
        $array_info="resultsimilar result";
      }
      elseif(
        !is_array($resultsimilar) &&
        is_array($result)){
          $result = $result;
        $array_info="!resultsimilar result";
      }
      elseif(
        is_array($resultsimilar) &&
        !is_array($result)){
          $result = $resultsimilar;
        $array_info="resultsimilar !result";
      }
        #$result = isset($resultsimilar) && is_array($resultsimilar) && is_array($result) && isset($result) ? array_merge($result, $resultsimilar) : $result;
//         $content.=$array_info;
    if(is_array($result)){
      foreach($result as $spec){
        $license       = $spec->license;
        $subgenus      = $spec->subgenus ? "(".$spec->subgenus.") " : "";
        $specimen      = $spec->genus." ".$subgenus.$spec->species;
        $descriptor    = replaceHTMLcode($spec->descriptor);
        $descriptor_id = $spec->descriptor_id;
        $authors      = replaceHTMLcode($spec->authors_short);
        $authors_id   = $spec->authors_id;
        //emphase($originaltext='',$replacetext='',$contenttype='')
        $annotation = $objHtml->emphase($spec->annote,$replacetext,"references",false);
          $annotation=str_replace("'","\'",$annotation);
        $systematicNotes = $objHtml->emphase($spec->systematicNotes,$replacetext,"references",false);
          $systematicNotes=str_replace("'","\'",$systematicNotes);
        $file         = $spec->filename;
        $img_width    = $spec->img_width_default;
        $morph_long   = $spec->morph_long;
        $reference    = replaceHTMLcode($spec->authors_short);

        $descriptor_overlib = $descriptor_id==0 ? " <span class=\'attention\'>".$descriptor."</span>" : "<a class=\'reference\' title=\'Click for reference.\'  target=\'chirokey\' href=\'http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir'].$config['ServerKeyDir']."chirokey.php?show=references#refid".$descriptor_id."\'>".htmlentities($descriptor,ENT_QUOTES,'UTF-8')."</a>" ;
        $authors = $authors ? "<a class=\'reference\' target=\'chirokey\' href=\'chirokey.php?show=references#refid".$authors_id."\'>".htmlentities($authors,ENT_QUOTES,'UTF-8')."</a>" : "<span class=\'error\'>no author given</span>";
        $annotation = $annotation ? "<hr class=\'thin\'><img title=\'Note to this image\'  align=\'middle\' src=\'../structure/img/b_annote.png\' width=16 height=16 >&nbsp;".$annotation : "";
        $systematicNotes = $systematicNotes ? "<hr class=\'thin\'><img align=\'middle\'  title=\'systematic note\' src=\'../structure/img/b_systree_note.png\' width=16 height=16 >&nbsp;".$systematicNotes : "";
        $onmouseover="onmouseover=\"return overlib('<em>".$specimen."</em> ".$descriptor_overlib." ".lb2string($annotation).lb2string($systematicNotes)."<hr class=\'thin\'><img align=\'middle\' title=\'reference\' src=\'../structure/img/book.png\' width=16 height=16 >&nbsp;".$authors;
        $onmouseover.="<hr class=\'thin\'>Search:&nbsp;";
          $arrSearch = array("FaunaEuropea", "Species2000", "ITIS", "GoogleImgages", "AskImages", "GoogleScholar", "Scirius", "ScienceDirect", "Jstor");
          foreach ($arrSearch as $value)
            $onmouseover.= $objHtml->searchStringOnline($spec->genus."+".$spec->species, $value, true);
        $onmouseover.="<hr class=\'thin\'>".$license."', CAPTION, '".$morph_long."', CENTER, STICKY, MOUSEOFF);\" onmouseout=\"return nd();\"";


        $content.= $last_specimen==$specimen ? "" : "\n<h2 style='text-align:center;'><em>".$specimen."</em> ".$descriptor."</h2>\n";
        $content.="\n<a  class='nothing' onClick=\"window.open('image.php?popup=1&file=".$file."&specimen=".$specimen."&descriptor=".$descriptor."&morph_long=".$morph_long."&image_id=".$spec->image_id."', '','toolbar=no,status=yes,menubar=no,scrollbars=yes,width=900,height=550')\"  ".$onmouseover.">\n";
        $content.="\n  <img style='border:1px dotted;padding:5px;'  src='../../".$config['dirSpec'].$file."' width='".$img_width."' alt='".$specimen."'>";
        $content.="\n</a>\n";
        $last_specimen=$specimen;
    }
  }
}
// }
//   print_r($resultsimilar);
  echo $content.$page['foot'];
  exit;


?>