<?
/**
 * Calculate a Fourier outline
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-02-24 21:24:33
 * @license Noncommercial-Share Alike 3.0 Unported
 * @category program tools
 * @package chirokey_adults
 * @subpackage math
 */
/**
  * Config part:
  */
// reduce error_reporting: without NOTES
  error_reporting(E_ERROR | E_WARNING | E_PARSE);
  $allowedImWidthHeight = 1000;// px
  $allowedImSize        = 500;// kB
  $debug                = false; // show detailed information in calculations (output is quite large)
  // path for including outline library 'inc.outline.php':
  /* include $_SERVER['DOCUMENT_ROOT']."/path/to/the/classfile/inc.outline.php"; */
header('content-type: text/html; charset=utf-8');
header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
header ("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT"); // always modified
header ("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header ("Pragma: no-cache"); // HTTP/1.0
/**
 * Read outline classes
 *
 *
 * Extract current server path relatively: {1} means one level up as it replaces
 * any string exept '/' multiple times ('+') ended by '/'. In regular expression
 * language:
 * <code>([^/]+/)</code>
 * The (..) can be used to refere the found string by \\1, \\2 and so on.
 * @global string $currentServerPath
 */
 $currentServerPath = preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);
  include($currentServerPath.'structure/classes/inc.outline.php');

/**
  * check variables
  */
  $textadd=isset($_POST['fileSended'])? $_FILES['loadedImage']['name']:"";
  $textadd=isset($_POST['chainSubmitted'])? "for given chaincode":$textadd;
  $textadd=empty($textadd)? "for a given file/chaincode":$textadd;
  $stop=false;

/* check image properties*/
  #echo $stop?"stop is true<br>":"stop is false<br>";
  if(isset($_POST['fileSended'])){
    /* wrong file type */
    if(!preg_match("/image\/(png|gif|jpeg|bmp)/",$_FILES['loadedImage']['type'])){
      $cause= "File '".$_FILES['loadedImage']['name']."' (".$_FILES['loadedImage']['type'].") is no image file. ";
      $stop=true;
    }
    #echo $stop?"stop is true<br>":"stop is false<br>";
    /* file size to much */
    $stop=($_FILES['loadedImage']['size'] > 1024* $allowedImSize) ? true:$stop;
    $cause.=($stop==true && $_FILES['loadedImage']['size'] > 1024* $allowedImSize)? "File size is more than allowed size of ".$allowedImSize."kB (".round($_FILES['loadedImage']['size']/1024,2)." kB). ":"";

    /* file width or height to much */
    $size = GetImageSize (
      $_FILES['loadedImage']["tmp_name"]
      #,&$info # erweiterte Informationen aus der Datei
      );
    $stop=($size[0]> $allowedImWidthHeight || $size[1] > $allowedImWidthHeight)? true:$stop;
    $cause.=$stop==true && !empty($size)? "File width or height is > 600px (".$size[3]."). ":"";
  } else $stop=false;
  #echo $stop?"stop is true<br>":"stop is false<br>";
  $textadd.=$stop?" Error":"";
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
"http://www.w3.org/TR/html4/strict.dtd">

<head>
  <title>Outline with Fourier Analysis (<?=$textadd;?>)</title>
<!--   <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"> -->
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <meta http-equiv="expires" content="0">
<!--   <link rel="stylesheet" href="../structure/css/basic.css" media="screen" type="text/css"> -->
  <style type="text/css">

ol.preformatted{
  list-style:decimal outside;
/*   border:2px solid gray; */
  background-color: #EEEED1;
  padding-left:3em;
/*   border-top:1px solid red; */
  text-align:left;
  margin:0px;
}
ol.preformatted li {
  font-family:  monospace;
    white-space : pre;
  background-color: white;
}
div.preformattedLi{
  font-family:  monospace;
  white-space:pre;
/*   background-color: white; */
/*   padding-left:3em; */
  background-color: #EEEED1;
  border-bottom:1px solid red;
  margin-top:1em;
  margin-bottom:0px;
}
div.preformatted{
  font-family: "Courier New", Courier, monospace;
  white-space : pre;
/*   background-color: white; */
/*   padding-left:3em; */
  background-color: #EEEED1;
/*   border-bottom:1px solid red; */
/*   margin-top:1em; */
  margin-bottom:0px;
}

a {
    color : #330080;
     text-decoration:none;
  }
/* see also .species{} */
a.button {
    font-size: medium;
    border:0px;
    padding:3px;
    background-color : #FFDEAD;
    border-color : transparent;
  }

a:hover {
    background:#D7DDFF;
    color:#330080;
    text-shadow:#FFFF99 0px 0px 1px;
  }

td {
  vertical-align:top;
}
.digits4 {
  width:4em;
  text-align:right;
}
li{
  margin:0px;
  padding:0px;
}
p, ul {text-align:justify;}
body {
    background-color:#FFFFFF;
    color:black;
    font-size:10pt;
    font-family:Verdana,Monaco,Helvetica,Swiss,Geneva,Arial,sans-serif;
    line-height:13pt;
  }

</style>
</head>
<body>
  <h2 style="text-align:center;" id="top">Outline with Fourier Analysis (<?=$textadd;?>)</h2>

<?php
/* Es wird ein Array aus 4 Elementen zurück gegeben. Im Array-Index 0 steht die
Breite. Index 1 enthält die Höhe, 2 ein Flag je nach Grafik-Typ (1 = GIF, 2 =
JPG, 3 = PNG, SWF = 4) und Index 3 die richtige Zeichenkette im Format
"height=xxx width=xxx" zur Verwendung im IMG-Tag von HTML.
Beispiel 1. Grafik-Ausmaße ermitteln per GetImageSize:
*/

/*
Array
(
    [0] => 454
    [1] => 193
    [2] => 2
    [3] => width="454" height="193"
    [bits] => 8
    [channels] => 1
    [mime] => image/jpeg
)
 */
if($stop==true){
  echo "<p style='color:red;text-align:center;font-size : x-large;'>".$cause." Stop here.</p>";
} else {
  echo "<p style='text-align:center;font-size : large;'>Output is given below.</p>";
}

?>
<script type="text/javascript">
 function reloadImg(nameImg){
  document[nameImg].src = document[nameImg].src + '?' + (new Date()).getTime();
 }
</script>


<fieldset>
<legend>Information</legend>
<p>Fourier Analysis is done after: <br>
Kuhl, Frank P. and Giardina, Charles R., 1982: <em>Elliptic Fourier features of a closed contour</em>, Computer Graphics and Image Processing, vol.&nbsp;18, no.&nbsp;3, pp.&nbsp;236-258. <br>(Abstract: A direct procedure for obtaining the Fourier coefficients of a chain-encoded contour is presented. Advantages of the procedure are that it does not require integration or the use of fast Fourier transform techniques, and that bounds on the accuracy of the image contour reconstruction are easy to specify. Elliptic properties of the Fourier coefficients are shown and used for a convenient and intuitively pleasing procedure of normalizing a Fourier contour representation. Extension of the contour representation to arbitrary objects at arbitrary aspect angle is discussed. The procedures have direct application to a variety of pattern recognition problems that involve analysis of well-defined image contours.)</p>
<p>
Using the  statistical program <a class="external" target="_blank" href="http://www.r-project.org">R</a> together with <a href="http://www.maths.nott.ac.uk/~ild/shapes" class="external" target="_blank">shape-package</a> and userfunctions <a href="../doc/functions_NEF_shape.html">linked here</a>, one can proceed to analyse shapes. The program here will only extract n-Fourier harmonics supplied by the user (default 200).</p>
<p>Another good tutorial for morphometric analysis in R (also with given source codes) is:
<ul>
<li> Claude, Julien (2008). <em>Morphometrics with R</em>. English. Ed. by Robert Gentleman, Kurt Hornik, and Giovanni Parmigiani. Use R! Springer, p. 316. ISBN: 978-0-387-77789-4.</li>
</ul>
</p>
</fieldset>

<table>
<tr>
  <td>
    <fieldset><legend>Outline to (normalized) elliptic Fourier transformation</legend>
    <form action="outline.php#imageOriginal" method="post" name="sendfile" enctype="multipart/form-data">
      <table>
        <tr>
          <td>Select one file as b/w image:<br>
          <input name="loadedImage" type="file"><br>
          <span style="font-size : x-small;">(PNG is recommended; *.GIF, *.JPG, *.BMP)</span>
          </td>
        </tr>
        <tr>
          <td>Number of harmonics:<br><input name="nharmo" type="text"  value="<?= isset($_POST['nharmo'])? $_POST['nharmo'] : "200"; ?>" class="digits4" title="number of harmonics">
          </td>
        </tr>
        <tr>
          <td style="border-top:1px solid;text-align:right;">  <input type="submit" name='fileSended' value="Send file" onclick="if(document.forms['sendfile'].elements['loadedImage'].value==''){alert('Select a file to be analyzed!');return false;}else{return true;}">
          </td>
        </tr>
        <tr>
          <td>
          This PHP script recognizes only 1 outline as seen below by starting from the top left corner downward in y-direction. Untill the real outline is found there should be no single dark pixel within the top left image area. This will produce an error.<br><img src="../structure/img/outlinemethod.png">
          </td>
        </tr>
      </table>
    </form>
    </fieldset>
  </td>
  <td>
    <fieldset><legend>Chaincode to (normalized) elliptic Fourier transformation</legend>
    <form action="outline.php#imageReconstructed" method="post" name="sendchain" enctype="multipart/form-data">
      <table>
        <tr>
          <td>Insert chain code:
            <div class="preformatted" style="text-align:left;">
 Chaincode usu-
 ally without
 spaces:
  3   2   1
    \ | /
  4 - X - 0
    / | \
  5   6   7
            </div>

          </td>
          <td><textarea name="chain" style="width:30em;height:30em;" wrap="on"  ><?= isset($_POST['chain'])? $_POST['chain'] : ""; ?></textarea></td>
        </tr>
        <tr>
          <td style="border-bottom:1px solid;"></td>
          <td style="border-bottom:1px solid;">Number of harmonics:<br><input name="nharmo" type="text"  value="<?= isset($_POST['nharmo'])? $_POST['nharmo'] : "200"; ?>" class="digits4" title="number of harmonics"></td>
        </tr>
        <tr>
          <td ></td>
          <td style="text-align:right;">  <input name="chainSubmitted" type="submit" value="Send chain" onclick="if(document.forms['sendchain'].elements['chain'].value==''){alert('There is no chaincode given!');return false;}else{return true;}"></td>
        </tr>
      </table>

    <!--   <input name="loadedImage[]" type="file"><br> -->
    </form>
    </fieldset>
  </td>
</tr>
</table>
<?
/**
 * Print text as <samp><pre>...</pre></samp>
 * @param string $strContent content to print
 * @param boolean $doReturn return string or print directly
 */

  function print_pre($strContent, $doReturn=false){
    $content = "\n<pre class='info'>\n";
    $content.= print_r($strContent, true);
    $content.= "\n</pre>\n";
    if($doReturn)
      return $content;
    else
      print_r($content);
  }

/**
 * Scientific numbers
 * @param string $num number
 * @param int $d number of decimals
 */
  function sci($num, $d=-1) {
    $min=($num<0)?"-":"+";
    $num=abs($num);
    $e=floor(($num==0)?0 : ($num==1? 0:log10($num)));
    #$e = ($num==1 && $e==-1)? 0:$num;
    $num*=pow(10, -$e);
    $fmt=($d>=0)?".".$d:"";
    $e=($e>=0)?"+".sprintf("%02d",$e):"-".sprintf("%02d",-$e);
    //     return $num;
    //     return sprintf("%+.10f",$num);
    // echo "\"$min%".$fmt."fe%s\"".",".$num.",".$e;
    $number = sprintf("$min%".$fmt."fe%s",$num,$e);
    return $number;
  }
/**
 * For array_walk()
 *
 * Example.: <code>array_walk($array, 'calc_user', '-('.$const.')');</code>
 */
  function calc_user(&$item, $key, $calc){
    #echo "return $item$calc;<br>";
    $item = eval("return $item$calc;");
  }

  if($stop) exit;
  $test = new outline;
  $math = new mathuser;


if(isset($_FILES['loadedImage'])){

/*  if(!preg_match("/image\/(png|gif|jpeg)/",$_FILES['loadedImage']['type'])){
    echo "<p style='color:red;'> '".$_FILES['loadedImage']['name']."' (".$_FILES['loadedImage']['type'].") is no image file. Stop here.<p>";
    exit;
  }*/
    $size = GetImageSize (
      $_FILES['loadedImage']["tmp_name"]
      #,&$info # erweiterte Informationen aus der Datei
      );

  $im=$test->imagecreatefromfile($_FILES['loadedImage']['tmp_name'], true);

//   print_pre($size);
  $chain =  $test->imageDrawOutline(
    $im,
    $size,
    $debug); // switch above at config
//     print_pre($chain);
//     exit;
  $output = $math->chainToXY($chain);
  $x = $output['X']; $y = $output['Y'];
  #$imparams = $test->imageOutline($x, $y);
  #print_pre($imparams);
  $printHarm =true;

}# end if loadedImage exist
if(isset($_POST['chain'])){
  if(empty($_POST['chain'])){
    echo "<p>Empty chain code given. Stopped here.</p></body>";
    exit;
  }
  $search = array(
    /* 1*/ "/\s*/",     // white spaces
    /* 2*/ "/[\r\n]/",  // line break tabs
    /* 3*/ "/([0-7])/", // add white space for explode()
    /* 4*/ "/\s+$/"     // remove last white space for explode()

    );
  $replace = array(
    /* 1*/ "",     // white spaces
    /* 2*/ "",     // line break tabs
    /* 3*/ "\\1 ", // add white space for explode()
    /* 4*/ ""      // remove last white space for explode()
  );
  $chain= preg_replace($search,$replace,$_POST['chain']);
  $chain =  explode(" ",$chain);
  $output = $math->chainToXY($chain);
  $printHarm =true;
}# end isset($_POST['chain'])

if($printHarm){
  $harmonics = $math->getharmonics(
      $chain=$chain,
      $_POST['nharmo'],
      $debug// switch above at config
    );
  /** print x y values */
  $n = count($harmonics['normalized']["a"]);
  $x = $math->harmonicsToXY($n,
    $a = $harmonics['notnormalized']["a"],
    $b = $harmonics['notnormalized']["b"],
    $t = $n);
  $y = $math->harmonicsToXY($n,
    $a = $harmonics['notnormalized']["c"],
    $b = $harmonics['notnormalized']["d"],
    $t = $n  );
  $xn = $math->harmonicsToXY($n,
    $a = $harmonics['normalized']["a"],
    $b = $harmonics['normalized']["b"],
    $t = $n);
  $yn = $math->harmonicsToXY($n,
    $a = $harmonics['normalized']["c"],
    $b = $harmonics['normalized']["d"],
    $t = $n  );

  $textadd=isset($_POST['fileSended'])? $_FILES['loadedImage']['name']:"given chaincode";

  $xim = $xn;
  $yim = $yn;
  $xshift = min($xim)<0? abs(min($xim)):0;
  $yshift = min($yim)<0? abs(min($yim)):0;
 array_walk($xim, 'calc_user', '+'.$xshift);
 array_walk($yim, 'calc_user', '+'.$yshift);
  $scale=empty($size) ? 200 : $size[0]/max($xim);
 array_walk($xim, 'calc_user', '*'.$scale);
 array_walk($yim, 'calc_user', '*'.$scale);
 if(isset($_POST['fileSended']) || !empty($chain)){
 echo "
<table>
 ";
  echo isset($_POST['fileSended'])? "<tr>\n  <td><a href='#top' id='imageOriginal'>^&nbsp;(up)&nbsp;</a><a href='#imageReconstructed'>v&nbsp;(down)</a></td>\n  <td style='text-align:center;' ><button onmousedown=\"reloadImg('imageOriginal');\" onkeydown=\"reloadImg('imageOriginal');\">Reload</button> original Image of<br> ".$_FILES['loadedImage']['name'].":<br>":"";
    isset($_POST['fileSended'])? $test->imageOutline($output['X'], $output['Y'], $dst="./temp/source.png", $textadd." id=\"imageOriginal\" name=\"imageOriginal\""):"";
  echo isset($_POST['fileSended'])? "\n</td>\n </tr>\n":"";
  echo "<tr>\n  <td><a href='#imageOriginal' id='imageReconstructed'>^&nbsp;(up)&nbsp;</a><a href='#chaincode'>v&nbsp;(down)</a></td>\n  <td style='text-align:center;'> <button onmousedown=\"reloadImg('imageReconstructed');\" onkeydown=\"reloadImg('imageReconstructed');\">Reload</button> reconstructed Image of<br> ".$_FILES['loadedImage']['name']." (n_harmo=".$_POST['nharmo']."):<br>";
    empty($chain)? "": $test->imageOutline($xim, $yim, $dst="./temp/outlined.png",$textadd." id=\"imageReconstructed\" name=\"imageReconstructed\"");
 echo "
  </td>
 </tr>
</table>
 ";
 unset($xim,$yim);
 }

$nchain=count($chain);
echo <<<EOF
<div class="preformattedLi">
<a href='#imageReconstructed' id='chaincode'>^&nbsp;(up)&nbsp;</a><a href='#notNormalizedFourier'>v&nbsp;(down)</a>

-----------+--------------
Chaincode  |    3   2   1
usually    |      \ | /
without    |    4 - X - 0
space and  |      / | \
line break |    5   6   7
-----------+--------------

$nchain points as outline for $textadd
(in counter clockwise direction as in program <a href='http://life.bio.sunysb.edu/morph/' target='_blank'>SHAPE, see http://life.bio.sunysb.edu/morph/):</a>

     1   5   10   15   20   25   30   35   40   45   50   55   60   65   70   75   80   85   90   95  100
</div>
<ol class="preformatted" start=0 >

EOF;
$outputChain = wordwrap(implode("", $chain),100, "\n", true);
$search = array(
  "/^([0-7])([0-7]{3})([0-7])/m",
  "/([0-7]{4})([0-7])/",
  "/^(.+)$/m"
);
$replace = array(
  "<span style='color:red'>\\1</span>\\2<span style='color:red'>\\3</span>",
   "\\1<span style='color:red'>\\2</span>",
   "\n  <li>\\1</li>"
);
$outputChain=preg_replace($search, $replace, $outputChain);
echo $outputChain."\n  <li>&nbsp;</li>\n
</ol>";
echo <<<EOF
<div class='preformattedLi'>
<a href='#chaincode' id='notNormalizedFourier'>^&nbsp;(up)&nbsp;</a><a href='#notNormalizedXY'>v&nbsp;(down)</a>

Data for $textadd:
  N  +------------ NOT normalized elliptic Fourier -------------+
Harm |            a              b              c              d|
</div>
<ol class="preformatted">
EOF;
  foreach ($harmonics['notnormalized']["a"] as $key => $value) {
    echo
    " <li>".
    sci($harmonics['notnormalized']["a"][$key], 7)." ".
    sci($harmonics['notnormalized']["b"][$key], 7)." ".
    sci($harmonics['notnormalized']["c"][$key], 7)." ".
    sci($harmonics['notnormalized']["d"][$key], 7)."</li>\n";
  }
echo "\n</ol>\n";
echo <<<EOF
<div class='preformattedLi'>
<a href='#notNormalizedFourier' id='notNormalizedXY'>^&nbsp;(up)&nbsp;</a><a href='#normalizedFourier'>v&nbsp;(down)</a>

Data for $textadd:
  N  +- x-y coordinates not normalized +
Harm |            x              y     |
</div>
<ol class="preformatted">
EOF;
  foreach ($x as $key => $value) {
    echo
    " <li>".
    sci($x[$key], 7)." ".
    sci($y[$key], 7)."</li>\n";
  }
  echo <<<EOF
</ol>
<div class='preformattedLi'>
<a href='#notNormalizedXY' id='normalizedFourier'>^&nbsp;(up)&nbsp;</a><a href='#normalizedXY'>v&nbsp;(down)</a>

Data for $textadd:
  N  +------------- normalized elliptic Fourier ----------------+
Harm |            a              b              c              d|
</div>
<ol class="preformatted">
EOF;
  foreach ($harmonics['normalized']["a"] as $key => $value) {
    echo
    " <li>".
    sci($harmonics['normalized']["a"][$key], 7)." ".
    sci($harmonics['normalized']["b"][$key], 7)." ".
    sci($harmonics['normalized']["c"][$key], 7)." ".
    sci($harmonics['normalized']["d"][$key], 7)."</li>\n";
  }
echo "\n</ol>\n";
echo <<<EOF
<div class='preformattedLi'>
<a href='#normalizedFourier' id='normalizedXY'>^&nbsp;(up)&nbsp;</a>

Data for $textadd:
  N  +- x-y coordinates normalized +
Harm |        xnorm         ynorm  |
</div>
<ol class="preformatted">
EOF;
  foreach ($xn as $key => $value) {
    echo
    " <li>".
    sci($xn[$key], 7)." ".
    sci($yn[$key], 7)."</li>\n";
  }

echo "\n</ol>\n";
  #print_pre($_POST);
}// end print harmonics

#harmonic.simple(x=1:n,a0=0,a=nefdf$nefabcd[,"a"],b=nefdf$nefabcd[,"b"],n,1:n)#;
  #print_pre(implode("\n",$x));
  #print_pre($math->ave_user($y));
  #print_pre($math->ave_user($x));
//   imagegif()*/
   ?>

</body>
<?
?>