<?
/**
 * Program's (small) HTML templates
 *
 *
 * Imortant note: all files of the program use utf8 encoding. To prevend therefore
 * damage you should use an unicode compatible editor like
 * {@link http://sourceforge.net/projects/notepad-plus notepad++} or the {@link http://www.crimsoneditor.com/ crimsoneditor}
 * both also with syntax highlighting.
 * The default Notepad Editor in Windows is only a
 * crutch (File ends has to be UNIX). Wordpad instead is capable to read utf8 files
 * and the file ends correct. In contrast to Linux Windows unfortunately doesn't bother
 * about using unicode at all by default in general. Because their interest is only in their
 * own products which are desingned not to cooporate with humanity without the idea of profit.
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-06-25 03:56:25
 * @package chirokey_adults
 * @subpackage program
 */

/**
 * Templates
 *
 * Collects all templates with accesible with <code>Template:ArrayKey</code> replaced
 * with the value in the corresponding array:
 * <code>$templates['ArrayKey'] = 'replaced HTML or text';</code>
 * Use only latin characters, numbers and ':'. There are also internal/hidden templates such
 * as:
 * <code>$templates['internal:...'] = '..';</code>
 * They are not available by the user in file popup.php
 * @global array $templates
 */
$templates = array();


/**
 * Statistical HOF model curve (model 1: no specific distribution)
 *
 * Huisman-Olff-Fresco---HOF---models is taxon's distribution type
 * whether its response is skewed (type V), unimodal (IV), sigmoidal (III, II) or has no
 * specific distribution (I). See Huisman, J. and Olff, H. and Fresco, L. F. M., "A
 * hierarchical set of models for species response analysis", Journal Of Vegetation Science,
 * vol. 4, no. 1, pp. 37-46, 1993.
 * @global string $templates['HOF:noDistribution']
 */
$templates['HOF:noDistribution']      = "<img src='../imgliterature/HOF_noDistribution.png'  height='12' align='middle' title='HOF model 1: no specific distribution'>";

/**
 * Statistical HOF model curve (model 3: left sigmoidal, reaching NOT the upper bound)
 *
 * Huisman-Olff-Fresco---HOF---models is taxon's distribution type
 * whether its response is skewed (type V), unimodal (IV), sigmoidal (III, II) or has no
 * specific distribution (I). See Huisman, J. and Olff, H. and Fresco, L. F. M., "A
 * hierarchical set of models for species response analysis", Journal Of Vegetation Science,
 * vol. 4, no. 1, pp. 37-46, 1993.
 * @global string $templates['HOF:sigmoidalNotUpperLeft']
 */
$templates['HOF:sigmoidalNotUpperLeft']      = "<img src='../imgliterature/HOF_sigmoidalNotUpperLeft.png'  height='12' align='middle' title='HOF model 3: left sigmoidal, reaching NOT the upper bound'>";

/**
 * Statistical HOF model curve (model 2: left sigmoidal, reaching upper bound)
 *
 * Huisman-Olff-Fresco---HOF---models is taxon's distribution type
 * whether its response is skewed (type V), unimodal (IV), sigmoidal (III, II) or has no
 * specific distribution (I). See Huisman, J. and Olff, H. and Fresco, L. F. M., "A
 * hierarchical set of models for species response analysis", Journal Of Vegetation Science,
 * vol. 4, no. 1, pp. 37-46, 1993.
 * @global string $templates['HOF:sigmoidalUpperLeft']
 */
$templates['HOF:sigmoidalUpperLeft']      = "<img src='../imgliterature/HOF_sigmoidalUpperLeft.png'  height='12' align='middle' title='HOF model 2: left sigmoidal, reaching upper bound'>";

/**
 * Statistical HOF model curve (model 3: right sigmoidal, reaching NOT the upper bound)
 *
 * Huisman-Olff-Fresco---HOF---models is taxon's distribution type
 * whether its response is skewed (type V), unimodal (IV), sigmoidal (III, II) or has no
 * specific distribution (I). See Huisman, J. and Olff, H. and Fresco, L. F. M., "A
 * hierarchical set of models for species response analysis", Journal Of Vegetation Science,
 * vol. 4, no. 1, pp. 37-46, 1993.
 * @global string $templates['HOF:sigmoidalNotUpperRight']
 */
$templates['HOF:sigmoidalNotUpperRight']      = "<img src='../imgliterature/HOF_sigmoidalNotUpperRight.png'  height='12' align='middle' title='HOF model 3: right sigmoidal, reaching NOT the upper bound'>";

/**
 * Statistical HOF model curve (model 2: right sigmoidal, reaching upper bound)
 *
 * Huisman-Olff-Fresco---HOF---models is taxon's distribution type
 * whether its response is skewed (type V), unimodal (IV), sigmoidal (III, II) or has no
 * specific distribution (I). See Huisman, J. and Olff, H. and Fresco, L. F. M., "A
 * hierarchical set of models for species response analysis", Journal Of Vegetation Science,
 * vol. 4, no. 1, pp. 37-46, 1993.
 * @global string $templates['HOF:sigmoidalUpperRight']
 */
$templates['HOF:sigmoidalUpperRight']      = "<img src='../imgliterature/HOF_sigmoidalUpperRight.png'  height='12' align='middle' title='HOF model 2: right sigmoidal, reaching upper bound'>";

/**
 * Statistical HOF model curve (model 4: unimodal)
 *
 * Huisman-Olff-Fresco---HOF---models is taxon's distribution type
 * whether its response is skewed (type V), unimodal (IV), sigmoidal (III, II) or has no
 * specific distribution (I). See Huisman, J. and Olff, H. and Fresco, L. F. M., "A
 * hierarchical set of models for species response analysis", Journal Of Vegetation Science,
 * vol. 4, no. 1, pp. 37-46, 1993.
 * @global string $templates['HOF:unimodal']
 */
$templates['HOF:unimodal']      = "<img src='../imgliterature/HOF_unimodal.png'  height='12' align='middle' title='HOF model 4: unimodal'>";

/**
 * Statistical HOF model curve (model 5: right skewed)
 *
 * Huisman-Olff-Fresco---HOF---models is taxon's distribution type
 * whether its response is skewed (type V), unimodal (IV), sigmoidal (III, II) or has no
 * specific distribution (I). See Huisman, J. and Olff, H. and Fresco, L. F. M., "A
 * hierarchical set of models for species response analysis", Journal Of Vegetation Science,
 * vol. 4, no. 1, pp. 37-46, 1993.
 * @global string $templates['HOF:skewedRight']
 */
$templates['HOF:skewedRight']      = "<img src='../imgliterature/HOF_skewedRight.png'  height='12' align='middle' title='HOF model 5: right skewed'>";

/**
 * Statistical HOF model curve (model 5: left skewed)
 *
 * Huisman-Olff-Fresco---HOF---models is taxon's distribution type
 * whether its response is skewed (type V), unimodal (IV), sigmoidal (III, II) or has no
 * specific distribution (I). See Huisman, J. and Olff, H. and Fresco, L. F. M., "A
 * hierarchical set of models for species response analysis", Journal Of Vegetation Science,
 * vol. 4, no. 1, pp. 37-46, 1993.
 * @global string $templates['HOF:skewedLeft']
 */
$templates['HOF:skewedLeft']      = "<img src='../imgliterature/HOF_skewedLeft.png'  height='12' align='middle' title='HOF model 5: left skewed'>";

/**
 * Explained variable LOI: Loss On Ignition
 *
 * @global string $templates['explained:LOI']
 */
$templates['explained:LOI']   = "<abbr class='variable' title='LOI: Loss on iginition (mostly given in %)'>LOI</abbr>";

/**
 * Explained variable N2: effective number of occurrence
 *
 * Is often used by transfer models but is NOT simply Hill´s (1973) N2 for Hill number 2!!!
 * @global string $templates['explained:N2:transferModels']
 */
$templates['explained:N2:transferModels']      = "<abbr class='variable' title='in transfer models = effective number of occurrence: adjusted by dividing Hill´s (1973) diversity measure N2 for Hill number 2 (1/sqrt{1 - 1/N2}). NOT to be confused with '>N2</abbr>";

/**
 * Explained variable N2: Hill´s (1973) diversity measure
 *
 * @global string $templates['explained:N2:HillsDiversity']
 */
$templates['explained:N2:HillsDiversity']      = "<abbr class='variable' title='Hill´s (1973) diversity measure N2 for Hill number 2. NOT to be confused with N2 often used in transfer models!'>N2</abbr>";

/**
 * RDA by Little and Smol 2001 (tested oxgen)
 *
 * @global string $templates['explained:LOI']
 */
$templates['RDA:oxygen:Little2001']      = '<img style="border: 1px solid gray;" src="../imgliterature/RDA_Little2001.gif" width="690" height="330" title="RDA of Little, Joanne L. and Smol, John P., A chironomid--based model for inferring late--summer hypolimnetic oxygen in southeastern Ontario lakes, Journal of Paleolimnology, vol. 26, no. 3, pp. 259--270, 2001.">';


/**
 * Error for reference
 *
 * For instance when a reference is missing
 * @global string $templates['Reference:Error']
 */
$templates['Reference:Error']      = "<span class='error' title='Reference is wrong(?) or missing'><img src='../structure/img/book_unclear.png'  align='middle'>Reference?</span>";

/**
 * Open questions...
 *
 * For instance when a reference has to be checked later...
 * @global string $templates['questions:open']
 */
$templates['questions:open']      = "<img src='../structure/img/b_questionmark.gif'  align='middle' title='An open question...'>";

/**
 * Internal template: hidden map
 *
 * Not accesible by the user in popup.php
 * @global string $templates['internal:hiddenMap']
 */
$templates['internal:hiddenMap']      = '<img class="printinvisible" src="../structure/img/map_pinned.png"  title="Hidden map here"><br>';

?>