SELECT * FROM `genus` ORDER BY `genus` ASC LIMIT 0 , 60

-- Splate alt  : Erklaerumg                       | Beispiel    |   neu             | neue Tabelle
--________________________________________________|_____________|___________________|______________
-- id          : primary key                      |  13         | valid id          | names_valid
-- genus       : full genus name                  |  Abiskomyia | valid genus name  | names_genera
-- tacosy      : short name of Taxa Coding System |  NULL       | valid tacosys     | names_genera
-- genus_short : short name                       |  Abis       | valid genus_short | names_genera
-- similar     : similar genera as id number      |  ] 83[      | similar           | characters
-- notes       : text for notes                   |  Text ...   | notes             | characters
-- ecology     : text for ecology                 |  Text ...   | ecology           | characters
-- subfamily   : id of subfamily                  |  4          | subfamily         | names_valid


--neue Abfrage
  -- identisch der alten 69 Gattungen
  SELECT characters.valid_name_id, names_genera.name, names_genera.tacosy, names_genera.name_short, names_species.name, characters.similar, characters.ecology, characters.notes, names_subfamily.id FROM names_genera, characters, names_species, names_subfamily LEFT JOIN names_valid ON (names_genera.id=names_valid.genus_name_id) AND (names_species.id=names_valid.species_name_id) AND (names_subfamily.id=names_valid.subfamily_name_id) WHERE characters.valid_name_id=names_valid.id

-- NULL setzten
  -- genus.ecology NULL setzten
  UPDATE `genus` SET ecology = NULL WHERE ecology LIKE CONVERT( _utf8 '' USING latin1 ) COLLATE latin1_general_cs
  -- genus.notes NULL setzten
  UPDATE `genus` SET notes = NULL WHERE notes LIKE CONVERT( _utf8 '' USING latin1 ) COLLATE latin1_general_cs
  -- genus.similar NULL setzten
  UPDATE `genus` SET similar = NULL WHERE similar LIKE CONVERT( _utf8 '' USING latin1 ) COLLATE latin1_general_cs
  -- genus.subfamily NULL setzten
  UPDATE `genus` SET subfamily = NULL WHERE subfamily LIKE CONVERT( _utf8 '' USING latin1 ) COLLATE latin1_general_cs

-- INDICES
  -- names_synonyms
  ALTER TABLE `names_synonyms` ADD INDEX `speciemen_name` ( `genus_name_id` , `species_name_id` )
  -- names_valid
  ALTER TABLE `names_valid` ADD INDEX `speciemen_name` ( `genus_name_id` , `species_name_id` )
  --characters
  ALTER TABLE `characters` ADD UNIQUE (`valid_name_id`)

-- subfamily nach names_valid ueberfuehren
  UPDATE `names_valid`,`genus` SET `subfamily_name_id` =`genus`.`subfamily` WHERE `names_valid`.`genus_name_id`=`genus`.`id`

-- characters
  -- neu erstellen STRG+R reg.Ausdruck (ohne |) suchen: |, -- (.+$)| ersetzen: |COMMENT '\1',|
  CREATE TABLE characters (
    id BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY COMMENT 'primary key',
    valid_name_id INT UNSIGNED NOT NULL COMMENT 'id from table names_valid',
    notes TEXT NULL COMMENT 'text for notes',
    ecology TEXT NULL COMMENT 'text for ecology',
    similar VARCHAR( 20 ) NULL  COMMENT 'simalar speciemen (id´s from table names_valid)'
  );
  -- mit sp.-Werten fuellen
  SELECT genus.* FROM genus WHERE genus_short NOT LIKE CONVERT( _utf8 '' USING latin1 ) COLLATE latin1_general_cs
  -- ecology notes similar hilfsspalte = NOT NULL ''
  INSERT INTO `characters`  SELECT
  `names_valid`.`hilfsspalte`,
  `names_valid`.`id`,
  `genus`.`notes`,
  `genus`.`ecology`,
  `genus`.`similar`
  FROM `names_valid` LEFT JOIN `genus` ON `names_valid`.`genus_name_id`=`genus`.`id`
  WHERE `genus`.`notes` IS NOT NULL
  OR `genus`.`ecology`  IS NOT NULL
  OR `genus`.`similar`  IS NOT NULL
  --   Eingefügte Zeilen: 453
  -- Letzte automatisch eingefügte ID: 1 (die Abfrage dauerte 0.0138 sek)
  INSERT INTO `characters`  SELECT
  `names_valid`.`hilfsspalte`,
  `names_valid`.`id`,
  `genus`.`notes`,
  `genus`.`ecology`,
  `genus`.`similar`
  FROM `names_valid` LEFT JOIN `genus` ON `names_valid`.`genus_name_id`=`genus`.`id`
  WHERE `genus`.`notes` IS NULL
  AND `genus`.`ecology`  IS NULL
  AND `genus`.`similar`  IS NULL



SELECT characters.valid_name_id, names_genera.name, names_genera.tacosy, names_genera.name_short, names_species.name, characters.similar, characters.ecology, characters.notes, names_subfamily.id FROM names_genera, characters, names_species, names_subfamily LEFT JOIN names_valid ON (names_genera.id=names_valid.genus_name_id) AND (names_species.id=names_valid.species_name_id) AND (names_subfamily.id=names_valid.subfamily_name_id) WHERE characters.valid_name_id=names_valid.id
-- ergibt:
--  Array
--  (
--      [0] => Array
--          (
--              [0] => 4
--              [valid_name_id] => 4
--              [1] => Acricotopus
--              [name] => sp.
--              [2] =>
--              [tacosy] =>
--              [3] => Acri
--              [name_short] => Acri
--              [4] => sp.
--              [5] =>
--              [similar] =>
--              [6] =>
--              [ecology] =>
--              [7] => ''Mentum:'' one broad median and 6 pairs of lateral teeth present; median tooth with shallow notches cividing anteriormargin into 4 parts. Ventromental plates broad; long beard present (Cranston et.al. 1983).
--  Plank 15.8.2005: in sample 02-YeR-15-1-5 cf. Acricotopus longipalpus  (immature stage 2 or 3) with ''one'' middle tooth
--              [notes] => ''Mentum:'' one broad median and 6 pairs of lateral teeth present; median tooth with shallow notches cividing anteriormargin into 4 parts. Ventromental plates broad; long beard present (Cranston et.al. 1983).
--  Plank 15.8.2005: in sample 02-YeR-15-1-5 cf. Acricotopus longipalpus  (immature stage 2 or 3) with ''one'' middle tooth
--              [8] => 1
--              [id] => 1
--          )

-- id von names_valid aendern Genus-sp.-id auf names_valid.id setzen
  UPDATE names_valid SET ID=ID+700  -- alle names_valid.id+700

  UPDATE names_valid SET ID=names_valid.genus_name_id WHERE `species_name_id` = '192'
  UPDATE names_valid SET ID=ID-663 WHERE `species_name_id` != '192' -- alle nicht species: names_valid.id-663


  SELECT *  FROM `names_valid` WHERE `species_name_id` != '192'
  SELECT *  FROM `names_valid` WHERE `species_name_id` = '192'

loeschen doppelter notes

  UPDATE characters SET notes = NULL WHERE valid_name_id=(SELECT names_valid.id FROM names_valid WHERE characters.valid_name_id=names_valid.id AND names_valid.species_name_id!=192)

  UPDATE characters SET ecology = NULL WHERE valid_name_id=(SELECT names_valid.id FROM names_valid WHERE characters.valid_name_id=names_valid.id AND names_valid.species_name_id!=192)

-- Sonntag 11 Februar 2007 alle Gattungen:
  SELECT `names_genera`.`name`
FROM `names_valid`
 LEFT JOIN `names_genera` ON `names_valid`.`genus_name_id` = `names_genera`.`id`
WHERE ((`names_valid`.`genus_name_id` =`names_genera`.`id`) AND (`names_valid`.`species_name_id` =192))

-- Dienstag 13 Februar 2007 alle Gattungen spec:
SELECT `names_genera`.`name` AS 'genus_name', `names_valid`.`id` AS 'valid_id', `names_subfamily`.`name_short` AS 'subfamily_short'
FROM `names_genera`, `names_valid`, `names_subfamily`
WHERE
  `names_genera`.`id`=`names_valid`.`genus_name_id` AND  `names_subfamily`.`id`=`names_valid`.`subfamily_name_id` AND
  `names_valid`.`species_name_id` =192
ORDER BY `names_genera`.`name` ASC


 `names_genera` ON `names_valid`.`genus_name_id` = `names_genera`.`id`
WHERE ((`names_valid`.`genus_name_id` =`names_genera`.`id`) AND (`names_valid`.`species_name_id` =192))

SELECT ... WHERE col IN (SELECT ...) -- sub SELECT ganze Liste!
SELECT ... WHERE EXISTS (SELECT ...) -- 1.SELECT OK? dann sub SELECT
SELECT `names_valid`.`id` FROM `names_valid`
(
  SELECT
  COUNT(`images`.`valid_id`) AS 'count_images',
  `images`.`valid_id`
  FROM `images` GROUP BY `images`.`valid_id`
  ) AS 'subcount'
WHERE
  `subcount`.`valid_id`=`names_valid`.`id`

SELECT  `names_valid`.`id`, COUNT(`images`.`valid_id`) AS 'count_images' FROM `names_valid`, `images` GROUP BY `images`.`valid_id`

-- 3.0300 sek.!
SELECT  `names_valid`.`id`, COUNT(`images`.`valid_id`)
FROM `names_valid`
LEFT JOIN  `images` ON `names_valid`.`id`=`images`.`valid_id`
GROUP BY `names_valid`.`id`

SELECT  `names_valid`.`id`, COUNT(`images`.`valid_id`)
FROM `names_valid`,`images`
GROUP BY `names_valid`.`id`

SELECT `names_genera`.`name` , `names_valid`.`id`
FROM `names_genera`, `names_valid`
WHERE  `names_genera`.`id` = `names_valid`.`genus_name_id` AND
`names_genera`.`name` LIKE '/*[VARIABLE]%*/'

--   subgenus
  -- 1 Isocladius
  -- Nostococladius)  CricNo  2
  -- Cricotopus)  CricCr  4
  -- Pseudocricotopus)  CricPs  5
  -- Monopsectrocladius 7
  -- Mesopsectrocladius)  PsclMe  8
  -- Psectrocladius 9
  -- Euorthocladius)  OrthEu  10
  -- Orthocladius)  OrthOr  11
  -- Pogonocladius)  OrthPo  12
  -- Eudactyloocladius)  OrthEd  13
  -- Psammocladius)  HaloPs  14

  UPDATE `names_valid` SET `names_valid`.`subgenus_name_id`=4  WHERE `names_valid`.`id` IN (
    SELECT `images`.`valid_id` FROM `images` WHERE SUBSTRING(`images`.`filename`,1,6)='CricCr'
  )
  UPDATE `names_valid` SET
  `names_valid`.`genus_name_id`=103 ,
  `names_valid`.`subgenus_name_id`=11
  WHERE `names_valid`.`id`=240

-- Oliverida/Hydrobaenus
  SELECT `names_genera`.`name` ,
    `names_genera`.`name_short` ,
    `names_valid`.`id` AS 'valid_name_id'
    FROM `names_genera`, `names_valid`
    WHERE
    `names_genera`.`id` = `names_valid`.`genus_name_id` AND
    `names_genera`.`name` REGEXP '[a-z]\/[a-z]'

  SELECT
    `images`.`filename`,
    `names_genera`.`name`,
    `names_species`.`name`,
    `images`.`annote`
  FROM `images`, `names_valid`, `names_genera`, `names_species`
  WHERE
    `images`.`morph_id`=7 AND
    `images`.`valid_id`=`names_valid`.`id` AND
    `names_genera`.`id`=`names_valid`.`genus_name_id` AND
    `names_species`.`id`=`names_valid`.`species_name_id`

SELECT
  `images`.`filename`,
  `images`.`annote`,
  `morph_attrib`.`morph_long`,
  `names_subgenus`.`name` AS 'subgenus',
  `names_genera`.`name` AS 'genus',
  `names_species`.`name` AS 'species',
  `names_authors`.`authors_short`
FROM `names_genera`, `names_species`, `names_authors`, `images`, `morph_attrib`, `names_valid`
  LEFT JOIN `names_subgenus` ON `names_valid`.`subgenus_name_id`=`names_subgenus`.`id`
WHERE
  `images`.`valid_id`=`names_valid`.`id` AND
  `images`.`morph_id`=7 AND
  `names_genera`.`id`=`names_valid`.`genus_name_id` AND
  `names_species`.`id`=`names_valid`.`species_name_id` AND
  `names_authors`.`id`=`images`.`names_authors_id` AND
  `names_valid`.`subfamily_name_id`=2 AND
  `morph_attrib`.`id`=`images`.`morph_id`
ORDER BY `names_genera`.`name` ASC



SELECT
  `images`.`filename`,
  `images`.`annote`,
  `morph_attrib`.`morph_long`,
  `morph_attrib`.`img_width_default`,
  `names_subgenus`.`name` AS 'subgenus',
  `names_genera`.`name` AS 'genus',
  `names_species`.`name` AS 'species',
  `names_subfamily`.`name_short` AS 'subfamily',
  `names_authors`.`authors_short`
FROM `names_genera`, `names_species`, `names_authors`, `images`, `morph_attrib`, `names_valid`
  LEFT JOIN `names_subgenus` ON `names_valid`.`subgenus_name_id`=`names_subgenus`.`id`
  LEFT JOIN `names_subfamily` ON `names_valid`.`subfamily_name_id`=`names_subfamily`.`id`
WHERE
  `images`.`valid_id`=`names_valid`.`id` AND
  `images`.`morph_id`=`names_subfamily`.`morph_attrib_id` AND
  `names_genera`.`id`=`names_valid`.`genus_name_id` AND
  `names_species`.`id`=`names_valid`.`species_name_id` AND
  `names_authors`.`id`=`images`.`names_authors_id` AND
  `names_valid`.`genus_name_id`=2 AND
  `morph_attrib`.`id`=`images`.`morph_id`
ORDER BY `names_genera`.`name` ASC


-- UPDATE all subfamily_id from a `names_valid` copy
UPDATE `names_valid`, `names_valid_backup`
  SET `names_valid`.`subfamily_name_id`=`names_valid_backup`.`subfamily_name_id`
WHERE
  `names_valid`.`genus_name_id` = `names_valid_backup`.`genus_name_id` AND
  `names_valid_backup`.`subfamily_name_id` IN (
    SELECT
      `names_valid_backup`.`subfamily_name_id`
    FROM `names_valid_backup`, `names_genera`
    WHERE
      `names_valid_backup`.`genus_name_id` = `names_genera`.`id` AND
      `names_valid_backup`.`species_name_id` = 192
    )

-- 2009-03-31 14:09:50 delete all image with 'only private usage'
  -- UPDATE text images
    SELECT CONCAT('UPDATE `characters` SET `ecology` = REPLACE(`ecology`,"\' src=\'../../imglarvae/',`filename`,'\'", " deleted ', UTC_TIMESTAMP(),'\' src=\'image.php?img_warning=true&text=',`filename`,' deleted ', UTC_TIMESTAMP(),'\'");\n  UPDATE `characters` SET `notes` = REPLACE(`notes`,"\' src=\'../../imglarvae/',`filename`,'\'", " deleted ', UTC_TIMESTAMP(),'\' src=\'image.php?img_warning=true&text=',`filename`,' deleted ', UTC_TIMESTAMP(),'\'");') AS 'replaced'  FROM `images` WHERE `license` LIKE 'only private usage'
  -- save as executable bash-file
    SELECT CONCAT('if [ -a ',`filename`,' ]; then rm ',`filename` ,'; fi') as 'remove'  FROM `images` WHERE `license` LIKE 'only private usage'
    SELECT CONCAT("# ",UTC_TIMESTAMP())
    UNION
    SELECT CONCAT(' ./chip/imglarvae/',`filename`,' ') as 'remove'  FROM `images` WHERE `license` NOT LIKE 'only private usage';
  -- delete images in table images
  DELETE FROM `images` WHERE `images`.`license` = 'only private usage'
-- NOTE: if a database is copied table id=0 in names_authors for
--       'No reference given' has to be restored:
  UPDATE `names_authors` SET `id`= 0 WHERE `authors_short` LIKE 'No reference given'
echo  sed  -e 's/\\Select\[[^]+]\]/\1/g;' datei.txt

SELECT `names_authors`.`author_names`
FROM `names_authors`
 LEFT JOIN `images` ON `names_authors`.`id` = `images`.`names_authors_id`
WHERE (`names_authors`.`author_names` REGEXP '^Sæther, O. A.')

UPDATE `images`, `names_authors` SET `images`.`license` = 'Author provides scientific usage'
WHERE
  (`names_authors`.`id` = `images`.`names_authors_id`) AND
  (`names_authors`.`author_names` REGEXP '^Sæther, O. A.')
