<?php
/**
 * Execute MySQL statements and redirect
 *
 * Variables $content, $info, $title are mainly used for any output.
 * INSERTs, UPDATEs and DELETE should be done with this file.
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-06-07 06:58:24
 * @license Noncommercial-Share Alike 3.0 Unported
 * @category program tools
 * @package chirokey_larvae
 * @subpackage database
 */

/**
 * Extract current server path relatively
 *
 *
 * {1} means one level up as it replaces
 * any string exept '/' multiple times ('+') ended by '/'. In regular expression
 * language:
 * <code>([^/]+/)</code>
 * The (..) can be used to refere the found string by \\1, \\2 and so on.
 * @global string $currentServerPath
 */
 $currentServerPath = preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);
include($currentServerPath.'structure/session.inc.php');
header('content-type: text/html; charset=utf-8');
header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
header ("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT"); // always modified
header ("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header ("Pragma: no-cache"); // HTTP/1.0
$currentServerPath = preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);
include($currentServerPath.'structure/functions.php');
include($currentServerPath.'structure/classes/sql.php');//first get classes
include($currentServerPath.'structure/config.php');/* login */
include($currentServerPath.'structure/classes/tools.php');
// print_r($_GET);

$objMysql  = new db_mysql;//class db_mysql
$objHtml   = new html;//class html
$objReload = new formreload;//class formreload

switch ($_GET['action']) {
# @annotation action: insert_characters
  /* needs GET variables:
      id_characters=ID,
      id_author=ID|NULL,
      id_author=name|'',
      link_back=urlencode(),
      taxon=urlencode()
    */
  case 'insert_characters':
    $title = "Insert ".$_GET['taxon']." into table characters";// page title
    $taxon = "<em>".$_GET['taxon']."</em>".(empty($_GET['author'])? '' : " from ".$_GET['author']);
  # @annotation action: insert_characters: form
    $form.="
    <form action='' method='POST'>
      ";
      $form.=isset($_POST['go_insert_id_characters']) ?"":" Insert ".$taxon." into table characters? <input type='submit' value='insert' name='go_insert_id_characters'>";
      $form.=$objReload->get_formtoken();
  # @annotation action: insert_characters: form save INSERT + reload block
    if(isset($_POST['go_insert_id_characters'])){
      if($objReload->easycheck_empty()){
      $objMysql->execute("
      INSERT INTO
        `characters`
          (`id`, `names_valid_id`, `names_authors_id`)
        VALUES
          ('',".$_GET['names_valid_id'].",".$_GET['id_author'].")
        ");
        $form.= $taxon." was inserted in table characters.";
      }// end no reload
      else {# reload
        $form.= $taxon." is already in table characters!";
      }
    }// end insert was pressed
    $form.=" <a href='".$_GET['link_back']."' target='chirokey_larvae'>Go back</a> </form>";
    $info.= $form;
  # @annotation action: insert_characters: fetch last inserted ID
  # @annotation action: insert_characters: delete_characters
    if($intCharactersId=$objMysql->insertId()) // provide delete_characters
    $info.="<form action='?action=delete_characters' method='POST'>
      <input type='submit' value='delete' onclick=\"check=confirm('Delete this data set from table characters for ".$_GET['taxon']."? There is no way back!!!');if (check==false) return false;\" name='go_delete_id_characters'>
      <input type='hidden' value='delete_characters' name='action'>
      <input type='hidden' value='".$intCharactersId."' name='id_characters'>
      <input type='hidden' value='".$_GET['link_back']."' name='link_back'>
      <input type='hidden' value='".$_GET['taxon']."' name='taxon'>
    </form>";
  break;// end case 'insert_characters'
# @annotation action: delete_characters
  /* needs POST variables: id_characters, link_back, taxon */
  case 'delete_characters':
    if(isset($_POST['id_characters']) && !empty($_POST['id_characters'])){
    $objMysql->execute("
      DELETE FROM `characters` WHERE `characters`.`id` = ".$_POST['id_characters']." LIMIT 1;
    ");
      $info.="<em>".$_POST['taxon']."</em> with ID ".$_POST['id_characters']." was deleted from table characters.";
    }else {
  # @annotation action: delete_characters: ID is missing (no save)
      $info.=$_POST['taxon']." was not removed. ID is missing.";
    }
    $info.= " <a href='".$_POST['link_back']."' target='chirokey_larvae'>Go back</a>";
  break;// end case 'insert_characters'
# @annotation action: default: no action
  default:
    $info = "No action is performed.";
}// end switch $_GET['action']
# @annotation content: compose output
/* title definitions */
  $title      = $title;
  $link       = '../structure/css/basic.css';
  $javascript = 'src="../structure/js/functions.js"';
  include($currentServerPath.'structure/pages.php');
  $content    = $page['head'];/* head of page */
  $content   .= "\n  <div class='info'>".$info."</div>";
  echo $content.$page['foot'];
  exit;
?>