<?php

/**
 * Image for measuring feature and textimages
 *
 * Creates image for the digitizer and for text images, e.g.:
 * <code>image.php?text=my text&angle=60</code>
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-02-24 21:24:33
 * @license Noncommercial-Share Alike 3.0 Unported
 * @todo provide possibility to alter the name of an image
 * @todo save scenario including subgenus: check Name from DB or error ...
 * @todo minor issue: document further detailed
 * @category program tools
 * @package chirokey_larvae
 * @subpackage program
 */
/**
 * Extract current server path relatively
 *
 *
 * {1} means one level up as it replaces
 * any string exept '/' multiple times ('+') ended by '/'. In regular expression
 * language:
 * <code>([^/]+/)</code>
 * The (..) can be used to refere the found string by \\1, \\2 and so on.
 * @global string $currentServerPath
 */
$currentServerPath=preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);
include($currentServerPath.'structure/session.inc.php');
include($currentServerPath.'structure/functions.php');
include($currentServerPath.'structure/classes/filemanage.php');
include($currentServerPath.'structure/classes/tools.php');
include($currentServerPath.'structure/classes/sql.php');
include($currentServerPath.'structure/config.php');
  $objImage = new pictures;
  $objMysql = new db_mysql;//class db_mysql
  $objHtml  = new html;//class html

if(isset($_GET['popup']))
{// @annotation:  popup-case

# @annotation:  popup-case: page
  $link = '../structure/css/basic.css';
  $javascript = 'src="../structure/js/functions.js"';
  $script = '<script type="text/javascript" src="../structure/js/wz_jsgraphics.js"></script>'."<link rel='shortcut icon' href='../structure/img/favicon.ico'>";
  $page_body=' class="popup"  onload="javascript:self.focus();" ';

if($_GET['action']=='measuringtemp'){
  $title= "Measure temporary image (larvae) ...";
  $strImgSrc=empty($_FILES['file']['name'])? '../structure/img/chiro.png' : 'temp/'.$_FILES['file']['name'];
  $arrImgSize = @getimagesize(preg_replace("#(.+)[^/]+$#U","\\1",__FILE__).'temp/'.$_FILES['file']['name']);
  include($currentServerPath.'structure/pages.php');
    $content.= $page['head'];
    $content.= "<h2>Digitizer (larvae)</h2>";
  # @annotation popup-case: action measuringtemp
    if(isset($_FILES['file']) && !preg_match("/image\/(png|gif|jpeg)/i",$arrImgSize['mime'])){
      $content.= "<div class='error'>File '".$_FILES['file']['name']."' (".$_FILES['file']['type'].") cannot be shown or is no image file.</div>";
    }
    $content.="<div class='info'>To measure distances of temporary images load them from folder 'larvae/key/temp'.</div>";
    $content.= "<form method='post' name='sendfile' enctype='multipart/form-data' action='http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."'>
      <input name=\"file\" type=\"file\" >
      <input name=\"tempload\" type=\"submit\" value=\"Load image\">
    </form>";
  # @annotation: popup-case: table measurement
    $content.= $page['count_coordinates'];
} else{# no GET measuringtemp
  $strImgSrc='../../'.$config['dirSpec'].$_GET['file'];

 if($_POST['update']=='update'){
    if($config['debug']) $_SESSION['POST']=$_POST;
      switch($_GET['action']){
    # @annotation popup-case: save:UPDATE-edit
        case "edit":
          if($_POST['names_valid_id']==$_POST['taxon_valid_id'])
            $objMysql->execute("
              UPDATE names_valid
                SET
                  descriptor_name_id = ".$_POST['descriptor_id'].",
                  in_brackets        = ".$_POST['in_brackets']."
                WHERE id             = ".$_POST['names_valid_id'].";
            ");
        // break;// no break: run throught default as well
        default:
      # @annotation popup-case: save:UPDATE
        $objMysql->execute("UPDATE `images`
          SET
            `annote`       = '".htmlentities(replaceHTMLcode($_POST['annote']),ENT_QUOTES,'UTF-8')."',
            `license_memo` = '".htmlentities(replaceHTMLcode($_POST['license_memo']),ENT_QUOTES,'UTF-8')."',
            `license`      = '".$_POST['license']."',
            ".($_GET['action']? "`morph_id`       = ".$_POST['morph_id'].      ",":" ")."
            ".($_GET['action']? "`names_valid_id` = ".$_POST['taxon_valid_id'].",":" ")."
            `time_modified`=NOW()
          WHERE `id` = ".$_GET['image_id']." LIMIT 1;");
     }# end switch action edit
    #unset($_POST);
    header("Location: http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']);
    exit;
  }# end update
# @annotation: popup-case: subfamily (query)
  $annote=$objMysql->querySingleItem("
    SELECT `images`.`annote` FROM `images`
      WHERE `images`.`id` = ".$_GET['image_id']." LIMIT 1;"
    );
# @annotation: popup-case: morphological attribute (query)
  $morph_long=$objMysql->querySingleItem("
    SELECT `morph_attrib`.`morph_long`
      FROM `images` , `morph_attrib`
        WHERE `images`.`morph_id` = `morph_attrib`.`id`
    AND `images`.`id` =".$_GET['image_id']." LIMIT 1;"
  );
# @annotation: popup-case: taxon DB-data (query)
  $oDBTaxonComplete =$objMysql->queryObjectArray("
  SELECT
    `names_authors`.`authors_short` ,
    `names_valid`.`in_brackets` ,
    `names_valid`.`id` AS 'names_valid_id',
    `names_genera`.`name` AS 'genus',
    `names_species`.`name` AS 'species',
    `names_subfamily`.`name` AS 'subfamily',
    `names_subfamily`.`name_short` AS 'subfamily_short'
    FROM `images`
      LEFT JOIN `names_valid`     ON `images`.`names_valid_id`            = `names_valid`.`id`
      LEFT JOIN `names_authors`   ON `names_valid`.`descriptor_name_id`   = `names_authors`.`id`
      LEFT JOIN `names_genera`    ON `names_valid`.`genus_name_id`        = `names_genera`.`id`
      LEFT JOIN `names_species`   ON `names_valid`.`species_name_id`      = `names_species`.`id`
      LEFT JOIN `names_subfamily` ON `names_valid`.`subfamily_name_id`    = `names_subfamily`.`id`
    WHERE (
    `images`.`id` = ".$_GET['image_id']."
    ) LIMIT 1;");
    foreach($oDBTaxonComplete as $value){# only 1 enty
      $strDbGenus            = $value->genus;
      $strDbSpecies          = $value->species;
      $strDbDescriptor       = $value->authors_short;
      $intDbInBrackets       = $value->in_brackets;
        $strDbDescriptorBrack= $intDbInBrackets? "(".$strDbDescriptor.")":$strDbDescriptor;
      $strDbSubfamily        = $value->subfamily;
      $strDbSubfamilyShort   = $value->subfamily_short;
      $intDbId_names_valid   = $value->names_valid_id;
    }
# @annotation: popup-case: reference-selects
  if($result=$objMysql->queryObjectArray($MysqlSelect['ReferencesReplace'])){
    foreach($result as $value)
      $Select[$value->id]=$value->authors_short;
  }
  $default = array("" => "^^ select a reference as string for notes ^^");
  switch($_GET['action']){
    case "edit":
      $SelectDescriptor  = array("0" => "-- select descriptor -- ") + $Select;
      $title = $strDbGenus." ".$strDbSpecies." (edit image properties)";
    break;
    default:
      $title = $strDbGenus." ".$strDbSpecies." (image properties)";
  }
  $Select  = $default + $Select;
  $HTMLauthorTextarea  = $objHtml->select($Select,"reference_select_string",$default,"style=\"width:400px;\" title=\"reference string for notes\"  onchange=\"javascript:insert('{textciteID|' + this.options[selectedIndex].value+'|'+this.options[selectedIndex].text+'}','','form','annote');\" ");
  unset($Select,$default);

# @annotation popup-case: compose page
  include($currentServerPath.'structure/pages.php');
  # @annotation popup-case: information taxon
    $content.= $page['head']."<i>".$strDbGenus." ".$strDbSpecies."</i> ".$strDbDescriptorBrack." ".$strDbSubfamily."<br>".$morph_long."<br>\n";
    $content.= "(See also <a href='morphology.php' target='chirokey_larvae'>Morphology</a> or use also the <a href='image.php?popup=1&action=measuringtemp'>digitizer to measure temporary images.</a>)<br>\n";
  # @annotation: popup-case: table measurement
    $content.= $page['count_coordinates'];
  # @annotation: popup-case: form compose (input fieldset ...)
    $content.= "<fieldset style='width:400px;clear:both;' >\n  <legend>Image Notes/Properties</legend>
    <form name='form' method='post' >\n";
  # @annotation: popup-case: descriptor
    switch($_GET['action']){
      case "edit":
    # @annotation: popup-case: input valid id
    $content.="<input type='hidden' value='".$intDbId_names_valid."' name='names_valid_id'>\n";
    # @annotation: popup-case: taxon-genus selects
      if($result=$objMysql->queryObjectArray($MysqlSelect['TaxaValidId'])){
        foreach($result as $valValid)
          $Select[$valValid->id]=$valValid->taxon;
      }
      $default = $strDbGenus." ".$strDbSpecies." (".$strDbSubfamilyShort.")";
      $HTMLelement = $objHtml->select($Select,"taxon_valid_id",$default,"style='width:400px;'  title='taxa names'");
      $content.=$HTMLelement."<br>";
      unset($Select);
    # @annotation: popup-case: descriptor selects
      $default = $strDbDescriptor=="No reference given" ?  '-- select descriptor -- ': $strDbDescriptor;
      $HTMLelement = $objHtml->select($SelectDescriptor,"descriptor_id",$default,"style='width:285px;' title='first descriptor'");
      $content.=$HTMLelement."&nbsp;";
    # @annotation: popup-case: descriptor brackets
      $SelectInBrackets= array("NULL" => "-- brackets? -- ","0" => "no","1" => "yes");
      $default = isset($intDbInBrackets) ? $SelectInBrackets[$intDbInBrackets] : '-- brackets? -- ';
      // select compares the options not the value
      $HTMLelement = $objHtml->select($SelectInBrackets,"in_brackets",$default,"style='width:100px;' title='descriptor in brackets?'");
      $content.=$HTMLelement."<br >";
    # @annotation: popup-case: morphological structure
      if($result=$objMysql->queryObjectArray($MysqlSelect['MorphoIdShortLong'])){
        foreach($result as $value)
          $Select[$value->id]= $value->morph_long;
      }
      $default = $morph_long;
      $HTMLelement = $objHtml->select($Select,"morph_id",$default,"style='width:400px;'  title='morphological structure'");
      $content.=$HTMLelement."<br>";
      break;
      default:
        $content.= "Use also menu <img  style='vertical-align : middle;' src='../structure/img/b_upload.png' width='20' height='20'>&nbsp;&#171;Images&nbsp;&gt;&nbsp;Edit/delete Images&#187; to edit  properties in detail.<br>";
      break;
    }// end case edit


    $content.= "\n  <img src='../structure/img/b_annote.png' width='16' height='16' > Annotations to this picture.&nbsp;&nbsp;&nbsp;&nbsp;\n<input type='submit' name='update' value='update'><br >\n<textarea style='width:400px;' rows=5 name='annote'>".$annote."</textarea><br>\n";
    // reference_select_string
    $content.=$HTMLauthorTextarea;
    unset($Select);
    $content.="<hr>";
  # @annotation: popup-case: license query+select
    if($result=$objMysql->queryObjectArray("SELECT `license`,`license_memo`
        FROM `images` WHERE `images`.`id` =".$_GET['image_id'].";"))
      foreach($result as $value){
        $license      = $value->license;
        $license_memo = $value->license_memo;
      }
    if($result=$objMysql->queryObjectArray("SHOW COLUMNS FROM `images` LIKE 'license';"))
        foreach($result as $value){
          $Select=explode("','",preg_replace("/(enum|set)\('(.+?)'\)/","\\2",$value->Type));
          $Select=array_combine($Select,$Select);
        }
      $HTMLelement = $objHtml->select($Select,"license",$license,"style='width:400px;'   title='license'");
      $content.=$HTMLelement."<br>";unset($Select,$Select['Default']);
    $content.="<textarea style='width:400px;' rows=5 name='license_memo' title='annotation to license'>".$license_memo."</textarea>";
    $content.="</form>
    </fieldset>";
  }# end !$_GET['action']='measuringtemp'
  # @annotation: debug informations
    $content.= ($_SESSION['debug']? $objMysql->showStatistics(true)."\$_POST<br >".print_pre($_SESSION['POST'],true)."\$_GET<br >".print_pre($_GET,true)."\$_SERVER<br >".print_pre($_SERVER,true):'').$page['foot'];
    echo $content;
}// end popup
else
{// @annotation: image texts: create image from text
  // given angle or default angle
  // $var = confition ? TRUE : FALSE;
  $angle = isset($_GET['angle']) ? $_GET['angle'] : $config['img_text_angle'];
  # @annotation cases $_GET['encoding']
  switch ($_GET['encoding']) {
    case 'base64':
    $_GET['text']  = html_entity_decode(base64_decode($_GET['text']), ENT_QUOTES, 'UTF-8');
    break; # end GET[encoding] notes  ecology
      default:
    $_GET['text']  = html_entity_decode($_GET['text'], ENT_QUOTES, 'UTF-8');
  }// end switch $_GET['encoding']
  if(isset($angle) && !isset($_GET['img_warning']))
    $objImage->write_text_picture($_GET['text'],$angle);
  elseif(isset($_GET['img_warning']))
    $objImage->errors($_GET['text']);
}
?>
