<?php
/**
 * Navigation menu
 *
 * Generates the navigation menu.
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-02-24 21:24:33
 * @package chirokey_larvae
 * @todo minor issue: document further detailed
 * @subpackage navigation
 */

/**
 * Extract current server path relatively
 *
 *
 * {1} means one level up as it replaces
 * any string exept '/' multiple times ('+') ended by '/'. In regular expression
 * language:
 * <code>([^/]+/)</code>
 * The (..) can be used to refere the found string by \\1, \\2 and so on.
 * @global string $currentServerPath
 */
$currentServerPath=preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);
  include($currentServerPath.'structure/session.inc.php');
/* start a global session */
header('content-type: text/html; charset=utf-8');
 ?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>navigation</title>
<link media='screen' rel='stylesheet' type='text/css' href='../structure/css/basic.css'>
<link media='print' rel='stylesheet' type='text/css' href='../structure/css/print.css'>
<script language='JavaScript' src='../structure/js/overlib.js'></script>
<script language='JavaScript' src='../structure/js/functions.js'></script><!-- for watch eg. -->
</head>
<?php
  include($currentServerPath.'structure/functions.php');
  include($currentServerPath.'structure/classes/sql.php');
  include($currentServerPath.'structure/config.php');
  include($currentServerPath.'structure/classes/tools.php');
$mysql = new db_mysql;//class db_mysql
?>
<body class="navi" onload="showTheTime();">
<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>

<script>
// (C) 2004 www.CodeLifter.com
// Free for all users, but leave in this header
function framePrint(whichFrame){
   // window.parent[whichFrame].focus();
  if(confirm("This opens the lower frame in a new window.\nAdditional layout modifications can be done via CSS\nin the file »structure/css/print.css«.\n(By default in landscape mode - at least with Opera)")){
    //alert(window.parent[whichFrame].name)
    var urlPrint = String(parent[whichFrame].location);
    urlPrint = urlPrint.replace(/\.(php\?|php$)/gi,'.php?print=true&');
    open(urlPrint);
    //parent[whichFrame].open();
    //parent[whichFrame].print();http://localhost/%5C.(php%5C?|php$)/gi
  }
}
</script>



<table border='0' style='width:100%;'>
  <tr>
    <!-- Menue part -->
    <td style="text-align:left;" >
    <!-- History -->
      <a href="javascript:history.back();"  onmouseover="return overlib('navigation back',WIDTH, 100, OFFSETX, 5, OFFSETY, 30  );" onmouseout="return nd();"><img border='0' src='../structure/img/backward.gif' alt='backward' width='23' height='22'></a>
      <a onmouseover="return overlib('navigation forward',WIDTH, 120, OFFSETX, 5, OFFSETY, 30  );" onmouseout="return nd();"  href="javascript:history.forward();"><img alt='backward' src="../structure/img/forward.gif" border="0" ></a>&nbsp;&nbsp;
    <!-- MySQL -->
      <a href="http://localhost/<?=$config['phpmyadminpath'];?>/" class='external' target="_blank" >
        <img src="../structure/img/s_db.png"  border="0"  style='vertical-align : middle;'>&nbsp;MySQL database&nbsp;</a> /
    <!-- Home -->
      <a href="chirokey.php" target="chirokey_larvae" >
        <img src="../structure/img/b_home.png" border="0"  style='vertical-align : middle;'>&nbsp;Home &nbsp;</a> /
    <!-- References -->
      <a href="chirokey.php?show=references" target="chirokey_larvae" >
        <img src="../structure/img/book.png" width="20" height="20" border="0"  style='vertical-align : middle;'>&nbsp;References&nbsp;</a> /
    <!-- Morphology -->
      <a href="morphology.php?" target="chirokey_larvae" onmouseover="return overlib('Larval morphology', CENTER, OFFSETY,20);" onmouseout="return nd();">
        <img  style='vertical-align : middle;' src="../structure/img/chiro.png" width="20" height="20" border="0">&nbsp;Morphology&nbsp;</a> /
    <!-- Documentation -->
      <a href='../doc/readme.html' target='_blank' class='external' >
        <img  style='vertical-align : middle;' src='../structure/img/docu.png' width='20' height='20' border='0'>&nbsp;Documentation&nbsp;</a> /
    <!-- Images -->
      <a href='upload.php' target="chirokey_larvae" >
        <img  style='vertical-align : middle;' src='../structure/img/b_upload.png' width='20' height='20'>&nbsp;Images</a> /
    <!-- Manage Names -->
      <a href='synonyms.php' target="chirokey_larvae" >&nbsp;<img  style='vertical-align : middle;' src='../structure/img/b_systree.png' width='20' height='20'>&nbsp;Manage Names</a> /
    <!-- Outline Analysis -->
      <a href='outline.php' target="chirokey_larvae" >&nbsp;<img  style='vertical-align : middle;' src='../structure/img/b_outline.png' width='20' height='20'>&nbsp;Outline analysis</a> /
    <!-- Search -->
      <a href='search.php' target="chirokey_larvae" >&nbsp;<img  style='vertical-align : middle;' src='../structure/img/b_find.png' width='20' height='20'>&nbsp;Search</a> /
    <!-- Digitizer -->
      <a href='image.php?popup=1&amp;action=measuringtemp' target='_blank' class='external'>&nbsp;<img  style='vertical-align : middle;' src='../structure/img/b_divider.gif' >&nbsp;Digitizer</a>
    </td>
    <td style='border-width : 0px; text-align : right; vertical-align : top;'>
    <form name='form'>
      <input type='text' name='showTime' size='12' style='border-bottom-style : solid; border-bottom-width : 0px; border-collapse : collapse; font-family : monospace;'></input><br>
      <input type=radio name=showMilitary checked><font size="-2">24 h</input>
      <input type=radio name=showMilitary><font size="-2">12 h</input>
    </form>
    </td>
  </tr><!--document.structure_form.structure_sel.value-->
  <!-- selection menue -->
  <tr>
    <td style="text-align:left;" colspan='2'>
    <div style='float:left;'>
<?php
  $objHtml= new html;// call to class
  $content= "<form  name='structure_form' method='GET' action='chirokey.php' target='chirokey_larvae'>";

  if($result=$mysql->queryObjectArray($MysqlSelect['ShowStructures'])){
    foreach($result as $morphology)
      $morphMenu[$morphology->id]=$morphology->show_morph_long;

    $default = array("`names_subfamily`.`morph_attrib_id`" => "show default structure");
    $morphMenu = $default + $morphMenu;// protect to generate new keys
  }

  if($result=$mysql->queryObjectArray($MysqlSelect['SubfamiliesCount'])){
    foreach($result as $subfamily)
      $subfamilyMenu[$subfamily->id]=$subfamily->name." (".$subfamily->counted_genera.")";

    $default=array("" => "-- select subfamily -- ");
    $subfamilyMenu=$default + $subfamilyMenu;
  # @annotation: SubfamiliesCount: subfamily
    $content.=$objHtml->select($subfamilyMenu,"subfamily_id","-- select subfamily -- ","style='margin:0px;border:0px;'");
  # @annotation: SubfamiliesCount: morphology
    $content.=$objHtml->select($morphMenu,"morph_attrib_id","show default structure","style='margin:0px;border:0px;'");
    $content.="\n<input type='submit' class='flat'  value='...go'>\n";
    $content.="\n<input type='hidden' name='show' value='subfamily'>\n";
    $content.="\n</form>";

    $content.= "<form  name='structure_form' method='GET' action='chirokey.php' target='chirokey_larvae' >";
    if($result=$mysql->queryObjectArray($MysqlSelect['GeneraValidId'])){
      foreach($result as $genus)
        $generaMenu[$genus->valid_id]=$genus->genus_name." (".$genus->subfamily_short.")";

      $default=array("" => "-- select genus -- ");
      $generaMenu= $default + $generaMenu;
    }
  # @annotation: SubfamiliesCount: genera
    $content.=$objHtml->select($generaMenu,"genus_valid_id","-- select genus -- ","style='margin:0px;border:0px;'");
  # @annotation: SubfamiliesCount: morphology
    $content.=$objHtml->select($morphMenu,"morph_attrib_id","show default structure","style='margin:0px;border:0px;'");
    $content.="\n<input type='submit'  class='flat' value='...go'>\n";
    $content.="\n<input type='hidden'  name='show' value='genus'>\n";
    $content.= " or go to specimens: ".$objHtml->pencil('edit=specimen', "popup.php", "title='New window: browse for a specimen' ", "chiro_icon_go.png");
    $content.="\n</form>";

    echo $content;
  }
?></div>
  <div  style='float:right;'>
    <span onclick="alert('To toggle between fullscreen and normal view\nmost browsers accept the key F11');" title='Fullscreen/Normal F11'><img align='middle' src='../structure/img/b_fullscreen.png'></span>
    <span onclick="javascript:framePrint('chirokey_larvae');" title='print' ><img src='../structure/img/b_print.png'  align='middle'></span>
  </div>
    </td>
  </tr>
</table>
</body>

</html>