<?
/**
 * handle references
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-02-24 21:24:33
 * @license Noncommercial-Share Alike 3.0 Unported
 * @category program tools
 * @package chirokey_larvae
 * @subpackage references
 * @todo minor issue: document further detailed
 */
/**
 * Extract current server path relatively
 *
 *
 * {1} means one level up as it replaces
 * any string exept '/' multiple times ('+') ended by '/'. In regular expression
 * language:
 * <code>([^/]+/)</code>
 * The (..) can be used to refere the found string by \\1, \\2 and so on.
 * @global string $currentServerPath
 */
$currentServerPath = preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);

if($result=$objMysql->queryArray("
  SELECT
    `id`,
    CONCAT(`names_authors`.`authors_short`,`names_authors`.`literal`) AS 'authors_short',
    `names_authors`.`author_names`
    FROM `names_authors` ORDER BY `names_authors`.`authors_short`, `names_authors`.`year`,`names_authors`.`title` ASC;
  ")){
  foreach($result as $value){
    $notes_references[$value['id']] = $value['authors_short'];
  }
}


$fetchKeywords =  preg_match("/AND\s+(`id`|id)\s+IN/",$MySQL['addWHERE']) ? "" : "\n<form action='http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir'].$config['ServerKeyDir']."chirokey.php' method='get' onsubmit=\"check=confirm('This may take some time, but you can have tea time inbetween...;-)'); if(check==false) return false;\">
  <button class='printinvisible' type='submit' value='1' name='show_keywords' >get list by keywords</button>
  <input type='hidden' value='references' name='show'>
</form>";

$content.= "
<h1 class='sec1' id='references'>References</h1>
<div id='top' class='printinvisible' style='border:1px dashed;text-align:center;background-color:#FFFFCC;'>".
  preg_replace('#(.)#e',"'<a href=\'#'.base64_encode('\\1').'\' >\\1</a>\n'", 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')
  .$fetchKeywords."
</div>
";

# @annotation keywords compose
if($_GET['show_keywords']){
  $sqlkeywords="SELECT `keywords`
  FROM `names_authors`
  -- WHERE `keywords` IS NOT NULL
  -- AND `keywords` NOT LIKE ''
  ;";
  if($result=$objMysql->queryArray($sqlkeywords))
    foreach($result as $dataset){
      $keywords.=",".$dataset['keywords'];
    }
  # @annotation keywords prepare comma list
    $arr_search = array(
      "/[\n\r]/" , # remove line breaks
      "/ *, */",  # remove multiple blanks with comma
      "/ +/"      # remove multiple blanks
    );
    $arr_replace =array(
      " " , # remove line breaks
      ",",  # remove multiple blanks with comma
      " "   # remove multiple blanks
    );
    $keywords = preg_replace($arr_search,$arr_replace,$keywords);
    $keywords = explode(",", $keywords);             # make a comma seperated list
  # @annotation keywords counting -> array([keyword] => n)
    $keywordsCounted = array_count_values($keywords);
    unset($keywords);

  # @annotation: keywords compose: count
    foreach($keywordsCounted as $keyKeyword =>$valueCounts)
      $keywords[] = $keyKeyword. " (".$valueCounts.")";

  # @annotation: keywords compose: unique list (array $keywords)
    $keywords = array_unique($keywords);
    natcasesort($keywords);

  $i=1; $n = count($keywords);
  #print_pre($keywords);
  foreach($keywords as $datasetCounted){
    $keyword=preg_replace("# *\([0-9]+\)#","",$datasetCounted);
    $count=  preg_replace("#.+([0-9]*)\)$#U","\\1",$datasetCounted);
  # REGEXP BINARY = case sensitive
    $word = empty($keyword) ? " LIKE '".$objMysql->escape($keyword)."' ": " LIKE '%".$objMysql->escape($keyword)."%' ";#(,|$)
    #print_r($word); print_r("<br>");
    $MySQL['addWHERE'] = " AND `names_authors`.`keywords` ".$word;
    $MySQL['addLIMIT'] = " LIMIT ".$count;
    $searchedKeyword = ", '".$objMysql->escape($keyword)."' AS 'searchedKeyword' ";
    include($currentServerPath.'structure/config.php');/* login */
    #print_pre($objMysql->queryArray($MysqlSelect['References']));
    #print_r("<br>");
    // print_r("<br>".$i." array:".is_array($objMysql->queryArray($MysqlSelect['References'])));
    // print_r("<br>".$i." array:".is_array($result));
    if($i == 1){
      $result = $objMysql->queryArray($MysqlSelect['References']);
    } else {
      if(is_array($result) && is_array($objMysql->queryArray($MysqlSelect['References'])))
        $result=array_merge($result, $objMysql->queryArray($MysqlSelect['References']));

      if(is_array($result) && !is_array($objMysql->queryArray($MysqlSelect['References'])))
        $result = $result;

      if(!is_array($result) && is_array($objMysql->queryArray($MysqlSelect['References'])))
        $result = $objMysql->queryArray($MysqlSelect['References']);
    }
    #$result = ($i === 1 ? $objMysql->queryArray($MysqlSelect['References']) : array_merge($result, $objMysql->queryArray($MysqlSelect['References'])));
    $datasetCounted= empty($keyword) ? 'No keywords given'.$datasetCounted : $datasetCounted;
    $keyword       = empty($keyword) ? 'No keywords given' : $keyword;
    if($i>1)
      $strKeywordList.=(mb_strtolower(mb_substr($keyword, 0,1, 'UTF-8'), 'UTF-8')==mb_strtolower(mb_substr($keywordlast, 0,1, 'UTF-8'), 'UTF-8'))? "" : "\n<div class='printinvisible'  id='".mb_strtoupper(mb_substr($keyword, 0,1, 'UTF-8'), 'UTF-8')."'  style='text-align:center;background-color:#FFFFCC;'><b>&nbsp;".mb_strtoupper(mb_substr($keyword, 0,1, 'UTF-8'), 'UTF-8')."&nbsp;&nbsp;&nbsp;&nbsp;</b><a href='#top' style='text-align:right;'>^&nbsp;up&nbsp;^</a></div>\n";
    $strKeywordList.= "<a href='#".base64_encode($keyword)."'>".$datasetCounted."</a>".($n==$i?".":"<br>\n ");
    $keywordlast = $keyword;
    $i++;
  }// end foreach keywords
  $content.="\n<p>List of keywords (Note no abstracts are given to reduce file size):<br> ".$strKeywordList."</p>\n";
}// end fetch kewords
else{
# @annotation DB only references
  include($currentServerPath.'structure/config.php');/* login */
  $result=$objMysql->queryArray($MysqlSelect['References']);
}
  $content.="\n<ul class='references'>";
# @annotation: print references
  foreach($result as $ref){
    $ref['searchedKeyword'] = empty($ref['searchedKeyword']) ? 'No keywords given' : $ref['searchedKeyword'];
    $letterTitle= $_GET['show_keywords'] ? $ref['searchedKeyword'] :  mb_substr($ref['author_names'],0,1, 'UTF-8');
    if($whichletter!=$letterTitle){
  # @annotation: print references: up/keywords
      $letter =  empty($ref['searchedKeyword']) ? '' : $letterTitle;
      $content.="\n<div class='printinvisible'  id='".base64_encode($letter)."'  style='text-align:center;background-color:#FFFFCC;'><b>&nbsp;".$letterTitle."&nbsp;&nbsp;&nbsp;&nbsp;</b><a href='http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."#top' style='text-align:right;'>^&nbsp;up&nbsp;^</a></div>";
      $whichletter=$letterTitle;
    }
    $content.= "\n  <li id='refid".$ref['id']."'>\n    ";
    $content.= "[".$ref['id']."]&nbsp;<strong>";
    $content.= $ref['author_names'];
    // $content.= !empty($ref['year']) ? " (".$ref['year'].")" : '';
    $content.= ":</strong>";
    $ref['title']=preg_match('/\.$/',$ref['title']) ? substr($ref['title'],0,strlen($ref['title'])-1) : $ref['title'];
    $content.= empty($ref['title']) ? " <span style='color:darkred;'>No title in database.</span>" : " <em>".$ref['title']."</em>".(preg_match('/\?$/',$ref['title']) ? '':'.');
  #  @annotation Editor
    if(!empty($ref['editor_name'])){
    if (// multiple Editors
      preg_match('/[A-Z]{1}[a-z]\ +[A-Z]{1}[a-z]/',$ref['editor_name']) ||
      preg_match('/\&/',$ref['editor_name'])||
      preg_match('/\&amp;/',$ref['editor_name'])||
      preg_match('/\&\#038;/',$ref['editor_name'])||
      preg_match('/\ and\ /',$ref['editor_name'])
      )
      $content.= " (Editors:&nbsp;".$ref['editor_name'].").";
      else
      $content.= " (Editor:&nbsp;".$ref['editor_name'].").";
    }

    if(!empty($ref['journal']))
      $content.= preg_match('/\.$/',$ref['journal']) ? " ".$ref['journal'] : " ".$ref['journal'].".";

    if(!empty($ref['publisher_name']))
      $content.= preg_match('/\.$/',$ref['publisher_name']) ? " ".$ref['publisher_name'] : " ".$ref['publisher_name'].".";

    $content.= " <span style='white-space:nowrap;' >";
      /* Volume, Number, ... */
        $searchpattern=array(
          "/\s*(\-|–|─)+\s*/",
          "/\s*(\-|–|─)\s*/",
        );
        $replacepattern=array(
          "&#8211;",// en dash
          "&#8211;",// en dash
        );
    // @annotation replace volume number pages
    if(!empty($ref['volume'])) $ref['volume']=preg_replace($searchpattern, $replacepattern, $ref['volume']);
    if(!empty($ref['number'])) $ref['number']=preg_replace($searchpattern, $replacepattern, $ref['number']);
    if(!empty($ref['page']))   $ref['page']  =preg_replace($searchpattern, $replacepattern, $ref['page']);
    $content.= !empty($ref['volume']) ? " Vol.&nbsp;".$ref['volume']."" : '';
      if(!empty($ref['number']))
      {/* @annotation:  number */
        $colon = empty($ref['volume']) ? " " : ", ";
        $content.= $colon. " No.&nbsp;".$ref['number'];
      }

      if(!empty($ref['page']))
      {/* @annotation: pages */
        if(!empty($ref['number']) ||
        !empty($ref['volume'])){
          $content.= preg_match('/&#8211;/',$ref['page'])? ", Pp.&nbsp;".$ref['page']."." : ",&nbsp;".$ref['page']."&nbsp;P.";
        }
        else {
          $content.= preg_match('/&#8211;/',$ref['page'])? "&nbsp;Pp.&nbsp;".$ref['page']."." : "&nbsp;".$ref['page']."&nbsp;P.";
        }
      }
    $content.= "</span>"; //end no wrap

    if(!empty($ref['edition']))
    {/* edition */
      $content.= " Editon:".$ref['edition'].".";
    }

    if(!empty($ref['month']))
    {/* month */
      $content.= " <nobr>".$ref['month']."</nobr>.";
    }

    if(!empty($ref['journal_url']))
    {/* journal_url */
      $content.= " Link:&nbsp;<a class='external' target=\"_blank\" href=\"".$ref['journal_url']."\">".$ref['journal_url']."</a>.";
    }

    if(!empty($ref['author_mail']))
    {/* mail */
    $searchpattern=array(
    '/\s+/',
    '/\@/',
    '/\./',
    );
    $replacepattern=array(
    '; ',
    '<span style="color:red;" class="printinvisible"> at </span><span class="printvisible">@</span>',
    '<span style="color:red;" class="printinvisible"> dot </span><span class="printvisible">.</span>',
    );
    $ref['author_mail']=preg_replace( $searchpattern, $replacepattern,$ref['author_mail']);
      $content.= " e-mail:&nbsp;<span class='mail'>".$ref['author_mail']. "</span>.";
    }

    if(!empty($ref['author_address']))
    {/* adress */
      $content.= " Adress:&nbsp;".$ref['author_address'].".";/*INSERT INTO `test`.`test` SELECT * FROM `test`.`genus` ;*/
    }

    if(!empty($ref['abstract']) && !$_GET['show_keywords'])
    {/* abstract */
      $ref['abstract']=lb2string($ref['abstract'],' ');
      $content.= " <span onmouseover=\"return overlib('<div style=\'padding:5px;\'>".htmlentities($ref['abstract'],ENT_QUOTES,'UTF-8')."</div>', WIDTH, 600, STICKY, MOUSEOFF, CAPTION, 'Abstract (".htmlentities($ref['authors_short'],ENT_QUOTES,'UTF-8').")');\" onmouseout=\"return nd();\"><img align='middle' src=\"../structure/img/b_annote.png\" width=16 height=16 ></span>" ;
    }

    if(!empty($ref['note']))
    {/* adress */

    /* @annotation $ref['note'] */
      $ref['note']      = $objHtml->pattern2tag(" ".$ref['note']);
      # @annotation $ref['note'] Templates: repelace Templates Template:ArrayKey ($ecologyNotes)
        if(preg_match("#Template:[A-za-z:0-9]+#",$ref['note'])){
          include($currentServerPath.'structure/templates.php');
            $ref['note'] = $objHtml->emphase($ref['note'],$templates, "strTemplateToHtml");
        }# Templates found

        foreach ($notes_references as $key => $value) {
         // $value_searched=array("/\{citeID\|".$key."\|.+\}/U");
         // $value_replaced="<a target='chirokey_larvae' class='reference' title='Click for reference.' href='chirokey.php?show=references#refid".$key."'>".$value."</a>";
         $link=" href='chirokey.php?show=references#refid".$key."' ";
        $value_searched=array(
          "/\{citeID\|".$key."\|(.+)\}/U",
          "/\{textciteID\|".$key."\|(.+)(\d+[a-z]*)\}/U",
          "/\{textciteID\|".$key."\|(.+)(n\.\s*d\.\s*)\}/U", // n.d.
          "/\{citeyearID\|".$key."\|(.+)\}/U",
          "/\{citeauthorID\|".$key."\|(.+)\}/U",
          "/\{numciteID\|".$key."\|(.+)\}/U"
        );
        $value_replaced=array(
          "<a title='Click for reference: \\1.' class='reference' target='chirokey_larvae' ".$link." >".$value."</a>",
          "<a title='Click for reference: \\1\\2.' class='reference' target='chirokey_larvae' ".$link." >".preg_replace("#(.+?)(\d+[a-z]*$)#","\\1 (\\2)",$value)."</a>",
          "<a title='Click for reference: \\1\\2.' class='reference' target='chirokey_larvae' ".$link." >".preg_replace("#(.+?)(n\.\s*d\.\s*$)#","\\1 (\\2)",$value)."</a>",
          "<a title='Cited year of reference: \\1.' class='reference' target='chirokey_larvae' ".$link." >".preg_replace("/.+([0-9]{4}[a-z]?)/","\\1",$value)."</a>",
          "<a title='Cited author of reference: \\1.' class='reference' target='chirokey_larvae' ".$link." >".preg_replace("/(.+)\s*[0-9]{4}[a-z]?/","\\1",$value)."</a>",
          "<a title='Click for reference: \\1.' class='reference' target='chirokey_larvae' ".$link." >".$key."</a>"
          );
            $ref['note']=preg_replace($value_searched,$value_replaced,$ref['note']);
        }

//         $originaltextnew=preg_replace($value_searched, $value_replaced, $originaltext);
      $content.= " Note:&nbsp;".$ref['note'].(preg_match("/[?.!]$/", $ref['note'])?"":".");
    }
    $content.= empty($ref['keywords']) ? " <span style='color:darkred;' class='printinvisible'>Keywords not yet given.</span> " : "";

    $content.= "\n  <a target='chirokey_larvae' class='nothing' title='edit this record' href='update.php?title=references&amp;refid=".$ref['id']."'><img align='middle' id='pencilEdit' src='../structure/img/b_edit.png' width='16' height='16' ></a></li>";
  }//end foreach($objMysql_mysql)

  $content.= "\n</ul>"; // to close list
$content.="\n</div>\n<!-- end description -->\n";

?>