#!/bin/bash
###############################
# simple Linux BASH script to
# prepare key for adults + pupae
###############################
# it copies only one file given as $1
# save given option 1
FILEPATH=$1

if [ "$FILEPATH" == "" ]; # check empty option -> exit
then
  echo -e "\033[0;31mI can't do something. No file to process!\nUsage with relative path like: ./makeOtherChip.sh  ./structure/templates.php\033[0m"
  exit 1
elif ! [ -a "$FILEPATH" ];# check existance -> exit
then
  echo -e "\033[0;31mI can't do something. \033[4;31m$FILEPATH\033[0;31m not found!\nUsage with relative path like: ./makeOtherChip.sh  ./structure/templates.php\033[0m"
  exit 1
elif  [ -d "$FILEPATH" ];# check if directory was given -> exit
then
  echo -e "\033[0;31mI can't do something. '$FILEPATH' is a \033[4;31mdirectory\033[0;31m NOT a single file!\nUsage with relative path like: ./makeOtherChip.sh  ./structure/templates.php\033[0m"
  exit 1
elif  [ "${FILEPATH##*/}" == "morphology.php" ]
then
  echo -e "\033[0;31mI can't do something. '${FILEPATH##*/}' should be edited manually.\033[0m"
  exit 1
else
## prepare for adults & larvae
  for insectStage in adults pupae; do
    dirTarget=${FILEPATH%*/*}
    dirTarget=${dirTarget/larvae/$insectStage}
    # (Uppercase) adults -> Adults
    insectStageCase=`echo ${insectStage:0:1} | tr [:lower:] [:upper:]`
    insectStageCase=$insectStageCase${insectStage:1}
  # echo $insectStageCase
    if ! [ -d "../"$insectStage${dirTarget#*.} ];# check if directory was given -> exit
      then
      echo -e "\033[0;31mI can't do something. Directory '../$insectStage${dirTarget#*.}' is \033[4;31mnot existing\033[0;31m!\nUsage with relative path like: ./makeOtherChip.sh  ./structure/templates.php\033[0m"
      exit 1
    fi
      echo -e "\033[0;47mI prepare for $insectStage...\033[0m"
    if [ ${FILEPATH##*/} = 'chirokey_larvae.pkg' ]; # extract chirokey_larvae.pkg
      then
      sed -e :a -e "s/chirokey_larvae/chirokey_$insectStage/g; s/larvae/$insectStage/g; s/Larvae/$insectStageCase/g;" $FILEPATH > "../"$insectStage"/doc/tutorials/chirokey_"$insectStage"/chirokey_"$insectStage".pkg"
      echo -e "  "${FILEPATH%*.}" copied to\n   ../"$insectStage"/doc/tutorials/chirokey_"$insectStage"/chirokey_"$insectStage".pkg"
      ../$insectStage/makedoc.sh
    else
      sed -e :a -e "s/chirokey_larvae/chirokey_$insectStage/g; s/larvae/$insectStage/g; s/Larvae/$insectStageCase/g;" $FILEPATH > "../"$insectStage${FILEPATH#*.}
      echo "  "${FILEPATH%*.}" copied to ../"$insectStage${FILEPATH#*.}
    fi
    chmod go+r ../$insectStage${FILEPATH#*.}
  done # enf for loop
  echo -e "\033[0;32m... finished! ("`date`")\033[0m"
fi

