<?
/**
 * Program's configuration/MySQL queries (unicode utf8!!!)
 *
 * Configurations of image-reduced version due to copyrights of other sources.
 * Imortant note: all files of the program use utf8 encoding. To prevend therefore
 * damage you should use an unicode compatible editor like
 * {@link http://sourceforge.net/projects/notepad-plus notepad++} or the {@link http://www.crimsoneditor.com/ crimsoneditor}
 * both also with syntax highlighting.
 * The default Notepad Editor in Windows is only a
 * crutch (File ends has to be UNIX). Wordpad instead is capable to read utf8 files
 * and the file ends correct. In contrast to Linux Windows unfortunately doesn't bother
 * about using unicode at all by default in general. Because their interest is only in their
 * own products which are desingned not to cooporate with humanity without the idea of profit.
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-06-10 09:27:51
 * @package chirokey_larvae
 * @todo seems be done: enable to run different versions in different folders like /chip/larvae20091223
 * @todo minor issue: document further detailed
 * @internal prevent to have empty lines at the end of the files after ?> it may
 * conflict with the session. Because th session must always be the first output.
 * @subpackage configuration
 */
// reduce error_reporting: without NOTES
  error_reporting(E_ERROR | E_WARNING | E_PARSE);

/**
 * Configurations
 *
 * Sets all necessary configurations for database and program settings: popup, image defaults
 * colornames...
 * @global array $config
 */
$config = array();

/**
 * Path to phpmyadmin
 *
 * Depending on PHP version > 5.2 use then phpmyadmin3 otherwise phpmyadmin2-11-4.
 * Note that PHP 5.2 and phpmyadmin2-11-4 won't work together and PHP < 5.2 does not
 * work with phpmyadmin3.
 * @global string $config['phpmyadminpath']
 */
$config['phpmyadminpath']      = PHP_VERSION >= 5.2? 'phpmyadmin3' : 'phpmyadmin2-11-4';    // host name

/**
 * Server setting (host name)
 *
 * Default "localhost".
 * @global string $config['dbserver']
 */
$config['dbserver']      = "localhost";    // host name
/**
 * Database name
 *
 * Change this if you want to run different versions of the database.
 * Default "chirokey_larvae". <b>Important:</b>
 * if a database was renamed via phpmyadmin
 * it's the case that in table `names_authors` for entry 'No reference given' ID=0 was altered
 * to any other ID from the auto increment function for ID. You must restore this to  'No
 * reference given' with ID=0 otherwise only images with a given descriptor name will be
 * shown in the key (i.e. no NULL entries).
 * @global string $config['database']
 */
$config['database']      = "chirokey_larvae"; // Database name
/**
 * MySQL user for the  database
 *
 * Change this if you want to run from a different user. Default "chiro_user".
 * @global string $config['dbuser']
 */
$config['dbuser']        = "chiro_user";   // user of database
/**
 * MySQL password for the database
 *
 * Change this if you want to run with another password
 * but you have to alter settings for MySQL as well. Default "chiroproject". Note when you
 * change this you have to change it for the MySQL database with phpmyadmin as well!
 * @global string $config['dbpassword']
 */
$config['dbpassword']    = "chiroproject"; // password of database
/**
 * Server root directory for the key
 *
 * Default "chip/larvae/". Note: directories can be renamed and
 * being set here, but the directory-level structure should not be changed.
 * @global string $config['ServerRootDir']
 */
$config['ServerRootDir'] = 'chip/larvae/';   // directory of server
/**
 * Key directory of the program
 *
 * Default "key/". This folder contains all necessary files for the key.
 * Note: directories can be renamed and
 * being set here, but the directory-level structure should not be changed.
 * @global string $config['ServerKeyDir']
 */
$config['ServerKeyDir']  = 'key/';
/**
 * Directory of taxa
 *
 * Default "imglarvae/".
 * Note: directories can be renamed and
 * being set here, but the directory-level structure should not be changed.
 * If you renamed species directory please update table characters in the
 * database with this query:
 * <code>
 * UPDATE `characters`
 *   SET ecology = REPLACE(`ecology`, '/speciesDirOld/','/speciesDirNew/'),
 *   notes = REPLACE(`notes`, '/speciesDirOld/','/speciesDirNew/');
 * </code>
 * @global string $config['dirSpec']
 */
$config['dirSpec']       = "imglarvae/";     // species directory
/**
 * Base URL of the key
 *
 * Default "http://localhost/chip/".
 * @global string $config['BaseUrl']
 */
$config['BaseUrl']       ="http://localhost/chip/"; // is with last slash: '/'
  // $config['BaseUrl'].$config['ServerRootDir'].
  // http://'.$_SERVER['SERVER_NAME'].'/'.$config['ServerRootDir'].$config['ServerKeyDir']
  // http://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'].'
  // $_SERVER['DOCUMENT_ROOT'].'/'.$config['ServerRootDir']/structure/config.php

/**
 * Colors' declaration for {color name}
 *
 * This tries to illustrate different colors given in descriptions and to use them
 * rather esyly with e.g. <code>{red orange}</code> Corresponding to 'red orange' it
 * *must* be exist an additional defined CSS class, which produces then by the parser:
 * <code><span class='redorange'>red orange</span></code>
 * This can be set in /structure/css/basic.css as CSS-class without spaces:
 * <code>
 * span.redorange {
 *   background-color:#FF7F50;
 * }
 * </code>
 * @global string $config['colornames']
 */
  $config['colornames'] = 'black|brown|brownish|light brown|dark|dark brown|blackish brown|red|bright red|light red|dark red|light orange|bright orange|pale|red orange|whitish|yellow|yellowish|yellow brown|yellow red brown|pale yellow|dark yellow|green';

// $thumb_chiro="<img src=\'../structure/img/chiro.png\' width=20 border=0> ";
// $thumb_reference="<img src=\'../structure/img/book.png\' width=20 border=0> ";

/**
 * Allowed (maximal) file size in kB
 *
 * @global integer $config['img_max_filesize']
 */
  $config['img_max_filesize'] = "150"; // kB
/**
 * Allowed (maximal) width or height of images
 *
 * @global integer $config['img_max_size']
 */
  $config['img_max_size']     = "900"; // max width/height in px
/**
 * Allowed mime-types of images
 *
 * Note: this has to correspond with {@link fileWriteDelete::writeReference()}. For each
 * image mime type a handling procedure in  {@link fileWriteDelete::writeReference()} has
 * to be defined.
 * @global array $config['img_types']
 */
  $config['img_types'][0]="image/png";
  $config['img_types'][1]="image/jpeg";
  $config['img_types'][2]="image/gif";

/**
 * Settings for popup window with text area (editing texts)
 *
 * Default width 800 (px) height 600
 * @global array $config['popup']
 */
  $config['popup']['windowWidth']   =850;// px
  $config['popup']['windowHeight']  =550;// px
  $config['popup']['TextareaWidth'] =$config['popup']['windowWidth'] -200;// px
  $config['popup']['TextareaHeight']=$config['popup']['windowHeight']-190;// px

/* images in tables, comments */
/**
 * Default angle in transparency text images
 *
 * Used for table headings.
 * @global string $config['img_text_angle']
 */
  $config['img_text_angle']=60;        /* default angle for text image */
/**
 * n-characters of comments
 *
 * Not used now. 2009-06-30 03:43:34. Suggested use in select options to shorten too long strings.
 * @global string $config['max_comment_length']
 */
  $config['max_comment_length'] = 150; /* n-characters of comments */

/* Font for reference in pictures */
/**
 * Font for reference in pictures
 *
 * @global string $config['fontpath']
 */
  $config['fontpath']=preg_replace('#(.+/)([^/]+/){0}[^/]+\.php#',"\\1\\3", __FILE__).'font/verdana.ttf';
  $config['fontsize']=11;//in px

/**
 * Language characters (eg. for menu in popup.php)
 *
 * Is an array with languages. Use international URL code extension
 * used also in the internet: 'de', 'ru', 'us' and so on.
 * @global array $config['languages']
 */
$config['languages'] = array();

/**
 * Default language characters (eg. for menu in popup.php)
 *
 * See the PHP array key in configuration variable {@link $config['languages']['keys']}.
 * @global array $config['languages']['default']
 */
$config['languages']['default'] = 'sy';

/**
 * Language characters keys (eg. for menu in popup.php)
 *
 * I recommend to use international abbreviations such as 'ru', 'cn', 'eu' and so on.
 * If you want to add a new character set, add a new unique 'mykey' => 'My peculiar characters' and
 * use 'mykey' to define a new character set with spaced characters like
 * <code>$config['languages']['mykey'] = "n e w c h a r a c t e r s";</code>
 * Then you should hav a new character set available.
 * @global array $config['languages']['keys']
 */
$config['languages']['keys'] = array(
  "ru" => "Russian characters",
  "eu" => "European characters",
  "sy" => "Symbol characters",
);
/**
 * Russian language characters (eg. for menu in popup.php)
 *
 * @global array $config['languages']['ru']
 */
$config['languages']['ru'] = "а б в г д е ж з и й к л м н о п р с т у ф х ц ч ш щ ъ ы ь э ю я ё ї";
/**
 * Europe language characters (eg. for menu in popup.php)
 *
 * @global array $config['languages']['eu']
 */
$config['languages']['eu'] = "à á â ä å æ ā ą ǎ ç ć ĉ č ď è é ê ë ì í î ǐ ï ĩ ī ĵ ł ñ ò ó ô ǒ õ ö ō ø œ ŕ ř ś ŝ š ß ù ú û ǔ ü ũ ŭ ů ý ÿ ŷ ỳ ź ž";
/**
 * Symbol characters (eg. for menu in popup.php)
 *
 * <b>Important:</b> you need also unicode compatible browsers to display the characters
 * properly. If you see only boxes instead of characters use unicode fonts or another browser.
 * I tested once Internet Explorer 6 but there was no proper display possible. With Opera
 * everything was fine (on Linux).
 * @global array $config['languages']['sy']
 */
$config['languages']['sy'] = "¹ ² ³ ⁵ ⁶ ⁷ ⁸ ⁹ ⁰ ⁺ ⁻ ⁼ ⁽ ⁾ ₀ ₁ ₂ ₃ ₄ ₅ ₆ ₇ ₈ ₉ ₊ ₋ ₌ ₍ ₎ ± · ÷ × ½ ¼ ⅓ ⅔ √ ∞ ∑ ≈ ≉ ≡ ≤ ≥ ≦ ≧ 〈 〉 ← ↓ → ↑ | ° α β γ δ ε ζ η θ ι κ λ μ ν ξ ο π ρ ς σ τ υ φ χ ψ ω † ‡ ℃ ℉ № Ⅰ Ⅱ Ⅲ Ⅳ Ⅴ Ⅵ Ⅶ Ⅷ Ⅸ Ⅹ Ⅺ Ⅻ Ⅼ Ⅽ Ⅾ Ⅿ ☠ ☺ ☹ ♀ ♂ ⚥ ☾ ☽ ☼ ◔ ◑ ◕ ⚗ ⚘ ∢ ✔ ‰ ㎍ ㎎ ㎏ ㎐ ㎑ ㎟ ㎠ ㎡ ㎞ ㎝ ㎜ ㎛ ㍴ ㎧ ㎣ ㎤ ㎥ ㎦ ㎧ ㏒";


/**
 * Some debug information (for developers)
 *
 * Information about queries and time consumation of the PHP parser.
 * Values: true or false. Is stored in a $_SESSION
 * @global array $config['debug']
 */
  $config['debug']  = FALSE ; // true|false
/**
 * MySQL Queries
 *
 * Different queries used to connect to the database. If something is wrong or queries are
 * too slow you can analyse manually MySQL's behavior by <code>EXPLAIN SELECT ...</code> or
 * <code>DESCRIBE SELECT ...</code> If you reorder SELECT-statemanet in <var>FROM `table1`, `table2`</var> anew it is
 * possible to force MySQL's SELECT to be faster with <code>SELECT STRAIGHT_JOIN ...</code>
 * But it is only necessary if the MySQL analyser will fail to optimize the SELECT query.
 * @global array $MysqlSelect
 */
$MysqlSelect = array();

/**
 * Query table <var>names_genera</var> gernera + ID
 *
 * @global array $MysqlSelect['GeneraToIdAll']
 * @annotation $MysqlSelect['GeneraToIdAll']
 */
$MysqlSelect['GeneraToIdAll'] = "
SELECT
  `names_genera`.`name`,
  `names_genera`.`id`
FROM `names_genera`
ORDER BY `name` ASC;
";
$MysqlSelect['SpeciesIdName'] = "SELECT `id`, `name` FROM `names_species`  ORDER BY `name` ASC;";
$MysqlSelect['TribeNames']    = "SELECT `id`, `name` FROM `names_tribe`    ORDER BY `name` ASC;";
$MysqlSelect['SubtribeNames'] = "SELECT `id`, `name` FROM `names_subtribe` ORDER BY `name` ASC;";
$MysqlSelect['SubgenusNames'] = "SELECT `id`, `name` FROM `names_subgenus` ORDER BY `name` ASC;";
$MysqlSelect['MorphoIdShortLong'] ="SELECT `id`,`morph_short`, `morph_long` FROM `morph_attrib` ORDER BY `morph_long` ASC;";
/**
 * Query valid gernera + subfamily
 *
 * It fetches only valid genera names, not all genera from table names_genera.
 * Note that `names_valid`.`id` is needed in context of Genus sp.  not `names_valid`.`genus_name_id`!
 * @global array $MysqlSelect['GeneraValidId']
 * @annotation $MysqlSelect['GeneraValidId']
*/
$MysqlSelect['GeneraValidId'] = "
SELECT STRAIGHT_JOIN
  `names_genera`.`name` AS 'genus_name',
  `names_valid`.`genus_name_id` AS 'genus_valid_id',
  `names_valid`.`id` AS 'valid_id',
  `names_subfamily`.`name_short` AS 'subfamily_short'
FROM `names_subfamily`,  `names_valid`, `names_genera`
WHERE
  `names_genera`.`id`=`names_valid`.`genus_name_id` AND
  `names_subfamily`.`id`=`names_valid`.`subfamily_name_id` AND
  `names_valid`.`species_name_id` = 192 AND
  `names_valid`.`subgenus_name_id` IS NULL
ORDER BY `genus_name`,'valid_id' ASC;
";
# @annotation $MysqlSelect['TaxaValidId']
$MysqlSelect['TaxaValidId'] ="
SELECT `names_valid`.`id`,
  CONCAT(`names_genera`.`name`, ' ',`names_species`.`name`, ' (',`names_subfamily`.`name_short`, ')') AS 'taxon'
FROM `names_subfamily`
 LEFT JOIN `names_valid` ON `names_subfamily`.`id` = `names_valid`.`subfamily_name_id`
 LEFT JOIN `names_genera` ON `names_valid`.`genus_name_id` = `names_genera`.`id`
 LEFT JOIN `names_species` ON `names_valid`.`species_name_id` = `names_species`.`id`
ORDER BY `names_genera`.`name`, `names_species`.`name`;
";
# @annotation $MysqlSelect['GeneraSynoCounted']
/**
 * Query table <var>names_synonyms</var> gernera + #species
 *
 * @global array $MysqlSelect['GeneraSynoCounted']
 */
$MysqlSelect['GeneraSynoCounted'] = "
SELECT
  CONCAT(`names_genera`.`name`, ' (',COUNT(`names_synonyms`.`species_name_id`),')') AS 'genus_name',
  `names_genera`.`id` AS 'genus_id'
FROM `names_synonyms`
 LEFT JOIN `names_genera` ON `names_synonyms`.`genus_name_id` = `names_genera`.`id`
  GROUP BY `names_synonyms`.`genus_name_id`
  ORDER BY 'genus_name';
";

# @annotation $MysqlSelect['GeneraValidIdDesc']
$MysqlSelect['GeneraValidIdDesc']="
SELECT STRAIGHT_JOIN
  `names_genera`.`name` AS 'genus_name',
  `names_valid`.`id` AS 'valid_id',
  `names_subfamily`.`name_short` AS 'subfamily_short'
FROM `names_valid`, `names_genera`, `names_subfamily`
WHERE
  `names_genera`.`id`=`names_valid`.`genus_name_id` AND
  `names_subfamily`.`id`=`names_valid`.`subfamily_name_id` AND
  `names_valid`.`species_name_id` =192 AND
  `names_valid`.`subgenus_name_id` IS NULL
ORDER BY `valid_id` DESC;
";
# @annotation $MysqlSelect['GeneraValidIdDescPreg']
$MysqlSelect['GeneraValidIdDescPreg']="
SELECT
  CONCAT('/(?>',`names_genera`.`name`,')/') AS 'genus_name',
  `names_valid`.`id` AS 'valid_id',
  `names_subfamily`.`name_short` AS 'subfamily_short'
FROM `names_genera`, `names_valid`, `names_subfamily`
WHERE
  `names_genera`.`id`=`names_valid`.`genus_name_id` AND
  `names_subfamily`.`id`=`names_valid`.`subfamily_name_id` AND
  `names_valid`.`species_name_id` =192 AND
  `names_valid`.`subgenus_name_id` IS NULL
 ORDER BY `valid_id` DESC;
";
# @annotation $MysqlSelect['SubfamiliesCount']
$MysqlSelect['SubfamiliesCount']="
SELECT
  `names_subfamily`.`id`,
  `names_subfamily`.`name`,
  `names_subfamily`.`morph_attrib_id`,
  COUNT(`names_valid`.`id`) AS 'counted_genera'
FROM `names_valid`
LEFT JOIN `names_subfamily` ON `names_valid`.`subfamily_name_id`=`names_subfamily`.`id`
WHERE `names_valid`.`species_name_id`=192
GROUP BY `subfamily_name_id`
ORDER BY `names_subfamily`.`name` ASC
;";

# @annotation $MysqlSelect['Synonyms']
/**
  * MySQL queries to compose synonyms
  *
  * It uses the variable $addMySQL to add for instance
  * <code>$addMySQL = "AND `synonyms`.`note` LIKE 'this%'";</code>
  * @global string $MysqlSelect['Synonyms']
  */
$MysqlSelect['Synonyms']="
SELECT
  CONCAT(
    `synonyms`.`genus_name`, ' ',
    `synonyms`.`species_name`
  ) AS 'synonym_name',
  `synonyms`.`authors_short` AS 'synonym_author',
  CONCAT(
    `names_genera`.`name`,' ',
    `names_species`.`name`
  ) AS 'valid_name',
    CONCAT(
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
        `names_authors`.`authors_short`,
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
      ) AS 'valid_author',
  `synonyms`.`note`,
  `synonyms`.`synonym_id`,
  `synonyms`.`author_id` AS 'synonym_author_id',
  `names_authors`.`id` AS 'valid_author_id'
FROM
  `names_genera`,
  `names_valid` ,
  `names_authors`,
  `names_species`,
  (
    SELECT
      `names_synonyms`.`id` AS 'synonym_id',
      `names_synonyms`.`valid_name_id`,
      `names_genera`.`name` AS 'genus_name',
      `names_species`.`name` AS 'species_name',
      `names_synonyms`.`note` AS 'note',
      `names_authors`.`authors_short`,
      `names_authors`.`id` AS 'author_id'
    FROM `names_synonyms`
      LEFT JOIN `names_authors` ON `names_synonyms`.`author_name_id` = `names_authors`.`id`
      LEFT JOIN `names_genera` ON `names_synonyms`.`genus_name_id` = `names_genera`.`id`
      LEFT JOIN `names_species` ON `names_synonyms`.`species_name_id` = `names_species`.`id`
  ) AS `synonyms`
 WHERE
  `names_genera`.`id` = `names_valid`.`genus_name_id` AND
  `names_valid`.`descriptor_name_id` = `names_authors`.`id` AND
  `names_valid`.`species_name_id` = `names_species`.`id` AND
  `synonyms`.`valid_name_id` = `names_valid`.`id` ".$addMySQL."
ORDER BY   CONCAT(
    `synonyms`.`genus_name`, ' ',
    `synonyms`.`species_name`,' ',
    `synonyms`.`authors_short`
  ) ASC
;";

/**
  * MySQL queries to compose subfamily taxa
  */
# @annotation $MysqlSelect['ShowSpeciesBySubfamily']
$MysqlSelect['ShowSpeciesBySubfamily']="
SELECT STRAIGHT_JOIN
  `images`.`filename`,
  `images`.`license`,
  IFNULL(`names_valid`.`notes`,'') AS 'systematicNotes',
  IF(CHAR_LENGTH(`images`.`annote`)>".$config['max_comment_length'].", CONCAT(SUBSTRING(`images`.`annote`,1,".$config['max_comment_length']."),'...'), `images`.`annote`) AS 'annote',
    CONCAT(
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
      `tempb`.`authors_short`,
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
    )  AS 'descriptor',
  `tempb`.`id` AS 'descriptor_id',
  `temp_genera_valid`.`valid_id`,
--   `names_valid`.`id` AS 'valid_id',
  `morph_attrib`.`morph_long`,
  `morph_attrib`.`img_width_default`,
  `names_subgenus`.`name` AS 'subgenus',
  `names_genera`.`name` AS 'genus',
  `names_species`.`name` AS 'species',
  `names_authors`.`id` AS 'author_id',
  CONCAT(`names_authors`.`authors_short`,`names_authors`.`literal`) AS 'authors_short'
FROM(
  `names_subfamily`,
  `morph_attrib`,
  `images`,
  `names_authors`,
  `names_valid`,
  `names_species`,
  `names_genera`,
    (
      SELECT
        `names_genera`.`name` AS 'genus_name',
        `names_valid`.`id` AS 'valid_id',
        `names_valid`.`genus_name_id`
      FROM `names_genera`, `names_valid`, `names_subfamily`
      WHERE
        `names_genera`.`id`=`names_valid`.`genus_name_id` AND
        `names_valid`.`subfamily_name_id`=".$_GET['subfamily_id']." AND
        `names_valid`.`subfamily_name_id`=`names_subfamily`.`id` AND
        `names_valid`.`species_name_id` =192 AND
        `names_valid`.`subgenus_name_id` IS NULL
    ) AS `temp_genera_valid`,
    (
      SELECT
         CONCAT(`authors_short`,`literal`) AS 'authors_short',
        `id`
        FROM `names_authors`
    ) AS
    `tempb`)
  LEFT JOIN `names_subgenus` ON `names_valid`.`subgenus_name_id`=`names_subgenus`.`id`
WHERE
  (`names_valid`.`subfamily_name_id` = ".$_GET['subfamily_id']." AND
  `names_valid`.`subfamily_name_id`  = `names_subfamily`.`id`) AND
  `names_valid`.`descriptor_name_id` = `tempb`.`id`  AND
  `temp_genera_valid`.`genus_name_id`= `names_genera`.`id` AND
  `names_valid`.`genus_name_id`      = `names_genera`.`id` AND
  `names_valid`.`id`                 = `images`.`names_valid_id` AND
  `names_valid`.`species_name_id`    = `names_species`.`id` AND
  `names_authors`.`id`               = `images`.`names_authors_id` AND
  `images`.`morph_id` IN(".$_GET['morph_attrib_id'].") AND
  `images`.`morph_id`                = `morph_attrib`.`id`
ORDER BY `names_genera`.`name`,`names_species`.`name` ASC
;";
/**
  * MySQL queries to compose genus taxa
  */
# @annotation $MysqlSelect['ShowSpeciesByGenus']
$MysqlSelect['ShowSpeciesByGenus']="
SELECT STRAIGHT_JOIN
  `images`.`filename`,
  `images`.`license`,
  IFNULL(`names_valid`.`notes`,'') AS 'systematicNotes',
  IF(CHAR_LENGTH(`images`.`annote`)>".$config['max_comment_length'].", CONCAT(SUBSTRING(`images`.`annote`,1,".$config['max_comment_length']."),'...'), `images`.`annote`) AS 'annote',
    CONCAT(
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
      `tempb`.`authors_short`,
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
    )  AS 'descriptor',
  `tempb`.`id` AS 'descriptor_id',
  `morph_attrib`.`morph_long`,
  `morph_attrib`.`img_width_default`,
  `names_subgenus`.`name` AS 'subgenus',
  `names_genera`.`name` AS 'genus',
  `names_species`.`name` AS 'species',
  `names_subfamily`.`name` AS 'subfamily',
  `names_authors`.`id` AS 'names_authors_id',
  CONCAT(`names_authors`.`authors_short`,`names_authors`.`literal`) AS 'authors_short',
  `names_valid`.`id` AS 'valid_id'
FROM(
  `names_subfamily`,
  `morph_attrib`,
  `images`,
  `names_authors`,
  `names_valid`,
  `names_species`,
  `names_genera`,
    (
      SELECT
         CONCAT(`authors_short`,`literal`) AS 'authors_short',
        `id`
        FROM `names_authors`
    ) AS `tempb`,
    ( SELECT `names_valid`.`genus_name_id` FROM `names_valid`
     WHERE `names_valid`.`id`=".$_GET['genus_valid_id']."
    ) AS `temp`
  )
  LEFT JOIN `names_subgenus` ON `names_valid`.`subgenus_name_id`=`names_subgenus`.`id`
WHERE
  `tempb`.`id` =  `names_valid`.`descriptor_name_id` AND
  `names_valid`.`subfamily_name_id`=`names_subfamily`.`id` AND
  `images`.`names_valid_id`    =`names_valid`.`id` AND
  `images`.`morph_id`          IN(".$_GET['morph_attrib_id'].") AND
  `names_genera`.`id`          =`names_valid`.`genus_name_id` AND
  `names_species`.`id`         =`names_valid`.`species_name_id` AND
  `names_authors`.`id`         =`images`.`names_authors_id` AND
  `names_valid`.`genus_name_id`=`temp`.`genus_name_id` AND
  `morph_attrib`.`id`          =`images`.`morph_id`
ORDER BY `names_genera`.`name` , `names_species`.`name` ASC
";

/**
  * MySQL queries to compose specimen taxon
  */
# @annotation $MysqlSelect['SpeciesBySpecimens']
$MysqlSelect['SpeciesBySpecimens']="
SELECT STRAIGHT_JOIN
  `images`.`id` AS 'image_id',
  `images`.`filename`,
  `images`.`license`,
  IFNULL(`names_valid`.`notes`,'') AS 'systematicNotes',
  IF(CHAR_LENGTH(`images`.`annote`)>".$config['max_comment_length'].", CONCAT(SUBSTRING(`images`.`annote`,1,".$config['max_comment_length']."),'...'), `images`.`annote`) AS 'annote',
    CONCAT(
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
      `tempb`.`authors_short`,
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
    )  AS 'descriptor',
  `tempb`.`id` AS 'descriptor_id',
  `names_subfamily`.`name` AS 'subfamily',
  `names_subgenus`.`name` AS 'subgenus',
  `names_genera`.`name` AS 'genus',
  `names_species`.`name` AS 'species',
  `morph_attrib`.`morph_long`,
  `morph_attrib`.`img_width_default`,
  CONCAT(`names_authors`.`authors_short`,`names_authors`.`literal`) AS 'authors_short',
  `names_authors`.`id` AS 'authors_id',
  `images`.`names_valid_id`,
  -- get right order: first eg. mentum then others: SELECT '97,96,161,144,152,141,151,7' REGEXP '(^|[\,])4($|[\,])'
  IF(`names_subfamily`.`morph_attrib_id` REGEXP CONCAT('(^|[\,])',`morph_attrib`.`id`,'($|[\,])'),1,0) 'morph_sort'
FROM(
  `names_subfamily`,
  `morph_attrib`,
  `images`,
  `names_authors`,
  `names_valid`,
  `names_species`,
  `names_genera`,
    (
      SELECT
         CONCAT(`authors_short`,`literal`) AS 'authors_short',
        `id`
        FROM `names_authors`
    ) AS `tempb`
  )
LEFT JOIN `names_subgenus` ON `names_valid`.`subgenus_name_id`=`names_subgenus`.`id`
WHERE
  `tempb`.`id` =  `names_valid`.`descriptor_name_id` AND
  `images`.`names_valid_id`         = ".$_GET['valid_id']." AND
  `images`.`morph_id`               = `morph_attrib`.`id` AND
  `names_genera`.`id`               = `names_valid`.`genus_name_id` AND
  `names_species`.`id`              = `names_valid`.`species_name_id` AND
  `names_valid`.`id`                = `images`.`names_valid_id` AND
  `names_valid`.`subfamily_name_id` = `names_subfamily`.`id` AND
  `names_authors`.`id`              = `images`.`names_authors_id` AND
  `images`.`names_authors_id`  ".(empty($result[0]->author_id)?" IS NOT NULL": "=".$result[0]->author_id)."
ORDER BY 'morph_sort' DESC
";

/**
  * MySQL queries for clicked specimen
  */
# @annotation $MysqlSelect['SpeciesClicked']
$MysqlSelect['SpeciesClicked']="
SELECT STRAIGHT_JOIN
  `images`.`id` AS 'image_id',
  `images`.`filename`,
  `images`.`license`,
  IFNULL(`names_valid`.`notes`,'') AS 'systematicNotes',
  IF(CHAR_LENGTH(`images`.`annote`)>".$config['max_comment_length'].", CONCAT(SUBSTRING(`images`.`annote`,1,".$config['max_comment_length']."),'...'), `images`.`annote`) AS 'annote',
    CONCAT(
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
      `tempb`.`authors_short`,
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
    )  AS 'descriptor',
  `tempb`.`id` AS 'descriptor_id',
  `names_subfamily`.`name` AS 'subfamily',
  `names_subgenus`.`name` AS 'subgenus',
  `names_genera`.`name` AS 'genus',
  `names_species`.`name` AS 'species',
  `morph_attrib`.`morph_long`,
  `morph_attrib`.`img_width_default`,
  CONCAT(`names_authors`.`authors_short`,`names_authors`.`literal`) AS 'authors_short',
  `names_authors`.`id` AS 'authors_id',
  `images`.`names_valid_id`,
  -- get right order: first eg. mentum then others: SELECT '97,96,161,144,152,141,151,7' REGEXP '(^|[\,])4($|[\,])'
  IF(`names_subfamily`.`morph_attrib_id` REGEXP CONCAT('(^|[\,])',`morph_attrib`.`id`,'($|[\,])'),1,0) 'morph_sort'
FROM(
  `names_subfamily`,
  `morph_attrib`,
  `images`,
  `names_authors`,
  `names_valid`,
  `names_species`,
  `names_genera`,
    (
      SELECT
         CONCAT(`authors_short`,`literal`) AS 'authors_short',
        `id`
        FROM `names_authors`
    ) AS `tempb`
  )
LEFT JOIN `names_subgenus` ON `names_valid`.`subgenus_name_id`=`names_subgenus`.`id`
WHERE
  `tempb`.`id` =  `names_valid`.`descriptor_name_id` AND
  `images`.`names_valid_id`         = ".$_GET['valid_id']." AND
  `images`.`morph_id`               = `morph_attrib`.`id` AND
  `names_genera`.`id`               = `names_valid`.`genus_name_id` AND
  `names_species`.`id`              = `names_valid`.`species_name_id` AND
  `names_valid`.`id`                = `images`.`names_valid_id` AND
  `names_valid`.`subfamily_name_id` = `names_subfamily`.`id` AND
  `names_authors`.`id`              = `images`.`names_authors_id`
ORDER BY 'morph_sort' DESC
";
/**
  * MySQL queries for non-clicked other taxa
  */
# @annotation $MysqlSelect['SpeciesToCompareOthers']
$MysqlSelect['SpeciesToCompareOthers']="
SELECT STRAIGHT_JOIN
  `images`.`id` AS 'image_id',
  `images`.`filename`,
  `images`.`license`,
  IF(CHAR_LENGTH(`images`.`annote`)>".$config['max_comment_length'].", CONCAT(SUBSTRING(`images`.`annote`,1,".$config['max_comment_length']."),'...'), `images`.`annote`) AS 'annote',
  `images`.`license`,
  IFNULL(`names_valid`.`notes`,'') AS 'systematicNotes',
    CONCAT(
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
      `tempb`.`authors_short`,
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
    )  AS 'descriptor',
  `tempb`.`id` AS 'descriptor_id',
  `names_subfamily`.`name` AS 'subfamily',
  `names_subgenus`.`name` AS 'subgenus',
  `names_genera`.`name` AS 'genus',
  `names_species`.`name` AS 'species',
  `morph_attrib`.`morph_long`,
  `morph_attrib`.`img_width_default`,
  CONCAT(`names_authors`.`authors_short`,`names_authors`.`literal`) AS 'authors_short',
  `names_authors`.`id` AS 'authors_id',
  `images`.`names_valid_id`,
  -- get right order: first eg. mentum then others: SELECT '97,96,161,144,152,141,151,7' REGEXP '(^|[\,])4($|[\,])'
  IF(`names_subfamily`.`morph_attrib_id` REGEXP CONCAT('(^|[\,])',`morph_attrib`.`id`,'($|[\,])'),1,0) 'morph_sort'
FROM(
  `names_subfamily`,
  `morph_attrib`,
  `images`,
  `names_authors`,
  `names_valid`,
  `names_species`,
  `names_genera`,
    (
      SELECT
         CONCAT(`authors_short`,`literal`) AS 'authors_short',
        `id`
        FROM `names_authors`
    ) AS `tempb`
  )
LEFT JOIN `names_subgenus` ON `names_valid`.`subgenus_name_id`=`names_subgenus`.`id`
WHERE
  `tempb`.`id` =  `names_valid`.`descriptor_name_id` AND
  `names_valid`.`subfamily_name_id` = `names_subfamily`.`id` AND
  `names_species`.`id`              = `names_valid`.`species_name_id` AND
  `names_genera`.`id`               = `names_valid`.`genus_name_id` AND
  `names_valid`.`id`                = `images`.`names_valid_id` AND
  `images`.`morph_id`               = `morph_attrib`.`id` AND
  `names_authors`.`id`              = `images`.`names_authors_id` AND
  `names_genera`.`id` =
(
  SELECT
    `names_valid`.`genus_name_id`
  FROM
    `names_valid`
  WHERE
    `names_valid`.`id` = ".$_GET['valid_id']."
)
ORDER BY 'genus' ASC , 'species' ASC , 'subgenus' ASC , 'morph_sort' DESC
;";
/**
  * MySQL queries for non-clicked own genus
  */
# @annotation $MysqlSelect['SpeciesToCompare']
$MysqlSelect['SpeciesToCompare']="
SELECT STRAIGHT_JOIN
  `images`.`id` AS 'image_id',
  `images`.`filename`,
  `images`.`license`,
  IFNULL(`names_valid`.`notes`,'') AS 'systematicNotes',
  IF(CHAR_LENGTH(`images`.`annote`)>".$config['max_comment_length'].", CONCAT(SUBSTRING(`images`.`annote`,1,".$config['max_comment_length']."),'...'), `images`.`annote`) AS 'annote',
    CONCAT(
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
      `tempb`.`authors_short`,
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
    )  AS 'descriptor',
  `tempb`.`id` AS 'descriptor_id',
  `names_subfamily`.`name` AS 'subfamily',
  `names_subgenus`.`name` AS 'subgenus',
  `names_genera`.`name` AS 'genus',
  `names_species`.`name` AS 'species',
  `morph_attrib`.`morph_long`,
  `morph_attrib`.`img_width_default`,
  CONCAT(`names_authors`.`authors_short`,`names_authors`.`literal`) AS 'authors_short',
  `names_authors`.`id` AS 'authors_id',
  `images`.`names_valid_id`,
  -- get right order: first eg. mentum then others: SELECT '97,96,161,144,152,141,151,7' REGEXP '(^|[\,])4($|[\,])'
  IF(`names_subfamily`.`morph_attrib_id` REGEXP CONCAT('(^|[\,])',`morph_attrib`.`id`,'($|[\,])'),1,0) 'morph_sort'
FROM(
  `names_subfamily`,
  `morph_attrib`,
  `images`,
  `names_authors`,
  `names_valid`,
  `names_species`,
  `names_genera`,
    (
      SELECT
         CONCAT(`authors_short`,`literal`) AS 'authors_short',
        `id`
        FROM `names_authors`
    ) AS `tempb`
  )
LEFT JOIN `names_subgenus` ON `names_valid`.`subgenus_name_id`=`names_subgenus`.`id`
WHERE
  `tempb`.`id` =  `names_valid`.`descriptor_name_id` AND
  `names_valid`.`subfamily_name_id` = `names_subfamily`.`id` AND
  `names_species`.`id`              = `names_valid`.`species_name_id` AND
  `names_genera`.`id` = `names_valid`.`genus_name_id` AND
  `names_valid`.`id`  = `images`.`names_valid_id` AND
  `images`.`names_valid_id`!= ".$_GET['valid_id']." AND
  `images`.`morph_id`               = `morph_attrib`.`id` AND
  `names_authors`.`id`              = `images`.`names_authors_id` AND
  `names_genera`.`id`=
(
  SELECT
    `names_valid`.`genus_name_id`
  FROM
    `names_valid`
  WHERE
    `names_valid`.`id` = ".$_GET['valid_id']."
)
ORDER BY 'genus' ASC , 'species' ASC ,  'subgenus' ASC , 'morph_sort' DESC
;";

# @annotation $MysqlSelect['Images']
$MysqlSelect['Images']="
SELECT STRAIGHT_JOIN
  `images`.`id` AS 'image_id',
  `images`.`filename`,
  `images`.`time_added`,
  IFNULL(CONCAT('modified: ',`images`.`time_modified`),'') AS 'time_modified',
    CONCAT(
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
      `tempb`.`authors_short`,
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
    )  AS 'descriptor',
  `tempb`.`id` AS 'descriptor_id',
  CONCAT(
    IFNULL(`names_genera`.`name`,''),' ',
    IFNULL(`names_subgenus`.`name`,''),' ',
    `names_species`.`name`
  ) AS 'taxon',
  `morph_attrib`.`morph_long`,
  CONCAT(`names_authors`.`authors_short`,`names_authors`.`literal`) AS 'authors_short',
  `names_authors`.`id` AS 'authors_id',
  `names_authors`.`title` AS 'title',
  `names_authors`.`journal` AS 'journal',
  `images`.`names_valid_id`
FROM(
  `names_subfamily`,
  `morph_attrib`,
  `images`,
  `names_authors`,
  `names_valid`,
  `names_species`,
  `names_genera`,
    (
      SELECT
         CONCAT(`authors_short`,`literal`) AS 'authors_short',
        `id`
        FROM `names_authors`
    ) AS `tempb`
  )
LEFT JOIN `names_subgenus` ON `names_valid`.`subgenus_name_id`=`names_subgenus`.`id`
WHERE
  `tempb`.`id` =  `names_valid`.`descriptor_name_id` AND
  `images`.`morph_id`               = `morph_attrib`.`id` AND
  `names_genera`.`id`               = `names_valid`.`genus_name_id` AND
  `names_species`.`id`              = `names_valid`.`species_name_id`
  ".(($_POST['genus_valid_id']=='NULL')?"":" AND names_valid.genus_name_id   = ".$_POST['genus_valid_id'])." ".(($_POST['species_id']=='NULL')?" AND names_valid.species_name_id   = 192 ":" AND names_valid.species_name_id   = ".$_POST['species_id'])." AND
  `names_valid`.`id`                = `images`.`names_valid_id` AND
  `names_valid`.`subfamily_name_id` = `names_subfamily`.`id` AND
  `names_authors`.`id`              = `images`.`names_authors_id`
ORDER BY 'authors_short', 'morph_long' ASC;";

# @annotation $MysqlSelect['TaxaExistInCharacters']
/**
  * Show data in table characters
  *
  * @global string $MysqlSelect['TaxaExistInCharacters']
  */
$MysqlSelect['TaxaExistInCharacters'] = "
  SELECT
  `characters`.`id` ,
  `names_genera`.`name` AS 'genus',
  CONCAT(
    '<em>',
    `names_genera`.`name`, ' ' ,
    IFNULL(CONCAT('(', `names_subgenus`.`name`,') '), ''),
    `names_species`.`name`,
    '</em>',
    IFNULL(CONCAT(' from {citeID|',`names_authors`.`id`,'|', `names_authors`.`authors_short`,'}'), ''),
    IFNULL(`names_authors`.`literal`,'')
  ) AS 'taxon',
  CONCAT(
    IFNULL(`names_authors`.`authors_short`, ''),
    IFNULL(`names_authors`.`literal`,'')
  ) AS 'author',
  IFNULL(`names_authors`.`id`,'NULL') AS 'id_author',
  CONCAT(
    `names_genera`.`name`, ' ' ,
    IFNULL(CONCAT('(', `names_subgenus`.`name`,') '), ''),
    `names_species`.`name`
  ) AS 'taxon_simple',
  `names_valid`.`id` AS 'names_valid_id'
FROM `names_valid`
  LEFT JOIN `names_genera`   ON `names_valid`.`genus_name_id`    = `names_genera`.`id`
  LEFT JOIN `names_species`  ON `names_valid`.`species_name_id`  = `names_species`.`id`
  LEFT JOIN `names_subgenus` ON `names_valid`.`subgenus_name_id` = `names_subgenus`.`id`
  LEFT JOIN `characters`     ON `names_valid`.`id`               = `characters`.`names_valid_id`
  LEFT JOIN `names_authors`  ON `names_authors`.`id` = `characters`.`names_authors_id`
WHERE `names_valid`.`genus_name_id` = (
  SELECT `names_valid`.`genus_name_id`
    FROM `names_valid`
    WHERE
      `names_valid`.`id` = ".$_GET['genus_valid_id']."
  ) AND
      `names_valid`.`species_name_id` != 192
  ORDER BY 'taxon'
;";

# @annotation $MysqlSelect['GenusCharacters']
/**
  * Fetch characters of Genus sp.
  *
  * @global string $MysqlSelect['GenusCharacters']
  */
$MysqlSelect['GenusCharacters']="
SELECT STRAIGHT_JOIN
  `names_genera`.`name` AS 'genus',
  `names_subfamily`.`name` AS 'subfamily',
  `characters`.`notes` ,
  `characters`.`id` AS 'id_characters',
  `characters`.`ecology`,
  `characters`.`similar`
FROM  `names_subfamily`,`names_genera`,`names_valid`, `characters`
WHERE
  `names_valid`.`id`=".$_GET['genus_valid_id']." AND
  `names_valid`.`species_name_id`='192' AND
  `names_valid`.`genus_name_id`=`names_genera`.`id` AND
  `names_valid`.`subfamily_name_id`=`names_subfamily`.`id` AND
  `characters`.`names_valid_id`=`names_valid`.`id` AND
  `names_valid`.`subgenus_name_id` IS NULL
  LIMIT 1;
";

# @annotation $MysqlSelect['SpecimenCharacters']
/**
  * Fetch for select list for specimens
  *
  * @global string $MysqlSelect['SpecimenCharacters']
  */
$MysqlSelect['SpecimenCharacters']="
SELECT
  `characters`.`id` AS 'id_characters',
  `names_valid`.`id` 'names_valid_id',
  CONCAT(
    `names_genera`.`name`, ' ',
      IFNULL(CONCAT('(', `names_subgenus`.`name`, ') '),''),  `names_species`.`name`
  )  AS 'specimen',
  IFNULL(`names_subfamily`.`name`, 'no subfamily name given') AS 'subfamily',
  IFNULL(`names_authors`.`authors_short`, 'no special author') AS 'author',
    CONCAT(
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
      `tempb`.`authors_short`,
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
    )  AS 'descriptor'
FROM (
  `characters`,
    (
      SELECT
         CONCAT(`authors_short`,`literal`) AS 'authors_short',
        `id`
        FROM `names_authors`
    ) AS `tempb`
  )
LEFT JOIN `names_authors`   ON `characters`.`names_authors_id`   = `names_authors`.`id`
LEFT JOIN `names_valid`     ON `characters`.`names_valid_id`     = `names_valid`.`id`
LEFT JOIN `names_genera`    ON `names_valid`.`genus_name_id`     = `names_genera`.`id`
LEFT JOIN `names_species`   ON `names_valid`.`species_name_id`   = `names_species`.`id`
LEFT JOIN `names_subfamily` ON `names_valid`.`subfamily_name_id` = `names_subfamily`.`id`
LEFT JOIN `names_subgenus`  ON `names_valid`.`subgenus_name_id`  = `names_subgenus`.`id`
WHERE (
  `characters`.`names_valid_id` =".$_GET['valid_id']." AND
  `names_valid`.`descriptor_name_id` = `tempb`.`id`
)";
#".(isset($_GET['id_characters'])? " `characters`.`id` = ".$_GET['id_characters']." AND ": "")."

# @annotation $MysqlSelect['SpecimenCharactersSingle']
/**
  * Fetch characters for a  single specimen
  *
  * @global string $MysqlSelect['SpecimenCharactersSingle']
  */
$MysqlSelect['SpecimenCharactersSingle']="
SELECT
  `characters`.`id` AS 'id_characters',
  `characters`.`names_authors_id` AS 'author_id',
  `characters`.`ecology`,
  `characters`.`notes`,
  `names_valid`.`id` AS 'names_valid_id',
  `names_genera`.`name` AS 'genus',
  `temp_genera_valid`.`valid_id` AS `genus_valid_id`,
  CONCAT(
    `names_genera`.`name`, ' ',
      IFNULL(CONCAT('(', `names_subgenus`.`name`, ') '),''),  `names_species`.`name`
  )  AS 'specimen',
  IFNULL(`names_subfamily`.`name`, 'no subfamily name given') AS 'subfamily',
  IFNULL(`names_authors`.`authors_short`, 'no special author') AS 'author',
  IFNULL(`names_authors`.`id`, 'NULL') AS 'id_author',
    CONCAT(
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
      `tempb`.`authors_short`,
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
    )  AS 'descriptor'
FROM (
  `characters`,
    (
      SELECT
         CONCAT(`authors_short`,`literal`) AS 'authors_short',
        `id`
        FROM `names_authors`
    ) AS `tempb`,
    (
      SELECT STRAIGHT_JOIN
        `names_genera`.`name` AS 'genus_name',
        `names_valid`.`genus_name_id` ,
        `names_valid`.`id` AS 'valid_id',
        `names_subfamily`.`name_short` AS 'subfamily_short'
      FROM `names_subfamily`,  `names_valid`, `names_genera`
      WHERE
        `names_genera`.`id`=`names_valid`.`genus_name_id` AND
        `names_subfamily`.`id`=`names_valid`.`subfamily_name_id` AND
        `names_valid`.`species_name_id` = 192 AND
        `names_valid`.`subgenus_name_id` IS NULL
      ORDER BY `genus_name`,`valid_id` ASC
    ) AS `temp_genera_valid`
  )
LEFT JOIN `names_authors`   ON `characters`.`names_authors_id`   = `names_authors`.`id`
LEFT JOIN `names_valid`     ON `characters`.`names_valid_id`     = `names_valid`.`id`
LEFT JOIN `names_genera`    ON `names_valid`.`genus_name_id`     = `names_genera`.`id`
LEFT JOIN `names_species`   ON `names_valid`.`species_name_id`   = `names_species`.`id`
LEFT JOIN `names_subfamily` ON `names_valid`.`subfamily_name_id` = `names_subfamily`.`id`
LEFT JOIN `names_subgenus`  ON `names_valid`.`subgenus_name_id`  = `names_subgenus`.`id`
WHERE (
  `characters`.`names_valid_id` =".$_GET['valid_id']." AND
   ".(isset($_GET['id_characters'])? " `characters`.`id` = ".$_GET['id_characters']." AND ": "")."
  `names_valid`.`descriptor_name_id` = `tempb`.`id` AND
  `temp_genera_valid`.`genus_name_id`= `names_genera`.`id`
)
LIMIT 1
";


# @annotation $MysqlSelect['SpeciesImages']
$MysqlSelect['SpeciesImages']="
SELECT STRAIGHT_JOIN
  CONCAT(`names_genera`.`name`,' ',`names_species`.`name`,' (',`morph_attrib`.`morph_long`,') ',  `names_authors`.`authors_short`,`names_authors`.`literal`
 ) AS 'species',
  CONCAT('<img align=\\'middle\\' alt=\\'',`names_genera`.`name`,' ',`names_species`.`name`,' (',`morph_attrib`.`morph_long`,')\\' width=',`morph_attrib`.`img_width_default`,' title=\\'',`names_genera`.`name`,' ',`names_species`.`name`,' ','(',`morph_attrib`.`morph_long`,') ',`names_authors`.`authors_short`,`names_authors`.`literal` ,'\\' src=\\'../../".$config['dirSpec']."',`images`.`filename`,'\\' >') AS 'imagefile',
  CONCAT('Img:',`images`.`filename`) AS 'imagefileshort'
FROM `names_genera`
 LEFT JOIN `names_valid` ON `names_genera`.`id` = `names_valid`.`genus_name_id`
 LEFT JOIN `names_species` ON `names_valid`.`species_name_id` = `names_species`.`id`
 LEFT JOIN `images` ON `names_valid`.`id` = `images`.`names_valid_id`
 LEFT JOIN `names_authors` ON `images`.`names_authors_id` = `names_authors`.`id`
 LEFT JOIN `morph_attrib` ON `images`.`morph_id` = `morph_attrib`.`id`
WHERE `names_genera`.`id` IN(
  SELECT `names_genera`.`id`
  FROM `names_valid`
  LEFT JOIN `names_genera` ON `names_valid`.`genus_name_id` = `names_genera`.`id`
  WHERE (`names_valid`.`id` =".$_GET['genus_valid_id'].")
  )
ORDER BY `names_species`.`name` ASC, `morph_attrib`.`morph_long` ASC";

# @annotation $MysqlSelect['AllSpeciesImages']
$MysqlSelect['AllSpeciesImages']="
SELECT STRAIGHT_JOIN
  CONCAT('Img:',`images`.`filename`) AS 'filename',
  CONCAT('<img align=\\\\\'middle\\\\\' alt=\\\\\'',`names_genera`.`name`,' ',`names_species`.`name`,' (',`morph_attrib`.`morph_long`,')\\\\\' width=',`morph_attrib`.`img_width_default`,' title=\\\\\'',`names_genera`.`name`,' ',`names_species`.`name`,' ','(',`morph_attrib`.`morph_long`,') ',`names_authors`.`authors_short`,`names_authors`.`literal` ,'\\\\\' src=\\\\\'../../".$config['dirSpec']."',`images`.`filename`,'\\\\\' >') AS 'imageToReplace'
FROM `morph_attrib`, `images`, `names_authors`, `names_valid`, `names_genera`, `names_species`
 WHERE `morph_attrib`.`id`             = `images`.`morph_id`   AND
  `images`.`names_authors_id`     = `names_authors`.`id`  AND
  `images`.`names_valid_id`       = `names_valid`.`id`    AND
  `names_valid`.`genus_name_id`   = `names_genera`.`id`   AND
  `names_valid`.`species_name_id` = `names_species`.`id`;
";

# @annotation $MysqlSelect['ReferencesReplace']
$MysqlSelect['ReferencesReplace']="
SELECT
  `id`,
  CONCAT(`authors_short`,`literal`) AS 'authors_short'
FROM `names_authors`
WHERE id != 0
  ORDER BY `names_authors`.`authors_short`, `names_authors`.`year`,`names_authors`.`title` ASC;
";
# @annotation $MysqlSelect['ReferencesReplace']
$MysqlSelect['ReferencesCompleteString']="
SELECT
  `id`,
   CONCAT( author_names,' (',year,literal,'):<br> ',
   IFNULL(CONCAT('<em>', title, '</em><br>'), '<strong><em>No reference given</em></strong>'),' ', IFNULL(journal, ''),
   IFNULL(CONCAT(', No:', number),''),
   IFNULL(CONCAT(', Vol:', volume),''),
   IFNULL(CONCAT(', Page(s): ',page), '')
   ) AS 'reference',
  CONCAT(`authors_short`,`literal`) AS 'authors_short'
FROM `names_authors`
WHERE id != 0
  ORDER BY `names_authors`.`authors_short`, `names_authors`.`year`,`names_authors`.`title` ASC;
";
# @annotation $MysqlSelect['SpeciesName']
$MysqlSelect['SpeciesName']="
SELECT
  `id`,
  `name`
FROM `names_species`
ORDER BY `name` ASC;";

# @annotation $MysqlSelect['SubfamilyNames']
$MysqlSelect['SubfamilyNames']="SELECT    *  FROM    `names_subfamily`
  ORDER BY `name` ASC";

# @annotation $MysqlSelect['SubfamilyToGenus']
$MysqlSelect['SubfamilyToGenus']="SELECT
`names_subfamily`.`name`
FROM `names_valid`, `names_subfamily`
WHERE
`names_valid`.`subfamily_name_id` = `names_subfamily`.`id` AND
`names_valid`.`id` = ".$_GET['genus_valid_id'].";";

# @annotation $MysqlSelect['References']
$MysqlSelect['References'] = "
SELECT
  `id`,
  CONCAT(`names_authors`.`authors_short`,`names_authors`.`literal`) AS 'authors_short',
  IF(`year`=0,CONCAT(`author_names`,`literal`),CONCAT(`author_names`,' (',`year`,`literal`,')'))  AS 'author_names',
  `author_mail`,
  `author_address`,
  `editor_name`,
  `edition`,
  `publisher_name`,
  `title`,
  `journal`,
  `journal_url`,
  `page`,
  `volume`,
  `number`,
  `year`,
  `month`,
  `abstract`,
  `note`,
  `keywords` ".$searchedKeyword."
FROM
  `names_authors`
  WHERE `names_authors`.`authors_short` = `names_authors`.`authors_short` AND
  `id` != 0 -- is 'No reference given'
  ".$MySQL['addWHERE']."
  ORDER BY `names_authors`.`authors_short`, `names_authors`.`year`,`names_authors`.`title` ASC
  ".$MySQL['addLIMIT']."
";

// $MysqlSelect['ShowStructures']="SELECT
//   `id`,
//   CONCAT('show ',`morph_long`) AS 'show_morph_long'
//   FROM `morph_attrib`
//   WHERE `morph_select`='1' ORDER BY `morph_long`;
// ";
# @annotation $MysqlSelect['ShowStructures']
$MysqlSelect['ShowStructures']="SELECT
  GROUP_CONCAT(`morph_attrib`.`id`) AS 'id',
  CONCAT('show ',`morpho_core`.`morph_long`) AS 'show_morph_long'
FROM `morph_attrib`,
(SELECT
  `id`,
  `morph_long`
   FROM `morph_attrib`
  WHERE `morph_select`='1'
 ORDER BY `morph_long`
) AS `morpho_core`
WHERE
`morph_attrib`.`morph_long` LIKE CONCAT(`morpho_core`.`morph_long`,'%')
GROUP BY `morpho_core`.`morph_long`
ORDER BY `morph_attrib`.`morph_long` ASC;
";

# @annotation $MysqlSelect['AlreadyInDatabaseNamesValid']
$MysqlSelect['AlreadyInDatabaseNamesValid']="
SELECT
CONCAT(
  CONCAT(`names_genera`.`id`, '|', 'genus_id'), '!',
  CONCAT(`names_species`.`id`, '|', 'species_id') , '!',
  CONCAT(`names_subfamily`.`id`, '|', 'subfamily_id' ) , '!',
  CONCAT(IFNULL(`names_tribe`.`id`,'NULL'), '|', 'tribe_id') , '!',
  CONCAT(IFNULL(`names_subtribe`.`id`,'NULL'), '|', 'subtribe_id'), '!',
  CONCAT(IFNULL(`names_subgenus`.`id`,'NULL'), '|', 'subgenus_id') , '!',
  CONCAT(IFNULL(`names_authors`.`id`,0), '|', 'descriptor_id' ), '!',
  CONCAT(IFNULL(`names_valid`.`in_brackets`,IF(`names_authors`.`id`=NULL,'0', 'NULL')), '|', 'in_brackets'), '!',
  CONCAT(IFNULL(`names_valid`.`notes`,''), '|','annote'), '!',
  CONCAT(`names_valid`.`id`, '|', 'valid_id')
) AS 'value' ,
CONCAT(
  `names_genera`.`name`, ' ', IFNULL(CONCAT('(', `names_subgenus`.`name`, ')'),''), ' ', `names_species`.`name`, ' ',
  IFNULL(
    CONCAT(
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
      `names_authors`.`authors_short`,
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),', ','), ')
    ), 'No reference given ,'
  ),
  IFNULL(CONCAT('Subfamily: ', `names_subfamily`.`name`), 'Subfamily: ???'),
  IFNULL(CONCAT(', Tribe: ', `names_tribe`.`name`),', Tribe: ???')
) AS 'text',
`names_valid`.`id` AS 'valid_id',
CONCAT(
  `names_genera`.`name`, ' ', IFNULL(CONCAT('(', `names_subgenus`.`name`, ')'),''), ' ', `names_species`.`name`, ' ',
  IFNULL(
    CONCAT(
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
      `names_authors`.`authors_short`,
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
    ), 'No reference given'
  )
) AS 'valid_name'
FROM `names_valid`
 LEFT JOIN `names_authors`   ON `names_valid`.`descriptor_name_id` = `names_authors`.`id`
 LEFT JOIN `names_genera`    ON `names_valid`.`genus_name_id`      = `names_genera`.`id`
 LEFT JOIN `names_species`   ON `names_valid`.`species_name_id`    = `names_species`.`id`
 LEFT JOIN `names_subfamily` ON `names_valid`.`subfamily_name_id`  = `names_subfamily`.`id`
 LEFT JOIN `names_subgenus`  ON `names_valid`.`subgenus_name_id`   = `names_subgenus`.`id`
 LEFT JOIN `names_tribe`     ON `names_valid`.`tribe_name_id`      = `names_tribe`.`id`
 LEFT JOIN `names_subtribe`  ON `names_valid`.`subtribe_name_id`   = `names_subtribe`.`id`
ORDER BY `names_genera`.`name`,  `names_species`.`name` ASC;
";
// help for upload images
# @annotation $MysqlSelect['AlreadyInDatabase']
$MysqlSelect['AlreadyInDatabase']="
SELECT
CONCAT(
  CONCAT(`names_genera`.`id`, '|', 'genus_valid_id'), '!',
  CONCAT(`names_species`.`id`, '|', 'species_id') , '!',
  CONCAT(`names_subfamily`.`id`, '|', 'subfamily_id' ) , '!',
  CONCAT(IFNULL(`names_tribe`.`id`,'NULL'), '|', 'tribe_id') , '!',
  CONCAT(IFNULL(`names_subtribe`.`id`,'NULL'), '|', 'subtribe_id'), '!',
  CONCAT(IFNULL(`names_subgenus`.`id`,'NULL'), '|', 'subgenus_id') , '!',
  CONCAT(IFNULL(`names_authors`.`id`,0), '|', 'authors_names_id_descriptor' ), '!',
  CONCAT(IFNULL(`names_valid`.`in_brackets`,IF(`names_authors`.`id`=NULL,'0', 'NULL')), '|', 'in_brackets')
) AS 'value' ,
CONCAT(
  `names_genera`.`name`, ' ', IFNULL(CONCAT('(', `names_subgenus`.`name`, ')'),''), ' ', `names_species`.`name`, ' ',
  IFNULL(
    CONCAT(
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
      `names_authors`.`authors_short`,
      IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),', ','), ')
    ), 'No reference given ,'
  ),
  IFNULL(CONCAT('Subfamily: ', `names_subfamily`.`name`), 'Subfamily: ???'),
  IFNULL(CONCAT(', Tribe: ', `names_tribe`.`name`),', Tribe: ???')
) AS 'text'
FROM `names_valid`
 LEFT JOIN `names_authors`   ON `names_valid`.`descriptor_name_id` = `names_authors`.`id`
 LEFT JOIN `names_genera`    ON `names_valid`.`genus_name_id`      = `names_genera`.`id`
 LEFT JOIN `names_species`   ON `names_valid`.`species_name_id`    = `names_species`.`id`
 LEFT JOIN `names_subfamily` ON `names_valid`.`subfamily_name_id`  = `names_subfamily`.`id`
 LEFT JOIN `names_subgenus`  ON `names_valid`.`subgenus_name_id`   = `names_subgenus`.`id`
 LEFT JOIN `names_tribe`     ON `names_valid`.`tribe_name_id`      = `names_tribe`.`id`
 LEFT JOIN `names_subtribe`  ON `names_valid`.`subtribe_name_id`   = `names_subtribe`.`id`
ORDER BY `names_genera`.`name`,  `names_species`.`name` ASC;
";

/**
 * MySQL's updates
 *
 * For altering the database.
 * @global array $MysqlUpdate
 */

$MysqlUpdate = array();

$MysqlUpdate['SubfamilyValid'] = "
UPDATE `names_valid`
SET  `names_valid`.`subfamily_name_id` = ".$_POST['subfamily_id']."
WHERE `names_valid`.`genus_name_id` = ".$_POST['genus_valid_id'].";
";

$MysqlUpdate['Reference'] = "
  UPDATE `names_authors` SET
    `authors_short`   = ".$_POST["authors_short"].",
    `author_filename` = ".$_POST["author_filename"].",
    `author_names`    = ".$_POST["author_names"].",
    `author_mail`     = ".$_POST["author_mail"].",
    `author_address`   = ".$_POST["author_address"].",
    `editor_name`     = ".$_POST["editor_name"].",
    `edition`         = ".$_POST["edition"].",
    `publisher_name`  = ".$_POST["publisher_name"].",
    `title`           = ".$_POST["title"].",
    `journal`         = ".$_POST["journal"].",
    `journal_url`     = ".$_POST["journal_url"].",
    `page`            = ".$_POST["page"].",
    `volume`          = ".$_POST["volume"].",
    `number`          = ".$_POST["number"].",
    `year`            = ".$_POST["year"].",
    `month`           = ".$_POST["month"].",
    `abstract`        = ".$_POST["abstract"].",
    `note`            = ".$_POST["note"].",
    `keywords`        = ".preg_replace("/[\n\r]/"," ",$_POST["keywords"]).",
    `entry_type`      = ".$_POST["entry_type"]."
  WHERE `id` = ".$_POST["id"]." LIMIT 1
";

$MysqlUpdate['ReferenceLiteral']="
UPDATE
(
  SELECT
    `id`,
    SUBSTRING('abcdefghij',if(`virtualExtern`.`howmuch`>1,@startcount:=@startcount+1,@startcount:=0),1)
     AS 'literal'
  FROM (
    SELECT
      @start:=0 ,  @namebefore:=NULL,
      `names_authors`.`id`,
      `names_authors`.`title`,
      @namebefore :=`names_authors`.`authors_short` AS 'tempname',
      `howmuch`
    FROM (
      SELECT
        `authors_short`,
        COUNT(`authors_short`) AS 'howmuch'
      FROM `names_authors`
      GROUP BY `authors_short` ORDER BY `authors_short`,`year`,`title` ASC
    ) AS `virtualIntern`,
    `names_authors`
    WHERE `virtualIntern`.`authors_short` = `names_authors`.`authors_short`
    ORDER BY `names_authors`.`authors_short`, `names_authors`.`year`,`names_authors`.`title` ASC
  ) AS `virtualExtern`
) AS `virtualExternUpdate`, `names_authors`
SET `names_authors`.`literal`=`virtualExternUpdate`.`literal`
WHERE `virtualExternUpdate`.`id` = `names_authors`.`id`;
";

/**
 * MySQL's inserts
 *
 * @global array $MysqlInsert
 */

$MysqlInsert = array();

$MysqlInsert['NewReference'] = "
  INSERT INTO `names_authors` (
    `id`,
    `authors_short`,
    `author_filename`,
    `author_names`,
    `author_mail`,
    `author_address`,
    `editor_name`,
    `edition`,
    `publisher_name`,
    `title`,
    `journal`,
    `journal_url`,
    `page`,
    `volume`,
    `number`,
    `year`,
    `month`,
    `abstract`,
    `note`,
    `keywords`,
    `entry_type`
    )
  VALUES(
    '',
    ".$_POST["authors_short"].",
    '".$author_filename."',
    ".$_POST["author_names"].",
    ".$_POST["author_mail"].",
    ".$_POST["author_address"].",
    ".$_POST["editor_name"].",
    ".$_POST["edition"].",
    ".$_POST["publisher_name"].",
    ".$_POST["title"].",
    ".$_POST["journal"].",
    ".$_POST["journal_url"].",
    ".$_POST["page"].",
    ".$_POST["volume"].",
    ".$_POST["number"].",
    ".$_POST["year"].",
    ".$_POST["month"].",
    ".$_POST["abstract"].",
    ".$_POST["note"].",
    ".$_POST["keywords"].",
    ".$_POST["entry_type"]."
  );
";


/* css alternating colors, not used */
//blue
  $css_alter_light='#E0F0FF';
  $css_alter_dark='#C9E4FF';
//green
  // $css_alter_light='#CCFF99';
  // $css_alter_dark='#B8E68A';
?>