<?php
/**
 * Handle synonyms
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-02-24 21:24:33
 * @license Noncommercial-Share Alike 3.0 Unported
 * @category program tools
 * @todo moving a whole Genus sp.
 * @todo minor issue: document further detailed
 * @package chirokey_pupae
 * @subpackage key
 */
/**
 * Extract current server path relatively
 *
 *
 * {1} means one level up as it replaces
 * any string exept '/' multiple times ('+') ended by '/'. In regular expression
 * language:
 * <code>([^/]+/)</code>
 * The (..) can be used to refere the found string by \\1, \\2 and so on.
 * @global string $currentServerPath
 */
  $currentServerPath = preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);
include($currentServerPath.'structure/session.inc.php');
include($currentServerPath.'structure/functions.php');
include($currentServerPath.'structure/classes/filemanage.php');
include($currentServerPath.'structure/classes/tools.php');
include($currentServerPath.'structure/classes/sql.php');
include($currentServerPath.'structure/config.php');
header('content-type: text/html; charset=utf-8');

$date=date("F j D, Y, g:i a O T");


$content='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>

<head>
  <title>Manage names of specimens</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <link rel="StyleSheet" href="../structure/css/basic.css">
  <script language="JavaScript" src="../structure/js/overlib.js"></script>
  <script language="JavaScript" src="../structure/js/functions.js"></script>
</head>
<body>
<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>
';
// $content.=print_r($_SERVER,true);
$content.="

<div class='info'>
  <ul style='text-align:justify;'>
    <li>If a specimen is named wrongly and you want to rename it, it is better to regard it as a 'synonym' an move it into table `names_synonyms` by using <a href='#ManageSynonyms'>Manage valid specimens <-> synonyms</a> (below) and by adding a note. To update a note for many or all images you can use following SQL-query as template to replace old strings with new one:<br> <span class='typewriter'>
<span style=\"font-weight: bold;color: #000000;\">UPDATE</span><span style=\"color: #000000;\"> `images` </span><span style=\"font-weight: bold;color: #000000;\">SET</span><span style=\"color: #000000;\"> `annote` = </span><span style=\"font-weight: bold;color: #000000;\">REPLACE</span><span style=\"color: #000000;\">(`annote`,</span><span style=\"color: #dd0000;\">'old string'</span><span style=\"color: #000000;\">,</span><span style=\"color: #dd0000;\">'new string'</span><span style=\"color: #000000;\">);</span></span><br>or with any  condition in the <span class='typewriter'><span style=\"font-weight: bold;color: #000000;\">WHERE</span></span>-clause:<br><span class='typewriter'>
<span style=\"font-weight: bold;color: #000000;\">UPDATE</span><span style=\"color: #000000;\"> `images` </span><span style=\"font-weight: bold;color: #000000;\">SET</span><span style=\"color: #000000;\"> `annote` = </span><span style=\"font-weight: bold;color: #000000;\">REPLACE</span><span style=\"color: #000000;\">(`annote`,</span><span style=\"color: #dd0000;\">'old string'</span><span style=\"color: #000000;\">,</span><span style=\"color: #dd0000;\">'new string'</span><span style=\"color: #000000;\">) <span style=\"font-weight: bold;color: #000000;\">WHERE</span> `names_valid_id` = 13;</span></span></li>
  </ul>
</div>";
$content.="
<fieldset id=\"ManageValidSpecies\">
  <legend><h2>Manage <em>valid</em> names of specimens</h2></legend>
  ".($_GET['update']=='names_valid'?"<div class='info'>".$_GET['info']."</div>":"")."
  <p>Here you can add informations to existing valid species or add a new one. A new taxon is also added by uploading an image using <a class=\"menuCHIP\" href=\"upload.php\" target=\"chirokey_pupae\" ><img  style=\"vertical-align : middle;\" src=\"../structure/img/b_upload.png\" width=\"20\" height=\"20\">Images</a>. To add a single name of a genus or species use links below.</p>
  <p>Note that a whole new genus (character) website is internally 'defined' by (1) genus name, (2) species name = 'sp.' (3) subfamily name AND (4) subgenus = NULL i.e. no selection.</p>
  <p>There is also a simple search possible to find database entries, see <a  class='menuCHIP' href='search.php' target='chirokey_pupae' >&nbsp;<img  style='vertical-align : middle;' src='../structure/img/b_find.png' width='20' height='20'>&nbsp;Search</a>.</p>
<form name=\"ManageValidSpecies\" action='http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."#ManageValidSpecies'  method='POST' enctype='multipart/form-data'>
<table cellpadding='5' summary='upload files, select species'>
  <tr>
    <td>";

$objMysql = new db_mysql;//class db_mysql
$objHtml = new html;//class html
# @annotation: fetch taxa: already in DB
  if($result=$objMysql->queryObjectArray($MysqlSelect['AlreadyInDatabaseNamesValid'])){
    foreach($result as $value){
      $Select[$value->value]=$value->text;
      $SelectManageSynonym[$value->valid_id]=$value->valid_name;
      }
    $default=array("NULL" => "-- select a specimen already stored in table 'valid_names' in the database -- ");
    $Select = $default + $Select;
  }
  $default = isset($_POST['genus_already']) ? $Select[$_POST['genus_already']] : '-- select a specimen already sored in database -- ';
  $HTMLelement="
    <SCRIPT LANGUAGE=\"JavaScript1.2\">
    // script to change options
      function changeSelects(str,formName) {
        str=str.split('!');
        for (var i = 0; i < str.length; i++) {
          selectByName=str[i].split('|');
          if(document.getElementsByName(selectByName[1])[0].type=='select-one'){
            var whichIndex = document.getElementsByName(selectByName[1])[0].selectedIndex
            var setTo      = document.getElementsByName(selectByName[1])[0].options[whichIndex].value
            var db         = selectByName[0]
            for (var n = 0; n < document.getElementsByName(selectByName[1])[0].options.length; n++) {
                if(document.getElementsByName(selectByName[1])[0].options[n].value == db){
                  document.getElementsByName(selectByName[1])[0].options[n].selected = true
                }
            }// end for level 2
          }
          else if(document.getElementsByName(selectByName[1])[0].type=='textarea'){
            document.getElementsByName(selectByName[1])[0].value=selectByName[0]
          }
          else if(document.getElementsByName(selectByName[1])[0].type=='text'){
            document.getElementsByName(selectByName[1])[0].value=selectByName[0]
          }
        }// end for level 1
      }// end function changeSelects
    </SCRIPT>
  ";
  $HTMLelement.=$objHtml->select($Select,"genus_already",$default," onchange=\"changeSelects(this.value,'ManageValidSpecies');\" title=\"select a specimen already sored in database\"");
  $selection=$HTMLelement."<br>";
  unset($Select);


# @annotation: fetch taxa: genera
  if($result=$objMysql->queryObjectArray($MysqlSelect['GeneraToIdAll'])){
    foreach($result as $valGenus)
      $Select[$valGenus->id]=$valGenus->name;
    $default=array("NULL" => "-- select genus -- ");
    $Select = $default + $Select;
  }
  $default = isset($_POST['genus_id']) ? $Select[$_POST['genus_id']] : '-- select genus -- ';
  $HTMLelement=$objHtml->select($Select,"genus_id",$default,"style='width:300px;' class='necessary' title='genus name'");
  $selection.=$HTMLelement."&nbsp;or add/modify <a class=\"external\" onmouseover=\"return overlib('Follow this link, select Insert and click menu button »Manage Names« in this key again.');\" onmouseout=\"return nd();\" target=\"_blank\" href=\"http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_genera&goto=tbl_structure.php&back=tbl_structure.php\">genus name...</a><br>";
  unset($Select);

# @annotation: fetch taxa: species
  if($result=$objMysql->queryObjectArray($MysqlSelect['SpeciesIdName'])){
    foreach($result as $valSpecimen)
      $Select[$valSpecimen->id]=$valSpecimen->name;
  }
  $default = array("NULL" => "-- select species -- ");
  $Select  = $default + $Select;
  $default = isset($_POST['species_id']) ? $Select[$_POST['species_id']] : '-- select species -- ';
  $HTMLelement = $objHtml->select($Select,"species_id",$default,"style='width:300px;' class='necessary' title='species name'");
  $selection.=$HTMLelement."&nbsp;or add/modify <a class='external' onmouseover='return overlib(\"Follow this link, select Insert and click menu button »Manage Names« in this key again.\");' onmouseout='return nd();' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_species&goto=tbl_structure.php&back=tbl_structure.php'>species name...</a><br>";unset($Select);
  unset($Select);

# @annotation: fetch taxa: subfamily
  if($result=$objMysql->queryObjectArray($MysqlSelect['SubfamilyNames'])){
    foreach($result as $valSubfamily)
      $Select[$valSubfamily->id]=$valSubfamily->name;
  }
  $default = array("NULL" => "-- select subfamily -- ");
  $Select = $default + $Select;
  $default = isset($_POST['subfamily_id']) ? $Select[$_POST['subfamily_id']] : '-- select subfamily -- ';
  $HTMLelement = $objHtml->select($Select,"subfamily_id",$default,"style='width:300px;' class='necessary' title='subfamily name'");
  $selection.=$HTMLelement."&nbsp;or add/modify <a class='external' onmouseover='return overlib(\"Follow this link, select Insert and click menu button »Manage Names« in this key again.\");' onmouseout='return nd();' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_subfamily&goto=tbl_structure.php&back=tbl_structure.php'>subfamily name...</a><br>";unset($Select);
  unset($Select);

# @annotation: fetch taxa: tribe
  if($result=$objMysql->queryObjectArray($MysqlSelect['TribeNames'])){
    foreach($result as $valTribe)
      $Select[$valTribe->id]=$valTribe->name;
  }
  $default = array("NULL" => "-- select tribe -- ");
  $Select  = $default + $Select;
  $default = isset($_POST['tribe_id']) ? $Select[$_POST['tribe_id']] : '-- select tribe -- ';
  $HTMLelement = $objHtml->select($Select,"tribe_id",$default,"style='width:300px;'  title='tribe name'");
  $selection.=$HTMLelement."&nbsp;or add/modify <a class='external' onmouseover='return overlib(\"Follow this link, select Insert and click menu button »Manage Names« in this key again.\");' onmouseout='return nd();' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_tribe&goto=tbl_structure.php&back=tbl_structure.php'>tribe name...</a><br>";unset($Select);
  unset($Select);

# @annotation: fetch taxa: subtribe
  if($result=$objMysql->queryObjectArray($MysqlSelect['SubtribeNames'])){
    foreach($result as $valSubtribe)
      $Select[$valSubtribe->id]=$valSubtribe->name;
  }
  $default = array("NULL" => "-- select subtribe -- ");
  $Select  = $default + $Select;
  $default = isset($_POST['subtribe_id']) ? $Select[$_POST['subtribe_id']] : '-- select subtribe -- ';
  $HTMLelement = $objHtml->select($Select,"subtribe_id",$default,"style='width:300px;' title='subtribe name'");
  $selection.=$HTMLelement."&nbsp;or add/modify <a class='external' onmouseover='return overlib(\"Follow this link, select Insert and click menu button »Manage Names« in this key again.\");' onmouseout='return nd();' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_subtribe&goto=tbl_structure.php&back=tbl_structure.php'>subtribe name...</a><br>";unset($Select);
  unset($Select);

# @annotation: fetch taxa: subgenus
  if($result=$objMysql->queryObjectArray($MysqlSelect['SubgenusNames'])){
    foreach($result as $valSubgenus)
      $Select[$valSubgenus->id]=$valSubgenus->name;
  }
  $default = array("NULL" => "-- select subgenus -- ");
  $Select  = $default + $Select;
  $default = isset($_POST['subgenus_id']) ? $Select[$_POST['subgenus_id']] : '-- select subgenus -- ';
  $HTMLelement = $objHtml->select($Select,"subgenus_id",$default,"style='width:300px;' title='subgenus name'");
  $selection.=$HTMLelement."&nbsp;or add/modify <a class='external' onmouseover='return overlib(\"Follow this link, select Insert and click menu button »Manage Names« in this key again.\");' onmouseout='return nd();' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_subgenus&goto=tbl_structure.php&back=tbl_structure.php'>subgenus name...</a><br>";unset($Select);

# @annotation: fetch taxa: descriptor
  if($result=$objMysql->queryObjectArray($MysqlSelect['ReferencesReplace'])){
    foreach($result as $valReference)
      $Select[$valReference->id]=$valReference->authors_short;
  }
  $default = array("0" => "-- select descriptor -- ");
  $Select  = $default + $Select;
  $default = isset($_POST['descriptor_id']) ? $Select[$_POST['descriptor_id']] : '-- select descriptor -- ';
    $HTMLelement = $objHtml->select($Select,"descriptor_id",$default,"style='width:300px;' title='first descriptor'");
    // for use ManageSynonyms
    $HTMLauthor          = $objHtml->select($Select,"descriptor_id",$default,"style='width:300px;' title='descriptor of synonym taxon' class='necessary' ");
    array_slice($Select,1);
    $default = array("0" => "^^ select a reference as string for notes ^^");
    $Select  = $default + $Select;
      $HTMLauthorTextarea  = $objHtml->select($Select,"reference_select_string",$default,"style=\"width:300px;\" title=\"reference string for notes\"  onchange=\"javascript:insert('{textciteID|' + this.options[selectedIndex].value+'|'+this.options[selectedIndex].text+'}','','ManageSynonyms','annote');\" ");
// $selection.=$objHtml->select($referenceMenu,"author_id","-- select reference -- ","style=\"margin:0px;border:0px;\" onchange=\"javascript:insert('{citeID|' + this.options[selectedIndex].value+'|'+this.options[selectedIndex].text+'}','','".$_GET['edit']."','textarea');\" title=\"select reference\" ");

    $selection.=$HTMLelement;
  $SelectInBrackets= array("NULL" => "-- brackets? -- ","0" => "no","1" => "yes");
  $default = isset($_POST['in_brackets']) ? $SelectInBrackets[$_POST['in_brackets']] : '-- brackets? -- ';
    // select compares the options not the value
    $HTMLelement = $objHtml->select($SelectInBrackets,"in_brackets",$default,"style='width:150px;' title='descriptor in brackets?'");
    $selection.=$HTMLelement."&nbsp;or add/modify <a target='chirokey_pupae' href='http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir'].$config['ServerKeyDir']."update.php?title=references&amp;refid=new'>reference...</a><br>";
  unset($SelectRef,$Select,$result);

# @annotation morphological structure
  if($result=$objMysql->queryObjectArray($MysqlSelect['MorphoIdShortLong'])){
    foreach($result as $value)
      $Select[$value->morph_short]= $value->morph_long;
  }
  // annote
  $default = isset($_POST['annote']) ? $_POST['annote'] : '';
  $selection.="\n  <textarea name='annote' title='important systematic notes to the specimen' style='width:300px;height:100px;'>".$default."</textarea>&nbsp;Notes<br>\n";
  // $selection.="\n
  $selection.="<input type='text'  name='valid_id' readonly='true' class='disabled' title='valid id'>&nbsp;Valid ID<br>\n";
  $selection.="<input title='save and update table: names_valid' type='submit' value='update/insert' name='update_insert_valid_names'>\n";
 $content.=$selection;
  unset($Select);



/*[genus_id] => 153
    [species_id] => 697
    [subfamily_id] => 1
    [tribe_id] => NULL
    [subtribe_id] => NULL
    [author_name_id_reference] => 20
    [structure_short] => sei*/
# @annotation: save: update valid names
if(isset($_POST['update_insert_valid_names']) &&
   $_POST['genus_id']       !="NULL"  &&
   $_POST['species_id']     !="NULL" &&
   $_POST['subfamily_id']   !="NULL")// end if
{// saving
  # @annotation: save: prepare saving
    $_POST['annote']  = replaceHTMLcode($_POST['annote']);// replace difficult characters for HTML code
    $_POST['annote']  = empty($_POST['annote']) ? 'NULL' : "'".$_POST['annote']."'";
    $subgenus_id_NULL = $_POST['subgenus_id']== 'NULL' ? " IS NULL" : " = ".$_POST['subgenus_id']." ";
# fetch genus name
  $strGenus=$objMysql->querySingleItem("SELECT name FROM names_genera WHERE id = ".$_POST['genus_id'].";");
  $strSpecies=$objMysql->querySingleItem("SELECT name FROM names_species WHERE id = ".$_POST['species_id'].";");
# already in names_valid?
  // -- AND `names_valid`.`subgenus_name_id` ".$subgenus_id_NULL.";
  if($objMysql->querySingleItem("
    SELECT `names_valid`.`id`
    FROM `names_valid`
    WHERE
      `names_valid`.`genus_name_id`     = ".$_POST['genus_id']." AND
      `names_valid`.`species_name_id`   = ".$_POST['species_id']." AND
      `names_valid`.`subfamily_name_id` = ".$_POST['subfamily_id']." ;
      ")==-1
      ){// -1 == no result
      # @annotation: save: INSERT in names_valid
        $objMysql->execute("
        INSERT INTO `names_valid` (
          `id`,
          `genus_name_id`,
          `species_name_id`,
          `descriptor_name_id`,
          `subfamily_name_id`,
          `in_brackets`,
          `tribe_name_id`,
          `subtribe_name_id`,
          `subgenus_name_id`,
          `notes`
          )
        VALUES(
          '',
          ".$_POST['genus_id'].",
          ".$_POST['species_id'].",
          ".$_POST['descriptor_id'].",
          ".$_POST['subfamily_id'].",
          ".$_POST['in_brackets'].",
          ".$_POST['tribe_id'].",
          ".$_POST['subtribe_id'].",
          ".$_POST['subgenus_id'].",
          ".$_POST['annote']."
        );
      ");
        if($valid_id=$objMysql->insertId());
        $messageAction.="+%3Cli%3E%3Cem%3E".$strGenus."+".$strSpecies."%3C%2Fem%3E+was+inserted+in+table+names_valid.%3C/li%3E";
      }// END not in names_valid
      else {// is already in names_valid
      //AND `names_valid`.`subgenus_name_id` ".$subgenus_id_NULL."
        $valid_id=$objMysql->querySingleItem("
        SELECT `names_valid`.`id`
        FROM `names_valid`
        WHERE
          `names_valid`.`genus_name_id` = ".$_POST['genus_id']." AND
          `names_valid`.`species_name_id` = ".$_POST['species_id']."  ;");
          # @annotation: save: UPDATE
            $objMysql->execute("
            UPDATE `names_valid` SET
              `genus_name_id`=".$_POST['genus_id'].",
              `species_name_id`=".$_POST['species_id'].",
              `descriptor_name_id`=".$_POST['descriptor_id'].",
              `subfamily_name_id`=".$_POST['subfamily_id'].",
              `in_brackets`=".$_POST['in_brackets'].",
              `tribe_name_id`=".$_POST['tribe_id'].",
              `subtribe_name_id`=".$_POST['subtribe_id'].",
              `subgenus_name_id`=".$_POST['subgenus_id'].",
              `notes`=".$_POST['annote']."
              WHERE `names_valid`.`id`=".$valid_id."
              LIMIT 1;
          ");
        $messageAction.="+%3Cli%3E %3Cem%3E".$strGenus."+".$strSpecies."%3C%2Fem%3E+updated+in+table+names_valid.%3C/li%3E";
      }// end is in names valid
         //@annotation: save: check if Genus specimen is already in table characters
        if(
          $objMysql->querySingleItem("
          SELECT STRAIGHT_JOIN
            `characters`.`id`
          FROM `names_valid`,`characters`
          WHERE
            `names_valid`.`species_name_id` = ".$_POST['species_id']." AND
            `names_valid`.`genus_name_id`   = ".$_POST['genus_id']." AND
            `names_valid`.`subgenus_name_id` ".$subgenus_id_NULL." AND
            `names_valid`.`id` = `characters`.`names_valid_id`;")==-1){// -1 == no result
          //@annotation: save: INSERT in table characters as genus_info i.e. genus site
          $objMysql->execute("
            INSERT INTO `characters` (
              `id`, `names_valid_id`,`genus_info`)
            VALUES(
                '',    ".$valid_id.",     1);
          ");
          $messageAction.="+%3Cli%3E %3Cem%3E".$strGenus."+".$strSpecies."%3C%2Fem%3E+was+inserted+in+table+characters.%3C/li%3E";
        }// END not in characters
  unset($_POST);// delete POST
  header("Location: http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir'].$config['ServerKeyDir']."synonyms.php?info=%3Col%3E".$messageAction."%3C/ol%3E&update=names_valid#ManageValidSpecies");
  exit;
}//end save
elseif(isset($_POST['update_insert_valid_names'])){
//@annotation: save fails: sth is missing
    $missing.= $_POST['genus_id']=="NULL" ? '<li>select genus name</li>' : '';
    $missing.= $_POST['species_id']=="NULL" ? '<li>select species name</li>' : '';
    $missing.= $_POST['subfamily_id']=="NULL" ? '<li>select subfamily name</li>' : '';
}// END no save sth. is missing
elseif(//@annotation: save synonyms: from id=ManageSynonyms
  isset($_POST['saveSynonym']) &&
  !empty($_POST['annote']) &&
  $_POST['descriptor_id']!='0' &&
  $_POST['valid_id_for_synonym'] != $_POST['synonym_id']
){
    /*
    Array (
      [valid_id_for_synonym] => 1562
      [synonym_id] => 26
      [descriptor_id] => 351
      [annote] =>
      [saveSynonym] => change )
    */
  # fetch genus name
    $strTaxonValid=$objMysql->querySingleItem("
    SELECT
    CONCAT(
      `names_genera`.`name`, ' ',
      `names_species`.`name`, ' ',
        CONCAT(
          IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
          `names_authors`.`authors_short`,
          IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
        )
      )
  FROM `names_valid`
  LEFT JOIN `names_authors` ON `names_valid`.`descriptor_name_id` = `names_authors`.`id`
  LEFT JOIN `names_genera` ON `names_valid`.`genus_name_id` = `names_genera`.`id`
  LEFT JOIN `names_species` ON `names_valid`.`species_name_id` = `names_species`.`id`
  WHERE (`names_valid`.`id` =".$_POST['valid_id_for_synonym'].")
  ;");
    $strTaxonSynonym=$objMysql->querySingleItem("    SELECT
    CONCAT(
      `names_genera`.`name`, ' ',
      `names_species`.`name`, ' ',
        CONCAT(
          IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'','('),
          `names_authors`.`authors_short`,
          IF(STRCMP(IFNULL(`names_valid`.`in_brackets`,''),1),'',')')
        )
      )
  FROM `names_valid`
  LEFT JOIN `names_authors` ON `names_valid`.`descriptor_name_id` = `names_authors`.`id`
  LEFT JOIN `names_genera` ON `names_valid`.`genus_name_id` = `names_genera`.`id`
  LEFT JOIN `names_species` ON `names_valid`.`species_name_id` = `names_species`.`id`
  WHERE (`names_valid`.`id` =".$_POST['synonym_id'].")
");
  # prepare saving
    $_POST['annote']  = htmlentities(replaceHTMLcode($_POST['annote']),ENT_QUOTES,'UTF-8');
    $objMysql->execute("
    INSERT INTO `names_synonyms` (
    `valid_name_id`,
    `genus_name_id`,
    `species_name_id`,
    `subfamily_name_id`,
    `author_name_id`,
    `note`)
    SELECT
     '".$_POST['valid_id_for_synonym']."',
    `genus_name_id`,
    `species_name_id`,
    `subfamily_name_id`,
      -- comment: reference_id was not stored in this example so it has to be given here
    '".$_POST['descriptor_id']."',
      -- comment: some additional Notes
    CONCAT(IFNULL(`notes`,''), ' Technical note: ".$strTaxonSynonym." moved to ".$strTaxonValid."; ".$_POST['annote']."')
    FROM `names_valid`
    WHERE `names_valid`.`id` = ".$_POST['synonym_id']."
    ");
    $messageAction="+%3Cli%3ETaxon+was+inserted+into+table+names_synonyms.%3C/li%3E";
    $objMysql->execute("
    UPDATE `images`
      SET `names_valid_id`= ".$_POST['valid_id_for_synonym'].",
          `annote`=CONCAT(IFNULL(`annote`,''),' ',NOW(),' Technical note: ".$strTaxonSynonym." moved to ".$strTaxonValid."; ".$_POST['annote']."'),
          `time_modified`=NOW()
      WHERE `names_valid_id` = ".$_POST['synonym_id'].";
    ");
    $messageAction.="+%3Cli%3ETable+images+was+updated.%3C/li%3E";
    $objMysql->execute("
    UPDATE `characters`
      SET `names_valid_id`= ".$_POST['valid_id_for_synonym'].",
          `notes` = CONCAT(IFNULL(`notes`,''),' Taxon moved: ".$_POST['annote']." ".$strTaxonSynonym." -> ".$strTaxonValid." (',NOW(),')')
      WHERE `names_valid_id` = ".$_POST['synonym_id'].";
      ");
    $messageAction.="+%3Cli%3ETable+characters+was+updated.%3C/li%3E";
    $objMysql->execute("
    DELETE FROM `names_valid`
      WHERE `names_valid`.`id` = ".$_POST['synonym_id']."
      LIMIT 1;
    ");
    $messageAction.="+%3Cli%3ETaxon+was+deleted+from+table+names_valid.%3C/li%3E";
  unset($_POST);// delete POST
  header("Location: http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir'].$config['ServerKeyDir']."synonyms.php?info=%3Col%3E".$messageAction."%3C/ol%3E+%3Cp%3ECheck+page+of+characters+for+the+valid+specimen+now.+There+is+an+additional++page.%3C/p%3E&update=names_synonyms#ManageSynonyms");
  exit;
  } elseif(isset($_POST['saveSynonym'])){//@annotation: save synonyms fails: sth is missing
    $missing.= $_POST['valid_id_for_synonym']=="NULL" ? '<li>select valid specimen</li>' : '';
    $missing.= $_POST['synonym_id']=="NULL" ? '<li>select synonym specimen</li>' : '';
    $missing.= $_POST['synonym_id']==$_POST['valid_id_for_synonym'] ? '<li>valid specimen and synonym specimen can not be equal!</li>' : '';
    $missing.= $_POST['descriptor_id']=="0" ? '<li>select descriptor name</li>' : '';
    $missing.= empty($_POST['annote']) ? '<li>Write a note! For instance "described as M.hygropetricus = synonym (s. http://www.faunaeur.org/)" or something like that. The note will appear in the onmousover-info</li>' : '';
  }


$content.="
      </td>
    </tr>
  </table>
  </form>
</fieldset>
";
// print all messagees
$message= isset($missing) ? "<div class='error' id='error'>There is something missing or an error: \n  <ul style='text-align:left;'>".$missing."\n  </ul>  <script type='text/javascript'>document.location.hash = '#error'; </script>\n</div>\n" : "";//".print_r($_POST,true)."
$content.=sprintf($message);

// valid specimen
  $default=array("NULL" => "-- select a valid specimen -- ");
  $SelectManageSynonym = $default + $SelectManageSynonym;
  $HTMLvalid=$objHtml->select($SelectManageSynonym,"valid_id_for_synonym",$default,"  title=\"select a valid specimen\" class=\"necessary\" ");

// synonym specimen
  array_slice($SelectManageSynonym,1);# remove 1st entry
  $default=array("NULL" => "-- select the synonym specimen -- ");
  $SelectManageSynonym = $default + $SelectManageSynonym;
  $HTMLsynonym=$objHtml->select($SelectManageSynonym,"synonym_id",$default,"  title=\"select the synonym specimen\" class=\"necessary\" ");
  $default = isset($_POST['annote']) ? $_POST['annote'] : '';

// notes
  $textarea ="\n  <textarea name='annote' class='necessary' title='important systematic notes to the specimen' style='width:300px;height:100px;'>".$default."</textarea>&nbsp;Notes\n";

# @annotation form synonyms
  if($result=$objMysql->queryObjectArray($MysqlSelect['GeneraSynoCounted'])){
    foreach($result as $value)
      $Select[$value->genus_id]=$value->genus_name;
    $default=array("NULL" => "-- select genus -- ");
    $Select = $default + $Select;
  }
  $default = isset($_POST['genus_id']) ? $Select[$_POST['genus_id']] : '-- select genus -- ';
  $HTMLgenus=$objHtml->select($Select,"genus_id",$default,"style='width:300px;' class='necessary' title='genus name'");

  $content.="\n<fieldset style='text-align:justify;' id='ShowSynonyms'>
  <legend><h2>Show synonyms</h2></legend>
    <form name=\"FetchSynonyms\"  action='http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."#ShowSynonyms'  method='POST' enctype='multipart/form-data'>
    <p>
    You might modify/delete data directly in table <a class=\"external\" onmouseover=\"return overlib('Follow this link, select Search/SQL and click menu button «Manage Names» in this key again.');\" onmouseout=\"return nd();\" target=\"_blank\" href=\"http://localhost/".$config['phpmyadminpath']."/sql.php?db=chirokey_pupae&table=names_synonyms&goto=tbl_structure.php&back=tbl_structure.php\">synonym names...</a> or you can use <a  class='menuCHIP' href='search.php' target='chirokey_pupae' >&nbsp;<img  style='vertical-align : middle;' src='../structure/img/b_find.png' width='20' height='20'>&nbsp;Search</a>.
    <p>
    ".$HTMLgenus."
    <input type=\"submit\" name=\"showSynonym\" value=\"fetch (all) synonyms\" title=\"fetch all synonyms\">\n";
    if(isset($_POST['showSynonym'])){
      //@annotation: fetch synonyms
      $addMySQL = $_POST['genus_id'] == 'NULL' ? '' : ' AND `names_valid`.`genus_name_id` = '.$_POST["genus_id"];
      include($currentServerPath.'structure/config.php');
        if($result=$objMysql->queryObjectArray($MysqlSelect['Synonyms'])){
          foreach($result as $value){
            $synonym_author = $value->synonym_author_id == 0 ? "<span class=\"attention\">".$value->synonym_author."</span>" :  "<a href=\"http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir'].$config['ServerKeyDir']."chirokey.php?show=references#refid".$value->synonym_author_id."\" class=\"reference\" target=\"chirokey\">".$value->synonym_author."</a>";
            $valid_author   = $value->valid_author_id   == 0 ? "<span class=\"attention\">".$value->valid_author."</span>" :  "<a href=\"http://".$_SERVER['SERVER_NAME']."/".$config['ServerRootDir'].$config['ServerKeyDir']."chirokey.php?show=references#refid".$value->valid_author_id."\" class=\"reference\" target=\"chirokey\">".$value->valid_author."</a>";
            $synonym_name = "<span class=\"search\" title=\"Click to search &#187;".$value->synonym_name."&#171;\" onclick=\"check=confirm('You clicked on &#187;".$value->synonym_name."&#171;.\\nDo you wish to search this string in a new window?');if (check==false) return false; if (check==true) window.open('http://www.google.com/search?rls=en&amp;q=".str_replace(" ","+",$value->synonym_name)."&amp;ie=utf-8&amp;oe=utf-8');\"><em class='species' >".$value->synonym_name."</em></span>";
            $valid_name   = "<span class=\"search\" title=\"Click to search &#187;".$value->valid_name."&#171;\" onclick=\"check=confirm('You clicked on &#187;".$value->valid_name."&#171;.\\nDo you wish to search this string in a new window?');if (check==false) return false; if (check==true) window.open('http://www.google.com/search?rls=en&amp;q=".str_replace(" ","+",$value->valid_name)."&amp;ie=utf-8&amp;oe=utf-8');\"><em class='species' >".$value->valid_name."</em></span>";
            //edit
            $edit="<a class='nothing' title='modify entry' target='_blank' href='http://localhost/".$config['phpmyadminpath']."/tbl_change.php?db=chirokey_pupae&table=names_synonyms&token=".$_SESSION['PMA_single_signon_token']."&primary_key=+%60names_synonyms%60.%60id%60+%3D+".$value->synonym_id."&sql_query=SELECT+%2A+FROM+%60names_synonyms%60&goto=sql.php'><img src='../structure/img/b_edit.png' width='16' height='16' ></a>";
            // write list
            $list.="\n  <li>\n    ";
            $list.= $edit." ".$synonym_name." ".$synonym_author."  valid as ";
            $list.= $valid_name." ".$valid_author ;
              $note = empty($value->note) ? '' : "<br>Note: ";
            $list.=$note.$value->note."</li>\n";
          }
          if($resultsub=$objMysql->queryObjectArray($MysqlSelect['ReferencesReplace'])){
            foreach($resultsub as $ref){
              $replacetext[$ref->id]=htmlentities($ref->authors_short,ENT_NOQUOTES,'UTF-8');
              //$replacetext[$ref->id]="refid".$ref->id;
            }
          }
          $list= $objHtml->pattern2tag($list);
          $list= $objHtml->emphase($list,$replacetext,"references",false);
        }
      $list=empty($list)? "\n  <li>\n    No synonyms found.</li>\n": $list;
      $content.="<ol>".$list."</ol>";
    }
$content.="\n</form></fieldset>\n";


$content.="\n<fieldset id='ManageSynonyms' style='text-align:justify;'>
  <legend><h2>Manage valid specimens &lt;-&gt; synonyms</h2></legend>
  ".($_GET['update']=='names_synonyms'?"<div class='info'>".$_GET['info']."</div>":"")."
    <form name=\"ManageSynonyms\" action='http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']."#ManageSynonyms'  method='POST' enctype='multipart/form-data'>
    <table class='general'>
      <th colspan=2>Set left specimen as valid for a synonym specimen at right</th>
      <tr>
        <td>valid taxon is:<br>
        ".$HTMLvalid."
        </td>
        <td>synonym taxon is:<br>
        ".$HTMLsynonym."<br>
        ".$HTMLauthor."<br>
        ".$textarea."<br>
        ".$HTMLauthorTextarea."
        <input type=\"submit\" name=\"saveSynonym\" value=\"change\" title=\"save and change\" onclick=\"check=confirm('Do you really want to do this change?\\nThis performs an update of tables `images`, `characters` and deletes the synonym specimen from table `names_valid`.');if (check==false) return false;\" >
        </td>
      </tr>
      <tr>
        <td colspan=2>
          <fieldset class='info' style='text-align:left;'><legend>Info</legend> <p>This performs an update of tables `images`, `characters` and `names_valid`. It moves the synonym taxon from table `names_valid` -> `names_synonyms`. Annotated text like «Psectrotanypus varius (Fabricius 1787) -> Psectrotanypus varipes No reference given (2009-06-28 09:59:42)» will be appended to images (`images`.`annote`) and the Note section of table `characters`.
          </p>
          <p>Moving a whole »Genus sp.« is <em>not yet</em> tested as it means to take care for the whole genus web-page. You might use instead the edit-pencil on the top of the genus page.
          </p>
          </fieldset>
        </td>
      </tr>
    </table>
    </form>
  <div class='slightlyNote'><br><br><br>
  <p>This update script should work as expected. The following scheme illustrates what is happening while updating a specimen as a synonym more detailed. You can alter names in table `names_valid` as you want but this is not recomended as all records in table `names_valid` has to be UNIQUE!</p>
  <ol style='list-style-type : lower-alpha;border-left:1px dotted;'>
    <li>change specimen's name:</li>
    <ol>
       <li>copy specimen's data from `names_valid` -> `names_synonyms` + Reference [+ note].  For instance if the correct valid ID for the synonym in `names_valid`.`id` is <span class='delimiter1'>1638</span> and the old ID is <span class='delimiter2'>736</span> than follow this scheme:<br><pre class='MySQLquery'>
<span class='comment'>-- comment: one query</span>
INSERT INTO names_synonyms <span class='delimiter2'>(</span>
 `valid_name_id`,
 `genus_name_id`,
 `species_name_id`,
 `subfamily_name_id`,
 `author_name_id`,
 `note`<span class='delimiter2'>)</span>
SELECT
 '<span class='delimiter1'>1638</span>', <span class='comment'>-- comment: new valid id</span>
 `genus_name_id`,
 `species_name_id`,
 `subfamily_name_id`,
 <span class='comment'> -- comment: reference_id if `descriptor_name_id` is stored in `names_valid` (i.e. not zero)</span>
 <span class='comment'> -- `descriptor_name_id`,</span>
 '319', <span class='comment'>-- comment: reference_id was not stored in this example so it has to be given here</span>
 CONCAT<span class='delimiter2'>(</span>IFNULL(`notes`,''), ' as synonym see Fauna Europaea and {citeID|20|Schmid 1993}'<span class='delimiter2'>)</span> <span class='comment'>-- comment: some additional Notes</span>
FROM `names_valid`
WHERE `names_valid`.`id` = <span class='delimiter2'>736</span>; <span class='comment'>-- the correct i.e. 'valid' ID </span>
</pre></li>
      <li>renaming the specimen's name:</li>
      <ol style='list-style-type : lower-alpha;'>
        <li>valid specimen exist already in table `names_valid`?</li>
        <ol>
          <li>update table `images`: <pre class='MySQLquery'>
UPDATE `images` SET `names_valid_id`= <span class='delimiter1'>1638</span>
  WHERE `names_valid_id` = <span class='delimiter2'>736</span>; <span class='comment'>-- i.e. old ID</span></pre>
          </li>
          <li>update table `characters`:<pre class='MySQLquery'>
UPDATE `characters` SET `names_valid_id`= <span class='delimiter1'>1638</span>
  WHERE `names_valid_id` = <span class='delimiter2'>736</span>; <span class='comment'>-- i.e. old ID</span></pre>
          </li>
          <li>delete `names_valid`.`id` (old) in `names_valid`:<pre class='MySQLquery'>
DELETE FROM `names_valid`
  WHERE `names_valid`.`id` = <span class='delimiter2'>736</span> <span class='comment'>-- i.e. old ID</span>
  LIMIT 1; <span class='comment'>-- 'safety' delete: only one data set, not more (if exist)</span></pre>
          </li>
        </ol>
        <li>valid specimen does NOT exist in table `names_valid`?</li>
        <ol>
          <li>create a new entry whith selected fields genus, species = 'sp.', subfamily AND subgenus (as not selected, i.e. NULL) see above</li>
          <li>Proceed as 2.a) 1+2+3</li>
        </ol>
      </ol>
    </ol>
    <li>change the whole genus and specimens within:</li>
    <ul>
      <li>similar as above, but beware of the whole genus-website-record in `characters`.`ecology` and `characters`.`notes`. A genus-website-record is 'defined' in table `names_valid` by UNIQUE combination of: `genus_name_id` plus `species_name_id` plus `subgenus_name_id`=NULL. In worst case you have to copy the old data for the genus-website from `characters`.`ecology` and `characters`.`notes` to the new record in table `characters`.</li>
    </ul>
  </ol>
  </div><!-- end gray-->
</fieldset>";

/*
nv -> sy
  1 Genus_Species:
    1 Genus_Species_Copy
      -> INSERT INTO `names_synonyms`: Genus_Species_Copy + Reference [+ note]
    2 Genus_Species_Rename
      1 Genus_Species_Rename does exist in `names_valid`
        -> UPDATE `names_valid`.`id` in `images`, `characters`
        -> DELETE `names_valid`.`id`
      2 Genus_Species_Rename not existing in `names_valid`
        -> UPDATE `names_valid` SET `genus_name_id`, `species_name_id`
*/

$content.="
</body>";
echo $content;
 ?>