<?php
/**
 * Template for the page
 *
 * @author Andreas Plank <andreas.plank@web.de>
 * @version 2009-04-03 14:08:59
 * @license Noncommercial-Share Alike 3.0 Unported
 * @category program tools
 * @package chirokey_pupae
 * @subpackage configuration
 */

  /* head from page <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
  */
$currentServerPath = preg_replace('#(.+/)([^/]+/){1}[^/]+\.php#',"\\1\\3", __FILE__);

/**
 * HTML Page settings
 *
 * @global array $page
 */
$page = array();

/**
 * HTML page head
 *
 * Variables are page title:<code>$title</code>
 * javascript for own (default) functions: <code>$javascript</code>
 * additional (javascript)script: <code>$script</code>
 * link to CSS stylesheet for screen: <code>$link</code>
 * elements for body tag: <code>$page_body</code>
 * @global array $page['head']
 */
  $page['head'] = '
<html>
<head>
<meta http-equiv="content-Type" content="text/html; charset=utf-8">
<title>'.$title.'</title>
  '.$script.'
  <link rel="stylesheet" href="'.$link.'" media="screen" type="text/css">
  <script type="text/javascript" src="../structure/js/overlib.js"></script>
  <script type="text/javascript" '.$javascript.'></script>
  <script type="text/javascript" src="../structure/js/sorttable.js"></script>
  '.$scriptafter.'
</head>
<body '.$page_body.' >
<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>
<!--  page content  -->
<div class="content">
';

/**
 * Moving javascript menu on the right side
 *
 * Needed to use moving javascript menu on the right side with one variable <code>$info</code>
 * Has to be the last to get proper javascript calculations.
 * @global array $page['footbefore']
 * @todo minor issue: javascript menu is not working with explicite given HTML doctype strict
 */
  $page['footbefore']='
<div id="divToc">
  <span class="tocmenu">'.$info.'</span>
  <a href="#toppage">top</a>
</div>';
//   $page['footbefore']="
// <script type='text/javascript' >
// if (!document.layers)
// document.write('<div id=\"divStayTopLeft\" style=\"position:absolute;min-width: 10%\">')
// </script>
//
// <layer id=\"divStayTopLeft\">
//
// <!--EDIT BELOW CODE TO YOUR OWN MENU-->
// <span class='tocmenu'>".$info."</span>
// <a href='#toppage'>top</a>
// <!--END OF EDIT-->
//
// </layer>
//
//
// <script type=\"text/javascript\">
// // does not work with strict css doctypes
// /*
// Floating Menu script-  Roy Whittle (http://www.javascript-fx.com/)
// Script featured on/available at http://www.dynamicdrive.com/
// This notice must stay intact for use
// */
//
// //Enter \"frombottom\" or \"fromtop\"
// var verticalpos=\"fromtop\"
//
// if (!document.layers)
// document.write('</div>')
//
//   var h,w;
//   if (self.innerHeight) // all except Explorer
//   {
//     w = self.innerWidth;
//     h = self.innerHeight;
//   }
//   else if (document.documentElement && document.documentElement.clientHeight)
//     // Explorer 6 Strict Mode
//   {
//     w = document.documentElement.clientWidth;
//     h = document.documentElement.clientHeight;
//   }
//   else if (document.body) // other Explorers
//   {
//     w = document.body.clientWidth;
//     h = document.body.clientHeight;
//   }
//
// function JSFX_FloatTopDiv()
// {
// //   var startX = 3,
// //   startY = 150;
//   var startX = w-130,
//   startY = 5;
//
//   var ns = (navigator.appName.indexOf(\"Netscape\") != -1);
//   var d = document;
//   function ml(id)
//   {
//     var el=d.getElementById?d.getElementById(id):d.all[id]?d.all[id]:d.layers[id];
//     if(d.layers)el.style=el;
//     el.sP=function(x,y){this.style.left=x;this.style.top=y;};
//     el.x = startX;
//     if (verticalpos==\"fromtop\")
//     el.y = startY;
//     else{
//     el.y = ns ? pageYOffset + innerHeight : document.body.scrollTop + document.body.clientHeight;
//     el.y -= startY;
//     }
//     return el;
//   }
//   window.stayTopLeft=function()
//   {
//     if (verticalpos==\"fromtop\"){
//     var pY = ns ? pageYOffset : document.body.scrollTop;
//     ftlObj.y += (pY + startY - ftlObj.y)/8;
//     }
//     else{
//     var pY = ns ? pageYOffset + innerHeight : document.body.scrollTop + document.body.clientHeight;
//     ftlObj.y += (pY - startY - ftlObj.y)/8;
//     }
//     ftlObj.sP(ftlObj.x, ftlObj.y);
//     setTimeout(\"stayTopLeft()\", 10);
//   }
//   ftlObj = ml(\"divStayTopLeft\");
//   stayTopLeft();
// }
// JSFX_FloatTopDiv();
// </script>
// ";

/**
 * HTML foot
 *
 * Real last HTML code of a page.
 * @global array $page['foot']
 */

  $page['foot']="
  </div>
</body>
</html>";

/**
 * "Home" page
 *
 * HTML first default page.
 * @global array $page['first']
 */

  $page['first']= "  <noscript>
    <div style=' text-align : center;color:red;'>This project uses Javascript. Please activate Javascript. Otherwise the key will not work properly.</div>
  </noscript>

  <div style=' text-align : center;'><h3 >CHIP&nbsp;&#8212; Chironomidae Identification Program (Pupae)</h3>
  version ".date('jS M. Y', filemtime($currentServerPath."structure/"))."<br>
  Author: Andreas Plank (andreas dot plank at web dot de)
<br><br><hr><br> “The important thing is not to stop questioning.”<br>Albert Einstein<br><br><br>
“What is our relationship to a flower,<br> to a bird that passes by?<br> And what is our relationship with each other -<br> not with the speaker but with each other - <br>with your wife, <br>with your husband, <br>with your children, <br>with the environment, <br>with your neighbor, <br>your community, <br>the government and so on? <br>What is our relationship to all this? <br>Or are we just isolated, self-concerned, <br>intensely interested in our own way of life?” <br><br>

(Jiddu Krishnamurti: The last talks, p. 28)
<br><br><hr><br><br>

<br><br>License: <br><img src='../structure/img/license.png'><br><a href='http://creativecommons.org/licenses/by-nc-sa/3.0/' class='external' target='_blank' title='Creative Commons Attribution-Noncommercial-Share Alike 3.0 Unported'>Creative Commons Attribution-Noncommercial-Share Alike 3.0 Unported</a><br>
<span class='comment'>You are free: to <strong>Share</strong> — to copy, distribute and transmit the work
to <strong>Remix</strong> — to adapt the work. Under the following conditions:

<strong>Attribution</strong>. You must attribute the work in the manner specified by the author or licensor (but not in any way that suggests that they endorse you or your use of the work).

<strong>Noncommercial</strong>. You may not use this work for commercial purposes.

<strong>Share Alike</strong>. If you alter, transform, or build upon this work, you may distribute the resulting work only under the same or similar license to this one.</span>

<hr>
Suggested citiation something like: A. Plank: CHIP&nbsp;&#8212; Chironomidae Identification Program (Pupae). Interactive PHP-Webserver program to identify larval Chironomidae (Diptera) and to manage related resources. Version ".date('jS M. Y', filemtime($currentServerPath."structure/")).".  http://www.chironomidaeproject.com.<br>

  </div>";

/**
 * Searching for genera names
 *
 * New search engines can be added here by using variable <code>$genus</code>
 * @global array $page['genus_searches']
 */
  $page['genus_searches']="\n
  <a class=\"search\" onmouseover=\"return overlib('New window: Search google images...' ,   WIDTH, 120, OFFSETY, 30, CENTER );\" onmouseout=\"return nd();\"  href=\"http://images.google.com/images?svnum=100&amp;newwindow=1&amp;q=".$genus."&amp;ie=UTF-8&amp;oe=UTF-8&amp;hl=en&amp;btnG=Search\" target=\"_blank\">\n    <img src=\"../structure/img/google_imagesearch.gif\" height=\"20\" border=\"0\">\n  </a>
  <a class=\"search\" onmouseover=\"return overlib('New window: Search google scholar...',   WIDTH, 120, OFFSETY, 30, CENTER );\" onmouseout=\"return nd();\" href=\"http://scholar.google.com/scholar?q=".$genus."&amp;ie=UTF-8&amp;oe=UTF-8&amp;hl=en&amp;btnG=Search\" target=\"_blank\">\n    <img src=\"../structure/img/google_scholarsearch.gif\" height=\"20\" border=\"0\">\n  </a>
  <a class=\"search\" onmouseover=\"return overlib('New window: Search scirus search...' ,   WIDTH, 120, OFFSETY, 30, CENTER );\" onmouseout=\"return nd();\"  href=\"http://www.scirus.com/srsapp/search?q=".$genus."&amp;ds=jnl&amp;ds=web&amp;g=s&amp;t=all\" target=\"_blank\">\n    <img src=\"../structure/img/scirus_search.gif\" height=\"20\" border=\"0\">\n  </a>
  <a class=\"search\" onmouseover=\"return overlib('New window: ixquick meta search...'  ,   WIDTH, 120, OFFSETY, 30, CENTER );\" onmouseout=\"return nd();\" href=\"http://eu.ixquick.com/do/metasearch.pl?cat=web&cmd=process_search&language=english&engine0=v1all&ff=&query=".$genus."\" target=\"_blank\">\n    <img src=\"../structure/img/ixquick_search.gif\" height=\"20\" border=\"0\">\n  </a>
  <a class=\"search\" onmouseover=\"return overlib('New window: Science direct search...',   WIDTH, 120, OFFSETY, 30, CENTER );\" onmouseout=\"return nd();\"   href=\"http://www.sciencedirect.com/science?_ob=QuickSearchURL&_method=submitForm&_acct=C000054205&md5=d7f83b6e67cdd758968256bfc76dc3c3&qs_tak=".$genus."&qs_author=&qs_title=&qs_vol=&qs_issue=&qs_pages=&x=0&y=0\" target=\"_blank\">\n    <img src=\"../structure/img/sciencedirect_search.gif\" height=\"20\" border=\"0\">\n  </a>
  <a class=\"search\" onmouseover=\"return overlib('New window: JSTOR search...'         ,   WIDTH, 120, OFFSETY, 30,CENTER );\" onmouseout=\"return nd();\"   href=\"http://www.jstor.org/action/doBasicSearch?Query=".$genus."&wc=on&dc=All+Disciplines\" target=\"_blank\">\n    <img src=\"../structure/img/jstor_search.gif\" height=\"20\" border=\"0\">\n  </a>
  <a class=\"search\" onmouseover=\"return overlib('New window: Search first description...',WIDTH, 120, OFFSETY, 30, CENTER );\" onmouseout=\"return nd();\" title=\"Nomenclator Zoologicus Vol 1-10 A List Of The Names Of The Genera And Subgenera In Zoology From The Tenth Edition Of Linnaeus 1758 To The End Of 2004\"   href=\"http://www.ubio.org/NZ/search.php?search=".$genus."&authority=&category=Dipt&publication=&year=&comments=&advanced=1&vol=&page=\" target=\"_blank\">\n  <img align='middle' src='../structure/img/book.png' height='20' >\n  </a>

  ";
  $page['count_coordinates']= preg_match("#\bMSIE\b#i",$_SERVER['HTTP_USER_AGENT']) ? "<script type=\"text/javascript\"> alert('You are using Internet Explorer and might not be able to measure coordinates as it cannot write coordinates to the table body. Sorry I have no time to fix it. Use Opera instead.');</script>"  :"";
 $page['count_coordinates'].= "
  <form name='saveScale'>
    <input type='hidden' id=\"scalePixelsHidden\" value=\"\" ><!-- store n-pixels -->
    <input type='hidden' id=\"scaleMicroMeterHidden\" value=\"\" ><!-- store µm -->
  </form>
  <form name=\"Show\" >\n  <div id='measure_img' >\n    <img style='float:left;' onmouseover=\"return overlib('click to measure distances', CENTER, OFFSETY,40);\" onmouseout=\"return nd();\" id='measure' onclick='writepoints();writeInImage();calcsum();' border=1 src='".$strImgSrc."'>
      <table  border=4 ><!-- output measured features -->
      <caption><input class=\"flat\" type=\"button\" value=\"reset\" onclick=\"document.getElementById('outputTbody').innerHTML='';document.getElementById('output').value='';document.getElementById('scalePixelsHidden').value = document.getElementById('scalePixels').value; document.getElementById('scaleMicroMeterHidden').value =document.getElementById('scaleMicroMeter').value ; jg_doc.clear();document.getElementById('scalePixels').value = document.getElementById('scalePixelsHidden').value; document.getElementById('scaleMicroMeter').value = document.getElementById('scaleMicroMeterHidden').value;\"> output measurements</caption>
      <thead>
        <tr>
          <th>equation</th>
          <th colspan=4><input id='calculate' value='' onkeypress=\"return checkEnter();\" onmouseover=\"return overlib('enter valid javascript equations eg:<br>Math.sqrt(5) = &#178;&#8730;5<br>3 * 4 / (6 + 8)<br>Math.pow(2,3) = 2&#094;3', CENTER, OFFSETY,40);\" onmouseout=\"return nd();\"></th>
          <th colspan=2 rowspan=2><input id='scalePixels' value='0' type='text' style='text-align:right;width:60px;'>&nbsp;pixels...<br>...are&nbsp;<input id='scaleMicroMeter' value='0' type='text' style='text-align:right;width:60px;'>&nbsp;µm</th>
        </tr>
        <tr>
          <th><input type=\"button\"  class=\"flat\"  id=\"calculateButton\" value=\"calculate\" onkeypress=\"return checkEnter();\" onclick=\"document.getElementById('calculateOutput').value=eval(document.getElementById('calculate').value);\"></th>
          <th  colspan=4><input id='calculateOutput' value='' type='text' ></th>
        </tr>
        <tr>
          <th>no.</th>
          <th>x-coord</th>
          <th>y-coord</th>
          <th>xy-dist</th>
          <th>dist total</th>
          <th>xy-dist (µm)</th>
          <th>dist total (µm)</th>
        </tr>
      </thead>
      <tbody id='outputTbody'>
      </tbody>
    </table>
    </div><br >
    <div style='clear:none;'></div>
    <input type='hidden' id=\"output\" name=\"output\" value=\"\" ><!-- store xy-coordinates -->
  </form>

    <script type=\"text/javascript\">
    var jg_doc    = new jsGraphics(\"measure_img\"); // draw directly into document

      function getScale(){
        if(document.getElementById(\"scalePixels\").value==0 || document.getElementById(\"scaleMicroMeter\").value==0){
          var scale = 0;
          document.getElementById(\"scalePixelsHidden\").value=0
          document.getElementById(\"scaleMicroMeterHidden\").value=0
          return scale;
        } else {
          var scale = parseInt(document.getElementById(\"scaleMicroMeter\").value)/parseInt(document.getElementById(\"scalePixels\").value);
          document.getElementById(\"scalePixelsHidden\").value = document.getElementById(\"scalePixels\").value;
          document.getElementById(\"scaleMicroMeterHidden\").value = document.getElementById(\"scaleMicroMeter\").value;
          return scale;
        }
      }// end function getScale()

      function writepoints() {//write only, if coordinates are set
        coordinates=document.getElementById(\"output\").value.split('|');
        if(tempX != \"\" || tempX != \"\" ) {
          document.getElementById(\"output\").value+= tempX + ' ' + tempY + '|';
          document.getElementById(\"outputTbody\").innerHTML+= \"\\n      <tr><td style='text-align:right;' id='no\"+coordinates.length+\"'>\"+ coordinates.length +\"</td><td id='x\"+coordinates.length+\"' >\"+ tempX +\"</td><td id='y\"+coordinates.length+\"'>\"+ tempY +\"</td><td id='sumdiff\"+coordinates.length+\"'></td><td id='sum\"+coordinates.length+\"'></td><td id='sumdiffMicroMeter\"+coordinates.length+\"'></td><td id='sumMicroMeter\"+coordinates.length+\"'></td></tr>\";
        }
      }// end function writepoints()

      function calcsum(){
        coordinates=document.getElementById('output').value.split('|');
        numCounts = coordinates.length
        if(numCounts-1 > 1){
          //(x1-x2)^2 + (y1-y2)^2 = dist^2
          x1 = parseInt(document.getElementById('x'+String(numCounts-2)).innerHTML);
          y1 = parseInt(document.getElementById('y'+String(numCounts-2)).innerHTML);
          x2 = parseInt(document.getElementById('x'+String(numCounts-1)).innerHTML);
          y2 = parseInt(document.getElementById('y'+String(numCounts-1)).innerHTML);
          dist = (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2)
          dist=Math.sqrt(dist)
           var scale =  getScale();
          document.getElementById('sumdiff'+String(numCounts-1)).innerHTML=Math.round(dist,2)
          document.getElementById('sumdiffMicroMeter'+String(numCounts-1)).innerHTML = Math.round(dist,2) * scale;
          if(numCounts == 3){
            document.getElementById('sum'+String(numCounts-1)).innerHTML=Math.round(dist,2);
            document.getElementById('sumMicroMeter'+String(numCounts-1)).innerHTML     = Math.round(dist,2) * scale;
          }else{
            document.getElementById('sum'+String(numCounts-1)).innerHTML=parseInt(document.getElementById('sum'+String(numCounts-2)).innerHTML)+Math.round(dist,2)
            document.getElementById('sumMicroMeter'+String(numCounts-1)).innerHTML     = (parseInt(document.getElementById('sum'+String(numCounts-2)).innerHTML)+Math.round(dist,2)) * scale;
          }
        }
      }//end calcsum()


      function writeInImage() {
        //   var coordinates = \"\"
        coordinates =document.getElementById('output').value.split('|');

        function myDrawFunction()
        {
          jg_doc.setColor(\"#af0000\"); // green
          var corr = 6 // corrections to mouse pointer
          // x-cross
            jg_doc.drawLine(tempX-6, tempY-1, tempX-3, tempY-1)
            jg_doc.drawLine(tempX+4, tempY-1, tempX+1, tempY-1)
          // y-cross
            jg_doc.drawLine(tempX-1, tempY-6, tempX-1, tempY-3)
            jg_doc.drawLine(tempX-1, tempY+1, tempX-1, tempY+4)
          // write string
          jg_doc.setFont('verdana','10px',Font.PLAIN);
          jg_doc.drawString(n+1, coord_screen[0]-16, coord_screen[1]-9);
          jg_doc.paint(); // draws, in this case, directly into the document
        }
        n = 0
        c = coordinates.length-1
        while(n < c) {//draw points for all coordinates in <textarea></textarea>
        //   coord_screen=array()
        coord_screen =coordinates[n].split(' ') //split empty spaces
        myDrawFunction();
          n ++// add 1
        }
    }

    //-->
    </script>

    <script language=\"JavaScript1.2\">
    /*
      ============================================================
      Capturing The Mouse Position in IE4-6 & NS4-6
      (C) 2000 www.CodeLifter.com
      Free for all users, but leave in this  header

      Part One:
      Set up a form named \"Show\" with text fields named \"MouseX\"
      and \"MouseY\".  Note in the getMouseXY() function how fields
      are addressed, thus: document.FormName.FieldName.value
    */

      // Detect if the browser is IE or not.
      // If it is not IE, we assume that the browser is NS.
      var IE = document.all?true:false

      // If NS -- that is, !IE -- then set up for mouse capture
      if (!IE) document.captureEvents(Event.MOUSEMOVE)

      // Set-up to use getMouseXY function onMouseMove
      document.onmousemove = getMouseXY;

      // Temporary variables to hold mouse x-y pos.s
      var tempX,tempY,tempOrigX,tempOrigY = 0
      // var tempY = 0

      // Main function to retrieve mouse x-y pos.s
      function getMouseXY(e) {
        if (IE) { // grab the x-y pos.s if browser is IE
          tempX = event.clientX + document.body.scrollLeft
          tempY = event.clientY + document.body.scrollTop
        } else {  // grab the x-y pos.s if browser is NS
          tempX = e.pageX
          tempY = e.pageY
        }
        // catch possible negative values in NS4
        if (tempX < 0){tempX = 0}
        if (tempY < 0){tempY = 0}

        tempOrigX = tempX
        tempOrigY = tempY
          return true
      }

    </script>
    </form>\n";
?>