#!/bin/bash
# $Id: makedoc.sh,v 1.2 2007/12/10 01:11:19 ashnazg Exp $

#/**
#  * makedoc - PHPDocumentor script to save your settings
#  *
#  * Put this file inside your PHP project homedir, edit its variables and run whenever you wants to
#  * re/make your project documentation.
#  *
#  * The version of this file is the version of PHPDocumentor it is compatible.
#  *
#  * It simples run phpdoc with the parameters you set in this file.
#  * NOTE: Do not add spaces after bash variables.
#  *
#  * @copyright         makedoc.sh is part of PHPDocumentor project {@link http://freshmeat.net/projects/phpdocu/} and its LGPL
#  * @author            Roberto Berto <darkelder (inside) users (dot) sourceforge (dot) net>
#  * @version           Release-1.1.0
#  */


##############################
# should be edited
##############################

#/**
#  * title of generated documentation, default is 'Generated Documentation'
#  *
#  * @var               string TITLE
#  */
TITLE="phpMyAdmin programmers documentation"

#/**
#  * name to use for the default package. If not specified, uses 'default'
#  *
#  * @var               string PACKAGES
#  */
PACKAGES="phpMyAdmin"

#/**
#  * name of a directory(s) to parse directory1,directory2
#  * $PWD is the directory where makedoc.sh (?/tmp)
#  *
#  * @var               string PATH_PROJECT
#  */
# PATH_PROJECT=$PWD
PATH_PROJECT=/opt/lampp/htdocs/phpmyadmin2-11-4

#/**
#  * path of PHPDoc executable
#  *
#  * @var               string PATH_PHPDOC
#  */
PATH_PHPDOC=/opt/lampp/htdocs/phpdocumentor/phpdoc

#/**
#  * where documentation will be put
#  *
#  * @var               string PATH_DOCS
#  */
PATH_DOCS=$PATH_PROJECT/doc

#/**
#  * what outputformat to use (html/pdf)
#  *
#  * @var               string OUTPUTFORMAT
#  */
OUTPUTFORMAT=HTML

#/**
#  * converter to be used
#  *
#  * @var               string CONVERTER
#  */
# Smarty|default
CONVERTER=Smarty

#/**
#  * template to use
#  *
#  * @var               string TEMPLATE
#  */
TEMPLATE=default

#/**
#  * parse elements marked as private
#  *
#  * @var               bool (on/off)           PRIVATE
#  */
PRIVATE=on

# Running the command-line in unix
#   -c, --config
#   -cp, --converterparams
#   -ct, --customtags
#   -dh, --hidden
#   -dn, --defaultcategoryname
#   -dn, --defaultpackagename
#   -d, --directory
#   -ed, --examplesdir
#   -f, --filename
#   -i, --ignore
#   -is, --ignoresymlinks
#   -it, --ignore-tags
#   -j, --javadocdesc
#   -o, --output
#   -pp, --parseprivate
#   -po, --packageoutput
#   -p, --pear
#   -q, --quiet
#   -ric, --readmeinstallchangelog
#   -s, --sourcecode
#   -t, --target
#   -tb, --templatebase
#   -ti, --title
#   -ue, --undocumentedelements
# make documentation
"$PATH_PHPDOC" -q -ue -d "$PATH_PROJECT" -t "$PATH_DOCS" -ti "$TITLE" -dn $PACKAGES \
-o 'HTML:default:DOM/earthli' -pp $PRIVATE -i '*test*'
# $OUTPUTFORMAT:$CONVERTER:$TEMPLATE

# 'HTML:default:earthli' # Farbe mit Icons
# 'HTML:default:default'
# 'HTML:default:l0l33t'
# 'HTML:default:phpdoc.de'
# 'HTML:default:DOM/earthli' # mit Baumstruktur
# 'HTML:default:DOM/default' # kein Schnickschack gut lesbar
# 'HTML:default:DOM/l0l33t' # ttfamily auch +/- gut lesbar
# 'HTML:default:DOM/phpdoc.de'
# 'HTML:Smarty:default'
# 'PDF:default:default'
# 'CHM:default:default'

# vim: set expandtab :
