<?php
/* vim: set expandtab sw=4 ts=4 sts=4: */
/**
 * Single signon for phpMyAdmin
 *
 * This is just example how to use single signon with phpMyAdmin, it is
 * not intended to be perfect code and look, only shows how you can
 * integrate this functionality in your application.
 *
 * @version $Id: signon.php 10424 2007-06-07 17:14:21Z lem9 $
 * @package phpMyAdmin
 * @subpacke Example
 */

/* Was data posted? */
if (!empty($_POST)) {
    /* Need to have cookie visible from parent directory */
    session_set_cookie_params(0, '/', '', 0);
    /* Create signon session */
    $session_name = 'SignonSession';
    session_name($session_name);
    session_start();
    /* Store there credentials */
    $_SESSION['PMA_single_signon_user']     = $_POST['user'];
    $_SESSION['PMA_single_signon_password'] = $_POST['password'];
    $_SESSION['PMA_single_signon_host']     = $_POST['host'];
    /* Close that session */
    session_write_close();
    /* Redirect to phpMyAdmin (should use absolute URL here!) */
    header('Location: ../index.php');
} else {
    /* Show simple form */
    header('Content-Type: text/html; charset=utf-8');
    echo '<?xml version="1.0" encoding="utf-8"?>' . "\n";
    ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">
<head>
    <link rel="icon" href="../favicon.ico" type="image/x-icon" />
    <link rel="shortcut icon" href="../favicon.ico" type="image/x-icon" />
    <link rel='StyleSheet' href='../../chip/larvae/structure/css/basic.css'>
    <title>Single signon for phpMyAdmin</title>
<html>
<body>
<div class="content">
  <h1>Single signon for phpMyAdmin3 or Chironomidae Identification Program</h1>
    <p>
    Note: This signon login is used to get some links from the Chironomidae Identification Program (CHIP) working with phpMyAdmin directly, e.g. when modifying synonyms, insert names and so on. If this is your first install of phpMyAdmin and MySQL, the super-user should be 'root' with no password. In phpMyAdmin the password can be set with the menu tab/link <span class="menu"> <img src="../themes/darkblue_orange/img/s_rights.png">&nbsp;Privileges</span> and in the file phpmyadmin3/config.inc.php as well. The CHIP will get its own password (see <a href='../../chip/larvae/doc/readme.html' class='external' target='chirokey'>CHIP documentation (larvae)</a>)
    </p>
  <form action="" method="post">
    <table>
      <tr><td>Username:</td> <td><input type="text" name="user" />                  </td></tr>
      <tr><td>Password:</td> <td><input type="password" name="password" />          </td></tr>
      <tr><td>Host:    </td> <td><input type="text" name="host" value="localhost" /> (will use the one from phpmyadmin3/config.inc.php by default)</td></tr>
      <tr><td></td><td><input type="submit"  /></td></tr>
    <table>
  </form>
</div>
</body>
</html>
<?php
}
?>
